package com.customization.leshanvc;

import com.engine.core.cfg.annotation.CommandDynamicProxy;
import com.engine.core.interceptor.AbstractCommandProxy;
import com.engine.core.interceptor.Command;
import com.engine.kq.biz.KQExitRulesBiz;
import com.engine.kq.cmd.attendanceEvent.GetOutWorkDurationCmd;
import org.apache.commons.lang.StringUtils;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.interfaces.leshanvc.workflow.util.ConvertDurationUtil;

import java.util.Map;

/**
 * @author:dxfeng
 * @createTime: 2023/02/17
 * @version: 1.0
 */
@CommandDynamicProxy(target = GetOutWorkDurationCmd.class, desc = "公出流程时间计算按照半小时为最小单位")
public class HsGetOutWorkDurationCmd extends AbstractCommandProxy<Map<String, Object>> {
    @Override
    public Map<String, Object> execute(Command<Map<String, Object>> targetCommand) {

        String minimumUnit = KQExitRulesBiz.getMinimumUnit();
        Map<String, Object> resultMap = nextExecute(targetCommand);
        // 半小时
        if ("3".equals(minimumUnit)) {
            String duration = Util.null2String(resultMap.get("duration"));
            if (StringUtils.isNotBlank(duration)) {
                try {
                    resultMap.put("duration", ConvertDurationUtil.handelHalfHour(duration));
                } catch (NumberFormatException e) {
                    new BaseBean().writeLog(e);
                }
            }
        }
        return resultMap;
    }
}
