package com.customization.leshanvc;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.engine.core.cfg.annotation.CommandDynamicProxy;
import com.engine.core.interceptor.AbstractCommandProxy;
import com.engine.core.interceptor.Command;
import com.engine.kq.cmd.attendanceEvent.GetOutWorkDurationCmd;
import com.engine.kq.cmd.travelrules.GetTravelRulesFormCmd;

import java.util.List;
import java.util.Map;

/**
 * @author:dxfeng
 * @createTime: 2023/02/17
 * @version: 1.0
 */
@CommandDynamicProxy(target = GetTravelRulesFormCmd.class, desc = "公出流程时间计算按照半小时为最小单位")
public class HsGetTravelRulesFormCmd extends AbstractCommandProxy<Map<String, Object>> {
    @Override
    public Map<String, Object> execute(Command<Map<String, Object>> targetCommand) {
        GetTravelRulesFormCmd getTravelRulesFormCmd = (GetTravelRulesFormCmd) targetCommand;
        Map<String, Object> result = nextExecute(targetCommand);
        List<String> minimumUnit = (List<String>) result.get("exit_minimumUnit");
        minimumUnit.set(2, minimumUnit.get(2).replace("1分钟", "半小时"));
        return result;
    }
}
