package com.engine.cube.cmd.card;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import com.engine.cube.biz.CardHelper;
import com.engine.cube.biz.DataHelper;
import com.engine.cube.entity.CardEntity;
import com.weaver.formmodel.util.DateHelper;
import com.weaver.formmodel.util.StringHelper;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.TimeUtil;
import weaver.general.Util;
import weaver.hrm.User;
import weaver.hrm.company.DepartmentComInfo;
import weaver.hrm.report.schedulediff.HrmScheduleDiffUtil;
import weaver.hrm.resource.ResourceComInfo;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class LayoutFieldAttrExcute extends AbstractCommonCommand<Map<String, Object>> {
    private final DataHelper dataHelper;
    private CardEntity card;

    public LayoutFieldAttrExcute(Map<String, Object> stringObjectMap, User user) {
        this.params = stringObjectMap;
        this.user = user;
        this.dataHelper = new DataHelper(user);
    }

    @Override
    public BizLogContext getLogContext() {
        return null;
    }

    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        Map<String, Object> result = new HashMap<String, Object>();
        JSONObject datas = new JSONObject();
        this.card = CardHelper.initBaseCardEntity(params);
        String triggerStr = Util.null2String(this.params.get("trigger"));
        JSONObject trigger = JSONObject.parseObject(triggerStr);
        if(trigger == null || trigger.isEmpty()) {
            return result;
        }
        RecordSet rs = new RecordSet();
        rs.executeQuery(" select fieldid, attrcontent, caltype, othertype, transtype, datasource" +
                "              from modefieldattr where layoutid = ? and caltype <> '5'  ", card.getLayoutId());
        while(rs.next()) {
            String attrcontent = Util.null2String(rs.getString(2)).trim();
            //attrcontent = attrcontent.replaceAll("\\$currentdate\\$", "\\$date\\$"+ DateHelper.getCurrentDate()+"\\$date\\$");
            attrcontent = attrcontent.replaceAll("\\$currentdept\\$", user.getUserDepartment()+"");
            attrcontent = attrcontent.replaceAll("\\$currentuser\\$", user.getUID()+"");
            attrcontent = attrcontent.replaceAll("\\$billid\\$", Util.null2String(this.card.getBillId()));
            attrcontent = attrcontent.replaceAll("\\$dataid\\$", Util.null2String(this.card.getBillId()));
            attrcontent = attrcontent.replaceAll("\\$modeid\\$", Util.null2String(this.card.getModeId()));
            attrcontent = attrcontent.replaceAll("\\$formid\\$", Util.null2String(this.card.getFormId()));
            Pattern pat = Pattern.compile("\\$([-]?\\d+)\\$");
            Matcher mat = pat.matcher(attrcontent);
            List<String> fields = new ArrayList<String>();
            boolean hasFind = false;
            JSONArray triggerDatas = null;
            while(mat.find()){
                String field = mat.group();
                field = field.replaceAll("\\$", "");
                String fieldStr = "field"+field;
                if(trigger.containsKey(fieldStr)) {
                    hasFind = true;
                    if(triggerDatas==null){
                        triggerDatas = trigger.getJSONArray(fieldStr);
                    }else{
                        triggerDatas.addAll(trigger.getJSONArray(fieldStr));
                    }
                }
            }
            if(hasFind && triggerDatas != null && !triggerDatas.isEmpty()) {
                String caltype = Util.null2String(rs.getString(3));
                String fieldid = "field"+Util.null2String(rs.getString(1)).toLowerCase();
                String datasource = Util.null2String(rs.getString("datasource"));
                if(datasource.isEmpty()) {
                    datasource = null;
                }
                JSONArray tempArr = new JSONArray();
                if(datas.containsKey(caltype)){
                	tempArr = (JSONArray) datas.get(caltype);
                }
                int othretype = Util.getIntValue(rs.getString(4));
                if("1".equals(caltype)||"0".equals(caltype)) {
                	tempArr.addAll(this.doFieldSql(fieldid, attrcontent, triggerDatas, datasource));
                } else if("2".equals(caltype)) {
                	tempArr.addAll(this.doFieldMath(fieldid, attrcontent, triggerDatas));
                } else if("3".equals(caltype)) {
                	tempArr.addAll(this.doDateTimeCal(fieldid, attrcontent, triggerDatas, othretype ));
                } else {
                	tempArr.addAll(this.doOtherAttr(fieldid, attrcontent, triggerDatas));
                }
                datas.put(caltype, tempArr);
            }
        }
        result.put("datas", datas);
        return result;
    }
    private JSONArray doOtherAttr(String fieldid, String attrcontent, JSONArray triggerDatas){
        JSONArray result = new JSONArray();

        int size = triggerDatas.size();
        for(int i = 0; i<size; i++) {
            String attrcontentTmp = attrcontent;
            JSONObject data = new JSONObject();
            JSONObject triggerData = triggerDatas.getJSONObject(i);
            if (triggerData != null && !triggerData.isEmpty()) {
                Pattern pat = Pattern.compile("\\$([-]?\\d+)\\$");
                Matcher mat1 = pat.matcher(attrcontent);
                while (mat1.find()) {
                    try {
                        String field = mat1.group();
                        String fid = field.replaceAll("\\$", "");
                        attrcontentTmp = attrcontentTmp.replaceAll("\\$"+fid+"\\$",Util.null2String(triggerData.getString("field"+fid)));
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
                dataHelper.addValue(data, fieldid, attrcontentTmp);
                dataHelper.dealData(data, new String[]{fieldid});
            }
            if (triggerData.containsKey("index")) {
                data.put("index", triggerData.get("index"));
            }
            result.add(data);
        }
        return result;
    }
    private JSONArray doFieldSql(String fieldid, String attrcontent, JSONArray triggerDatas, String datasource) {
        JSONArray result = new JSONArray();
        attrcontent = attrcontent.replaceAll("\\$currentdate\\$",  DateHelper.getCurrentDate());
        String execSql = attrcontent;
        int index = execSql.indexOf("doFieldSQL(\"");
        if (index < 0 || execSql.toUpperCase().indexOf("INSERT") > -1 || execSql.toUpperCase().indexOf("UPDATE") > -1
                || execSql.toUpperCase().indexOf("DROP") > -1 || execSql.toUpperCase().indexOf("TRUNCATE") > -1
                || execSql.toUpperCase().indexOf("DELETE") > -1 || execSql.toUpperCase().indexOf("EXEC") > -1
                || execSql.toUpperCase().indexOf("CALL") > -1 ){
            return result;
        }
        execSql = execSql.substring(index + 12);
        index = execSql.lastIndexOf("\")");
        if (index > -1) {
            execSql = execSql.substring(0, index);
            execSql = execSql.trim();
        }

        Pattern pat = Pattern.compile("\\$([-]?\\d+)\\$");
        Matcher mat = pat.matcher(attrcontent);
        List<String> paramNames = new ArrayList<String>();
        List<String> fieldArr = new ArrayList<String>();
        while(mat.find()){
            try{
                String field = mat.group();
                String fid = field.replaceAll("\\$", "");
                paramNames.add("field"+fid);
                fieldArr.add(field);
                //execSql = Util.replaceString(execSql, field, " ? ");
                //execSql = execSql.replaceAll( "\\$"+fid+"\\$", " ? ");
            }catch(Exception e){
                e.printStackTrace();
            }
        }

        RecordSet rs = new RecordSet();

        int size = triggerDatas.size();
        for(int i = 0; i<size; i++) {
        	String tempexecSql=execSql;
            JSONObject data = new JSONObject();
            JSONObject triggerData = triggerDatas.getJSONObject(i);
            if(triggerData != null && !triggerData.isEmpty()) {
                int size2 = paramNames.size();
                for(int j = 0; j<size2; j++) {
                	String field = fieldArr.get(j);
                    try {
                        System.out.println(triggerData.getString(paramNames.get(j)));
                    	tempexecSql = tempexecSql.replace(field, triggerData.getString(paramNames.get(j)));
                    }catch(Exception e){

                    }
                }

               /* tempexecSql  = " select zs from uf_glzd_cp  where id = '1' and dxwb = '1' ";*/

                if(datasource==null||StringHelper.isEmpty(datasource)){
                    rs.executeSql(tempexecSql);
                }else{
                    rs.executeSql(tempexecSql, datasource);
                }
                String[] cols = rs.getColumnName();
                while(rs.next()) {
                    if(cols.length > 1){
                        dataHelper.addValue(data, fieldid, rs.getString(2));
                    } else {
                        dataHelper.addValue(data, fieldid, rs.getString(1));
                    }
                }
                    dataHelper.dealData(data, new String[]{fieldid});
                
            }
            //if(data.isEmpty()) {
            //    data.put(fieldid, "");
            //}
            if(triggerData.containsKey("index")) {
                data.put("index", triggerData.get("index"));
            }
            result.add(data);
        }
        return result;
    }
    private JSONArray doDateTimeCal(String fieldid, String attrcontent, JSONArray triggerDatas, int othertype) {
        JSONArray result = new JSONArray();
        int size = triggerDatas.size();
        for(int i=0;i<size; i++) {
            JSONObject triggerData =  triggerDatas.getJSONObject(i);
            if(triggerData != null && !triggerData.isEmpty()) {
                JSONObject data = this.doDateTimeCal(fieldid, attrcontent,triggerData, othertype);
                dataHelper.dealData(data, new String[]{fieldid});
                if(triggerData.containsKey("index")) {
                    data.put("index", triggerData.get("index"));
                }
                result.add(data);
            }
        }
        return result;
    }
    private JSONObject doDateTimeCal(String fieldid, String attrcontent, JSONObject triggerData, int othertype){
        String datecontent_tmp = attrcontent;
        String retDateContent = "";
        int index = datecontent_tmp.indexOf("$");
        String fieldType = dataHelper.getFieldType(fieldid);
        while (index > -1) {
            int index0 = datecontent_tmp.indexOf("$", index + 1);
            String field1 = datecontent_tmp.substring(index + 1, index0);
            String mark_t = datecontent_tmp.substring(0, index).trim();
            if ("+".equals(mark_t)) {
                retDateContent += ("+");
            } else if ("-".equals(mark_t)) {
                retDateContent += ("-");
            }

            if (("datetime").equals(field1)) {
                retDateContent += "$datetime$";
            } else if ("currentdate".equals(field1)) {
                retDateContent += "$date$"+ DateHelper.getCurrentDate()+"$date$";
            } else if ("currentdatetime".equals(field1)) {
                retDateContent += "$currentdatetime$"+ DateHelper.getCurDateTime()+"$currentdatetime$";
            } else {
                String fieldtypeStr = "";
                String htmltype = dataHelper.getFieldHtmlType("field"+field1);
                String detailtype = dataHelper.getFieldType("field"+field1);

                boolean isdate = "3".equals(htmltype)&&"2".equals(detailtype);
                boolean istime = "3".equals(htmltype)&&"19".equals(detailtype);
                boolean isinput = !isdate&&!istime;
                if (isinput == true) {
                    fieldtypeStr = "$input$";
                } else if (isdate == true) {
                    fieldtypeStr = "$date$";
                } else if (istime == true) {
                    fieldtypeStr = "$time$";
                }


                retDateContent += (fieldtypeStr + triggerData.getString("field"+field1) + fieldtypeStr) ;
            }
            datecontent_tmp = datecontent_tmp.substring(index0 + 1);
            index = datecontent_tmp.indexOf("$");
        }

        // 最后结尾如果有数据，要特殊处理
        String[] tailStr = datecontent_tmp.split("");
        Pattern pa = Pattern.compile("\\d{1}");
        if (tailStr != null) {
            int ishead = -1;
            for (int j = 0; j < tailStr.length; j++) {
                String s = tailStr[j].trim();
                Matcher matcher = pa.matcher(s);
                if ("+".equals(s)) {
                    if (ishead == 0) {
                        retDateContent += "$input$";
                    }
                    retDateContent += ("+");
                    ishead = 1;
                } else if ("-".equals(s)) {
                    if (ishead == 0) {
                        retDateContent += "$input$";
                    }
                    retDateContent += ("-");
                    ishead = 1;
                } else if (matcher.find()) {
                    if (ishead == 1) {
                        retDateContent += ("$input$" + s);
                        ishead = 0;
                    } else {
                        retDateContent += s;
                    }
                }
            }
            if (ishead == 0) {
                retDateContent += "$input$\"";
            }
        }

        String datecontent = retDateContent;

        String key = "";
        String fromdate = "";
        String fromtime = "";
        String todate = "";
        String totime = "";
        String tempCalStr = "";
        int inputDate = -1;
        int setDataCx = 0;//赋值次数
        String tempDateTime = "";
        double tempDouble = 0;
        boolean isDateTimeCal = false;
        int index0 = datecontent.indexOf("$");

        while(index0 > -1){
            String calStr = "";
            int index1 = datecontent.indexOf("$", index0+1);
            String espStr = datecontent.substring(index0+1, index1);//数据类型标识。date日期、time时间、input数字
            datecontent = datecontent.substring(index1+1);
            if("datetime".equals(espStr)){
                //datecontent = datecontent.substring(index1+espStr.length()+1);
                isDateTimeCal = true;
            }else{
                int index2 = datecontent.indexOf("$"+espStr+"$");//找这个标签的下一次出现的地方
                String data0 = datecontent.substring(0, index2);//标识中的值
                if("date".equalsIgnoreCase(espStr)){
                    if("".equals(fromdate)){
                        fromdate = data0;
                        setDataCx += 1;
                    }else{
                        todate = data0;
                        if(isDateTimeCal == false){
                            setDataCx += 2;
                        }
                    }
                }else if("time".equalsIgnoreCase(espStr)){
                    if("".equals(fromtime)){
                        fromtime = data0;
                    }else{
                        totime = data0;
                        if(isDateTimeCal == true){
                            setDataCx += 2;
                        }
                    }
                }else if("currentdatetime".equalsIgnoreCase(espStr)){
                	String[] split = data0.split(" ");
                	if (split.length==2) {
                		 if("".equals(fromdate)){
                             fromdate = split[0];
                             fromtime=split[1];
                             setDataCx += 1;
                         }else{
                             todate = split[0];
                             totime=split[1];
                             if(isDateTimeCal == true){
                                 setDataCx += 2;
                             }
                         }
					}
                }else if("input".equalsIgnoreCase(espStr)){
                    inputDate = Util.getIntValue(data0, 0);
                    setDataCx += 5;
                }
                try{
                    if(setDataCx==3 || setDataCx==6 || setDataCx==5){//3：日期[合并时间]与日期[合并时间]计算；6：日期[合并]时间与数字计算；5：做过日期计算又做与数字的计算
                        if(setDataCx == 3){
                            tempDouble = Util.getDoubleValue(getDateTimeCal(fromdate, fromtime, todate, totime, isDateTimeCal, othertype, tempCalStr));
                            key = ""+tempDouble;
                            /*if(tempDouble<0){
                            	key = null;
                            }*/
                            inputDate = Util.getIntValue(key);
                            fromdate = "";
                            fromtime = "";
                            todate = "";
                            todate = "";
                        }else if(setDataCx == 6){
                            tempDateTime = getDateTimeInputCal(fromdate, fromtime, inputDate, isDateTimeCal, othertype, tempCalStr);
                            key = tempDateTime;
                        }else if(setDataCx == 5){
                            if("+".equalsIgnoreCase(tempCalStr)){
                                tempDouble = tempDouble + inputDate;
                            }else{
                                tempDouble = tempDouble - inputDate;
                            }
                            key = ""+tempDouble;
                        }
                        setDataCx = 0;
                    }
                }catch(Exception e){
                    e.printStackTrace();
                    setDataCx = 0;
                }
                int index3 = datecontent.indexOf("$", index2+espStr.length()+2);//
                if(index3 > -1){
                    calStr = datecontent.substring(index2+espStr.length()+2, index3);
                    if(!"".equals(calStr.trim())){
                        tempCalStr = calStr;
                    }
                }
                datecontent = datecontent.substring(index2+espStr.length()+2);
            }
            index0 = datecontent.indexOf("$");
        }
        JSONObject result = new JSONObject();
        result.put(fieldid, key);
        return result;
    }
    /**
         * 日期[合并时间]字段与数字的计算，返回日期[合并]时间
         * isDateTimeCal：石否合并日期时间
         * othertype：0：不排除非工作日（自然日期计算），使用总部一般工作时间；1：排除非工作日。
         * tempCalStr：加法还是减法。默认为加法
         */
    public String getDateTimeInputCal(String fromdate, String fromtime, int inputData, boolean isDateTimeCal, int othertype, String tempCalStr){
        String retStr = "";
        if("".equals(fromdate)){
            return retStr;
        }
        try{
            if(inputData==0 && isDateTimeCal==true){
                retStr = fromdate + " " + fromtime;
                return retStr;
            }
            if("-".equals(tempCalStr)){
                inputData = inputData * (-1);
                tempCalStr = "+";
            }
            if((inputData==1 || inputData==0) && isDateTimeCal==false){
                retStr = fromdate;
                return retStr;
            }
            if(inputData >= 0){
                inputData = inputData - 1;
            }else{
                inputData = inputData;
            }
            if("".equals(fromtime)){
                isDateTimeCal = false;
            }
            if(othertype == 0){
                if(isDateTimeCal == false){
                    retStr = TimeUtil.dateAdd(fromdate, inputData);
                }else{
                    retStr = TimeUtil.timeAdd(fromdate+" "+((fromtime + ":00").substring(0, 8)), inputData*24*3600);
                }
            }else{
                //如果考虑排除工作日，时间暂时无法参与计算
                int addtype = 0;
                if("-".equals(tempCalStr)){
                    addtype = 0;
                }else{
                    addtype = 1;
                }
                if(inputData<0){
                    inputData = inputData * (-1);
                    if(addtype == 1){
                        addtype = 0;
                    }else{
                        addtype = 1;
                        //inputData = inputData * (-1);
                    }
                }
                retStr = getNextWorkDate(fromdate, inputData, user, addtype);//无法获取人员信息，当前操作者未必就是正确的分部，所以用总部的
                if(isDateTimeCal == true){
                    retStr = retStr + " " + fromtime;
                }
            }
        }catch(Exception e){
            new BaseBean().writeLog(e);
        }
        return retStr;
    }
    /**
	 * 通过日期，分部，天数，返回指定天数后（前）的日期，排除工作日
	 * addtype：1，days天数之后；0，days天数之前
	 */
    public String getNextWorkDate(String fromdate, int days, User user, int addtype){
        String retStr = "";
        try{
            //writeLog("fromdate = " + fromdate);
            //writeLog("days = " + days);
            //writeLog("addtype = " + addtype);
            HrmScheduleDiffUtil hrmScheduleDiffUtil = new HrmScheduleDiffUtil();
            hrmScheduleDiffUtil.setUser(user);
            String nextDate_t = fromdate;
            int day0 = 1;
            if(addtype == 1){
                day0 = 1;
            }else{
                day0 = -1;
            }
            int index = 0;
            for(int cx=0; cx<days; ){
                    //writeLog("cx = " + cx);
                    nextDate_t = TimeUtil.dateAdd(nextDate_t, day0);
                    boolean isworkday = hrmScheduleDiffUtil.getIsWorkday(nextDate_t);
                    index++;
                    if(index>100&&index>2*days){
                        index=-1;
                        break;
                    }
                    if(isworkday == true){
                        retStr = nextDate_t;
                        cx++;
                    }
            }
            if(index==-1){
                retStr = fromdate;
            }
        }catch(Exception e){
            new BaseBean().writeLog(e);
        }
        //writeLog("retStr = " + retStr);
        return retStr;
    }
    /**
     ** 日期[合并时间]字段之间的计算，结果为float数据，换成String返回
     * isDateTimeCal：石否合并日期时间
     * othertype：0：不排除非工作日（自然日期计算），使用总部一般工作时间；1：排除非工作日。
     * tempCalStr：加法还是减法。默认为减法（设置加法的去面壁）
     */
    private String getDateTimeCal(String fromdate, String fromtime, String todate, String totime, boolean isDateTimeCal, int othertype, String tempCalStr){

        String retStr = "";
        if("".equals(fromdate) || "".equals(todate)){
            return retStr;
        }
        try{
            if("-".equals(tempCalStr)){
                if("".equals(fromtime) || "".equals(totime)){
                    isDateTimeCal = false;
                }else{
                    fromtime = (fromtime + ":00").substring(0, 8);
                    totime = (totime + ":00").substring(0, 8);
                }
                if(othertype == 0){
                    if(isDateTimeCal == true){
                        //做减法，要把数据倒过来
                        if(TimeUtil.timeInterval(todate+" "+totime, fromdate +" "+ fromtime) >= (long)0){
                            retStr = ""+(Util.getDoubleValue((""+TimeUtil.timeInterval(todate+" "+totime, fromdate +" "+ fromtime)))/3600/24);
                        }else{
                            retStr = ""+(Util.getDoubleValue((""+TimeUtil.timeInterval(todate+" "+totime, fromdate +" "+ fromtime)))/3600/24);
                        }
                    }else{
                        if(TimeUtil.dateInterval(todate, fromdate) >= (long)0){
                            retStr = ""+(TimeUtil.dateInterval(todate, fromdate) + 1);
                        }else{
                            retStr = ""+(TimeUtil.dateInterval(todate, fromdate));
                        }
                    }
                }else{
                    HrmScheduleDiffUtil hrmScheduleDiffUtil = new HrmScheduleDiffUtil();
                    hrmScheduleDiffUtil.setUser(user);
                    ResourceComInfo resourceComInfo = new ResourceComInfo();
                    DepartmentComInfo departmentComInfo = new DepartmentComInfo();
                    int departmentId = Util.getIntValue(resourceComInfo.getDepartmentID(""+user.getUID()));
                    int subCompanyId = Util.getIntValue(departmentComInfo.getSubcompanyid1(""+departmentId));
                    //做减法，要把数据倒过来
                    long firstCal = 0;
                    if(isDateTimeCal == true){
                        firstCal = TimeUtil.timeInterval(todate+" "+totime, fromdate+" "+fromtime);//前小后大返回大于0的数
                    }else{
                        firstCal = TimeUtil.dateInterval(todate, fromdate);
                    }
                    //下面的那个方法，必须前面参数的日期在后面参数的日期之前，比如，2012-02-01---2012-03-01，得到的值大于0
                    if(totime.length() == 8){
                        totime = totime.substring(0, 5);
                    }
                    if(fromtime.length() == 8){
                        fromtime = fromtime.substring(0, 5);
                    }
                    if(firstCal >= (long)0){
                        String a = hrmScheduleDiffUtil.getTotalWorkingDays(todate, totime, fromdate, fromtime, subCompanyId);
                        if(!"".equals(a)){
                            a = ""+(Util.getFloatValue(a));
                        }else{
                            a = ""+0;
                        }
                        retStr = a;
                    }else{
                        String b = hrmScheduleDiffUtil.getTotalWorkingDays(fromdate, fromtime, todate, totime, subCompanyId);
                        if(!"".equals(totime)){
                            b = ""+(Util.getFloatValue(b));
                        }else{
                            b = ""+(Util.getFloatValue(b) - 1);
                        }
                        retStr = "-" + b;
                    }
                }
            }else{
            }
            if(!"".equals(retStr) && retStr.indexOf(".")>-1){
                //处理一分钟的特殊情况
                if(retStr.equals("6.944444444444445E-4")){
                    retStr = "0.001388888888888889";
                }
                retStr = retStr + "00000";
                retStr = retStr.substring(0, retStr.indexOf(".")+5);
            }
        }catch(Exception e){
            new BaseBean().writeLog(e);
        }
        return retStr;
    }
    private JSONArray doFieldMath(String fieldid, String attrcontent, JSONArray triggerDatas){
        JSONArray result = new JSONArray();
        Pattern pat = Pattern.compile("\\$([-]?\\d+)\\$");
        int index = attrcontent.indexOf("doFieldMath(\"");
        String attrcontentTemp=null;
        if (index > -1) {
            attrcontentTemp = attrcontent.substring(index + 13);
            index = attrcontentTemp.lastIndexOf("\")");
            if (index > -1) {
                attrcontentTemp = attrcontentTemp.substring(0, index);
            }

            int size = triggerDatas.size();
            for(int i = 0; i<size; i++) {
                JSONObject data = triggerDatas.getJSONObject(i);
                JSONObject rtData = new JSONObject();
                if(data == null || data.isEmpty()) {
                    continue;
                }

                String calc = attrcontentTemp;
                Matcher mat = pat.matcher(calc);
                while(mat.find()) {
                    String field = mat.group();
                    String fieldidStr = field.replaceAll("\\$", "");
                    double value=0.0;
                    if(null!=data.getString("field"+fieldidStr)){
                        value = Util.getDoubleValue(data.getString("field"+fieldidStr).replaceAll(",",""), 0);
                    }
                    calc = calc.replaceAll("\\$"+fieldidStr+"\\$", "("+value+")" );
                }
                rtData.put(fieldid, calc);
                if(data.containsKey("index")) {
                    rtData.put("index", data.get("index"));
                }
                result.add(rtData);
            }
        }
        return result;
    }
}