package com.engine.hsCheck.cmd;

import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import org.apache.commons.lang3.StringUtils;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;

import java.util.HashMap;
import java.util.Map;

public class CheckCmd extends AbstractCommonCommand<Map<String, Object>> {

    public CheckCmd(Map<String, Object> params) {
        this.params = params;
    }

    @Override
    public BizLogContext getLogContext() {
        return null;
    }

    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        RecordSet rs = new RecordSet();
        BaseBean bb = new BaseBean();
        Map<String, Object> apimap = new HashMap<String, Object>();
        try {
            String workflowId = Util.null2String(params.get("workflowId"));
            String resourceId = Util.null2String(params.get("resourceId"));
            String fromDate = Util.null2String(params.get("fromDate"));
            String fromTime = Util.null2String(params.get("fromTime"));
            String toDate = Util.null2String(params.get("toDate"));
            String toTime = Util.null2String(params.get("toTime"));

            String st = fromDate + " " + fromTime;
            String ed = toDate + " " + toTime;
            int _tmpRq = 0;
            String msg = "";

            if ("105".equals(workflowId)) {
                rs.execute("select wr.requestid,wr.requestname from formtable_main_20_dt1 a,formtable_main_20 b ,workflow_requestbase wr  " +
                        "where b.requestId =wr.REQUESTID and b.id=a.mainid and a.resourceId=" + resourceId + "   and wr.CURRENTNODETYPE >0 and " +
                        " ((CONCAT(fromDate ,' ',fromTime) < '" + st + "' and  '" + st + "' <  CONCAT(toDate ,' ',toTime) ) or (CONCAT(fromDate ,' ',fromTime) < '" + ed + "' and  '"+ed+"' <  CONCAT(toDate ,' ',toTime)) or (CONCAT(fromDate ,' ',fromTime) > '" + st + "' and  '"+ed+"' >  CONCAT(toDate ,' ',toTime)) )" +
                        "  " +
                        " ");
                bb.writeLog("select wr.requestid,wr.requestname from formtable_main_20_dt1 a,formtable_main_20 b ,workflow_requestbase wr  " +
                        "where b.requestId =wr.REQUESTID and b.id=a.mainid and a.resourceId=" + resourceId + "   and wr.CURRENTNODETYPE >0 and " +
                        " ((CONCAT(fromDate ,' ',fromTime) < '" + st + "' and  '" + st + "' <  CONCAT(toDate ,' ',toTime) ) or (CONCAT(fromDate ,' ',fromTime) < '" + ed + "' and  '"+ed+"' <  CONCAT(toDate ,' ',toTime)) or (CONCAT(fromDate ,' ',fromTime) > '" + st + "' and  '"+ed+"' >  CONCAT(toDate ,' ',toTime)))" +
                        "  " +
                        " ");
                rs.next();
                String reqid = rs.getString("requestid");
                _tmpRq = Util.getIntValue(reqid);
                msg = Util.null2String(rs.getString("requestname"));
                if(StringUtils.isNotBlank(reqid)){
                    boolean checkBack = checkLeaveBack(reqid,st,ed);
                    if(!checkBack){
                        _tmpRq = 0;
                    }
                }
            }else if("50".equals(workflowId)){
                rs.execute("select wr.requestid,wr.requestname from  formtable_main_74 b ,workflow_requestbase wr  " +
                        "where b.requestId =wr.REQUESTID  and b.resourceId=" + resourceId + "   and wr.CURRENTNODETYPE >0 and " +
                        " ((CONCAT(fromDate ,' ',fromTime) < '" + st + "' and  '" + st + "' <  CONCAT(toDate ,' ',toTime) ) or (CONCAT(fromDate ,' ',fromTime) < '" + ed + "' and  '"+ed+"' <  CONCAT(toDate ,' ',toTime)) or (CONCAT(fromDate ,' ',fromTime) > '" + st + "' and  '"+ed+"' >  CONCAT(toDate ,' ',toTime)) )" +
                        "  " +
                        " ");
                bb.writeLog("select wr.requestid,wr.requestname from  formtable_main_74 b ,workflow_requestbase wr  " +
                        "where b.requestId =wr.REQUESTID  and b.resourceId=" + resourceId + "   and wr.CURRENTNODETYPE >0 and " +
                        " ((CONCAT(fromDate ,' ',fromTime) < '" + st + "' and  '" + st + "' <  CONCAT(toDate ,' ',toTime) ) or (CONCAT(fromDate ,' ',fromTime) < '" + ed + "' and  '"+ed+"' <  CONCAT(toDate ,' ',toTime)) or (CONCAT(fromDate ,' ',fromTime) > '" + st + "' and  '"+ed+"' >  CONCAT(toDate ,' ',toTime)) )" +
                        "  " +
                        " ");
                rs.next();
                String reqid = rs.getString("requestid");
                _tmpRq = Util.getIntValue(reqid);
                msg = Util.null2String(rs.getString("requestname"));
                if(StringUtils.isNotBlank(reqid)){
                    boolean checkBack = checkLeaveBack(reqid,st,ed);
                    if(!checkBack){
                        _tmpRq = 0;
                    }
                }
            }else if("75".equals(workflowId)) {
                rs.execute("select wr.requestid,wr.requestname from formtable_main_76_dt1 a,formtable_main_76 b ,workflow_requestbase wr  " +
                        "where b.requestId =wr.REQUESTID and b.id=a.mainid and a.jbry=" + resourceId + "   and wr.CURRENTNODETYPE >0 and " +
                        " ((CONCAT(ksrq ,' ',kssj) < '" + st + "' and  '" + st + "' <  CONCAT(jsrq ,' ',jssj) ) or (CONCAT(ksrq ,' ',kssj) < '" + ed + "' and  '"+ed+"' <  CONCAT(jsrq ,' ',jssj)) or (CONCAT(ksrq ,' ',kssj) > '" + st + "' and  '"+ed+"' >  CONCAT(jsrq ,' ',jssj)))" +
                        "  " +
                        " ");
                bb.writeLog("select wr.requestid,wr.requestname from formtable_main_76_dt1 a,formtable_main_76 b ,workflow_requestbase wr  " +
                        "where b.requestId =wr.REQUESTID and b.id=a.mainid and a.jbry=" + resourceId + "   and wr.CURRENTNODETYPE >0 and " +
                        " ((CONCAT(ksrq ,' ',kssj) < '" + st + "' and  '" + st + "' <  CONCAT(jsrq ,' ',jssj) ) or (CONCAT(ksrq ,' ',kssj) < '" + ed + "' and  '"+ed+"' <  CONCAT(jsrq ,' ',jssj)) or (CONCAT(ksrq ,' ',kssj) > '" + st + "' and  '"+ed+"' >  CONCAT(jsrq ,' ',jssj)))" +
                        "  " +
                        " ");
                rs.next();
                _tmpRq = Util.getIntValue(rs.getString("requestid"));
                msg = Util.null2String(rs.getString("requestname"));
            }else if("76".equals(workflowId)||"88".equals(workflowId)){
                rs.execute("select wr.requestid,wr.requestname from  formtable_main_75 b ,workflow_requestbase wr  " +
                        "where b.requestId =wr.REQUESTID  and b.resourceId=" + resourceId + "   and wr.CURRENTNODETYPE >0 and " +
                        " ((CONCAT(fromDate ,' ',fromTime) < '" + st + "' and  '" + st + "' <  CONCAT(toDate ,' ',toTime) ) or (CONCAT(fromDate ,' ',fromTime) < '" + ed + "' and  '"+ed+"' <  CONCAT(toDate ,' ',toTime)) or (CONCAT(fromDate ,' ',fromTime) > '" + st + "' and  '"+ed+"' >  CONCAT(toDate ,' ',toTime)))" +
                        "  " +
                        " ");
                bb.writeLog("select wr.requestid,wr.requestname from  formtable_main_75 b ,workflow_requestbase wr  " +
                        "where b.requestId =wr.REQUESTID  and b.resourceId=" + resourceId + "   and wr.CURRENTNODETYPE >0 and " +
                        " ((CONCAT(fromDate ,' ',fromTime) < '" + st + "' and  '" + st + "' <  CONCAT(toDate ,' ',toTime) ) or (CONCAT(fromDate ,' ',fromTime) < '" + ed + "' and  '"+ed+"' <  CONCAT(toDate ,' ',toTime)) or (CONCAT(fromDate ,' ',fromTime) > '" + st + "' and  '"+ed+"' >  CONCAT(toDate ,' ',toTime)))" +
                        "  " +
                        " ");
                rs.next();
                _tmpRq = Util.getIntValue(rs.getString("requestid"));
                msg = Util.null2String(rs.getString("requestname"));
            }else if("77".equals(workflowId)){
                rs.execute("select wr.requestid,wr.requestname from  formtable_main_77 b ,workflow_requestbase wr  " +
                        "where b.requestId =wr.REQUESTID  and b.resourceId=" + resourceId + "   and wr.CURRENTNODETYPE >0 and " +
                        " ((CONCAT(fromDate ,' ',fromTime) < '" + st + "' and  '" + st + "' <  CONCAT(toDate ,' ',toTime) ) or (CONCAT(fromDate ,' ',fromTime) < '" + ed + "' and  '"+ed+"' <  CONCAT(toDate ,' ',toTime)) or (CONCAT(fromDate ,' ',fromTime) > '" + st + "' and  '"+ed+"' >  CONCAT(toDate ,' ',toTime)))" +
                        "  " +
                        " ");
                bb.writeLog("select wr.requestid,wr.requestname from  formtable_main_77 b ,workflow_requestbase wr  " +
                        "where b.requestId =wr.REQUESTID  and b.resourceId=" + resourceId + "   and wr.CURRENTNODETYPE >0 and " +
                        " ((CONCAT(fromDate ,' ',fromTime) < '" + st + "' and  '" + st + "' <  CONCAT(toDate ,' ',toTime) ) or (CONCAT(fromDate ,' ',fromTime) < '" + ed + "' and  '"+ed+"' <  CONCAT(toDate ,' ',toTime)) or (CONCAT(fromDate ,' ',fromTime) > '" + st + "' and  '"+ed+"' >  CONCAT(toDate ,' ',toTime)))" +
                        "  " +
                        " ");
                rs.next();
                _tmpRq = Util.getIntValue(rs.getString("requestid"));
                msg = Util.null2String(rs.getString("requestname"));
            }else if("51".equals(workflowId)){
                rs.execute("select wr.requestid,wr.requestname from  formtable_main_77 b ,workflow_requestbase wr  " +
                        "where b.requestId =wr.REQUESTID  and b.resourceId=" + resourceId + "   and wr.CURRENTNODETYPE >0 and " +
                        " ((CONCAT(fromDate ,' ',fromTime) < '" + st + "' and  '" + st + "' <  CONCAT(toDate ,' ',toTime) ) or (CONCAT(fromDate ,' ',fromTime) < '" + ed + "' and  '"+ed+"' <  CONCAT(toDate ,' ',toTime)) or (CONCAT(fromDate ,' ',fromTime) > '" + st + "' and  '"+ed+"' >  CONCAT(toDate ,' ',toTime)))" +
                        "  " +
                        " ");
                bb.writeLog("select wr.requestid,wr.requestname from  formtable_main_77 b ,workflow_requestbase wr  " +
                        "where b.requestId =wr.REQUESTID  and b.resourceId=" + resourceId + "   and wr.CURRENTNODETYPE >0 and " +
                        " ((CONCAT(fromDate ,' ',fromTime) < '" + st + "' and  '" + st + "' <  CONCAT(toDate ,' ',toTime) ) or (CONCAT(fromDate ,' ',fromTime) < '" + ed + "' and  '"+ed+"' <  CONCAT(toDate ,' ',toTime)) or (CONCAT(fromDate ,' ',fromTime) > '" + st + "' and  '"+ed+"' >  CONCAT(toDate ,' ',toTime)))" +
                        "  " +
                        " ");
                rs.next();
                _tmpRq = Util.getIntValue(rs.getString("requestid"));
                msg = Util.null2String(rs.getString("requestname"));
            }else if("78".equals(workflowId)){
                rs.execute("select wr.requestid,wr.requestname from  formtable_main_78 b ,workflow_requestbase wr  " +
                        "where b.requestId =wr.REQUESTID  and b.resourceId=" + resourceId + "   and wr.CURRENTNODETYPE >0 and " +
                        " ((CONCAT(fromDate ,' ',fromTime) < '" + st + "' and  '" + st + "' <  CONCAT(toDate ,' ',toTime) ) or (CONCAT(fromDate ,' ',fromTime) < '" + ed + "' and  '"+ed+"' <  CONCAT(toDate ,' ',toTime)) or (CONCAT(fromDate ,' ',fromTime) > '" + st + "' and  '"+ed+"' >  CONCAT(toDate ,' ',toTime)))" +
                        "  " +
                        " ");
                bb.writeLog("select wr.requestid,wr.requestname from  formtable_main_78 b ,workflow_requestbase wr  " +
                        "where b.requestId =wr.REQUESTID  and b.resourceId=" + resourceId + "   and wr.CURRENTNODETYPE >0 and " +
                        " ((CONCAT(fromDate ,' ',fromTime) < '" + st + "' and  '" + st + "' <  CONCAT(toDate ,' ',toTime) ) or (CONCAT(fromDate ,' ',fromTime) < '" + ed + "' and  '"+ed+"' <  CONCAT(toDate ,' ',toTime)) or (CONCAT(fromDate ,' ',fromTime) > '" + st + "' and  '"+ed+"' >  CONCAT(toDate ,' ',toTime)))" +
                        "  " +
                        " ");
                rs.next();
                _tmpRq = Util.getIntValue(rs.getString("requestid"));
                msg = Util.null2String(rs.getString("requestname"));
            }else if("55".equals(workflowId)){
                rs.execute("select wr.requestid,wr.requestname from  formtable_main_78 b ,workflow_requestbase wr  " +
                        "where b.requestId =wr.REQUESTID  and b.resourceId=" + resourceId + "   and wr.CURRENTNODETYPE >0 and " +
                        " ((CONCAT(fromDate ,' ',fromTime) < '" + st + "' and  '" + st + "' <  CONCAT(toDate ,' ',toTime) ) or (CONCAT(fromDate ,' ',fromTime) < '" + ed + "' and  '"+ed+"' <  CONCAT(toDate ,' ',toTime)) or (CONCAT(fromDate ,' ',fromTime) > '" + st + "' and  '"+ed+"' >  CONCAT(toDate ,' ',toTime)))" +
                        "  " +
                        " ");
                bb.writeLog("select wr.requestid,wr.requestname from  formtable_main_78 b ,workflow_requestbase wr  " +
                        "where b.requestId =wr.REQUESTID  and b.resourceId=" + resourceId + "   and wr.CURRENTNODETYPE >0 and " +
                        " ((CONCAT(fromDate ,' ',fromTime) < '" + st + "' and  '" + st + "' <  CONCAT(toDate ,' ',toTime) ) or (CONCAT(fromDate ,' ',fromTime) < '" + ed + "' and  '"+ed+"' <  CONCAT(toDate ,' ',toTime)) or (CONCAT(fromDate ,' ',fromTime) > '" + st + "' and  '"+ed+"' >  CONCAT(toDate ,' ',toTime)))" +
                        "  " +
                        " ");
                rs.next();
                _tmpRq = Util.getIntValue(rs.getString("requestid"));
                msg = Util.null2String(rs.getString("requestname"));
            }else if("80".equals(workflowId)){
                rs.execute("select wr.requestid,wr.requestname from  formtable_main_80 b ,workflow_requestbase wr  " +
                        "where b.requestId =wr.REQUESTID  and b.resourceId=" + resourceId + "   and wr.CURRENTNODETYPE >0 and " +
                        " ((CONCAT(fromDate ,' ',fromTime) < '" + st + "' and  '" + st + "' <  CONCAT(toDate ,' ',toTime) ) or (CONCAT(fromDate ,' ',fromTime) < '" + ed + "' and  '"+ed+"' <  CONCAT(toDate ,' ',toTime)) or (CONCAT(fromDate ,' ',fromTime) > '" + st + "' and  '"+ed+"' >  CONCAT(toDate ,' ',toTime)))" +
                        "  " +
                        " ");
                bb.writeLog("select wr.requestid,wr.requestname from  formtable_main_80 b ,workflow_requestbase wr  " +
                        "where b.requestId =wr.REQUESTID  and b.resourceId=" + resourceId + "   and wr.CURRENTNODETYPE >0 and " +
                        " ((CONCAT(fromDate ,' ',fromTime) < '" + st + "' and  '" + st + "' <  CONCAT(toDate ,' ',toTime) ) or (CONCAT(fromDate ,' ',fromTime) < '" + ed + "' and  '"+ed+"' <  CONCAT(toDate ,' ',toTime)) or (CONCAT(fromDate ,' ',fromTime) > '" + st + "' and  '"+ed+"' >  CONCAT(toDate ,' ',toTime)))" +
                        "  " +
                        " ");
                rs.next();
                _tmpRq = Util.getIntValue(rs.getString("requestid"));
                msg = Util.null2String(rs.getString("requestname"));
            }else if("52".equals(workflowId)){
                rs.execute("select wr.requestid,wr.requestname from  formtable_main_80 b ,workflow_requestbase wr  " +
                        "where b.requestId =wr.REQUESTID  and b.resourceId=" + resourceId + "   and wr.CURRENTNODETYPE >0 and " +
                        " ((CONCAT(fromDate ,' ',fromTime) < '" + st + "' and  '" + st + "' <  CONCAT(toDate ,' ',toTime) ) or (CONCAT(fromDate ,' ',fromTime) < '" + ed + "' and  '"+ed+"' <  CONCAT(toDate ,' ',toTime)) or (CONCAT(fromDate ,' ',fromTime) > '" + st + "' and  '"+ed+"' >  CONCAT(toDate ,' ',toTime)))" +
                        "  " +
                        " ");
                bb.writeLog("select wr.requestid,wr.requestname from  formtable_main_80 b ,workflow_requestbase wr  " +
                        "where b.requestId =wr.REQUESTID  and b.resourceId=" + resourceId + "   and wr.CURRENTNODETYPE >0 and " +
                        " ((CONCAT(fromDate ,' ',fromTime) < '" + st + "' and  '" + st + "' <  CONCAT(toDate ,' ',toTime) ) or (CONCAT(fromDate ,' ',fromTime) < '" + ed + "' and  '"+ed+"' <  CONCAT(toDate ,' ',toTime)) or (CONCAT(fromDate ,' ',fromTime) > '" + st + "' and  '"+ed+"' >  CONCAT(toDate ,' ',toTime)))" +
                        "  " +
                        " ");
                rs.next();
                _tmpRq = Util.getIntValue(rs.getString("requestid"));
                msg = Util.null2String(rs.getString("requestname"));
            }


            if (_tmpRq > 0) {
                apimap.put("status",1);
                apimap.put("hsmsg","时间与流程"+msg+"存在重复，请重新提交!");
            }else{
                apimap.put("status",0);
                apimap.put("hsmsg","");
            }

        }catch (Exception e){
            apimap.put("status",1);
            apimap.put("hsmsg",e.toString());
        }
        return apimap;
    }

    /**
     * 判断
     * @param requestId
     * @return
     */
    public static Boolean checkLeaveBack(String requestId,String startDate,String endDate){
        RecordSet rs = new RecordSet();
        Boolean back = false;
        String sql = "select workflowid from kq_flow_split_leave where leavebackrequestid is null and belongdate >= '"+startDate+"' and belongdate <= '"+endDate+"' and requestid = "+requestId;
        rs.executeQuery(sql);
        if(rs.getCounts()>0){
            //该请假流程存在未退假的日期
            back = true;
        }
        return back;
    }
}
