package com.engine.leshanvc.web;

import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import com.engine.leshanvc.service.LzWorkflowManageService;
import com.engine.leshanvc.service.impl.LzWorkflowManageServiceImpl;
import com.engine.leshanvc.util.ResponseResult;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.Map;

public class LzWorkflowManageAction {
    public LzWorkflowManageService getService(User user){
        return ServiceUtil.getService(LzWorkflowManageServiceImpl.class,user);
    }

    /**
     * @Author ml
     * @Date 2023/3/16 10:44
     * @Description 根据线长查询生产线人员
     * @Since version-1.0
     */
    @GET
    @Path("/getHrmInfoByLinSup")
    @Produces(MediaType.APPLICATION_JSON)
    public String getHrmInfoByLinSup(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        return new ResponseResult<Map<String, Object>,  Map<String, Object>>(user).run(getService(user)::getHrmInfoByLinSup, ParamUtil.request2Map(request));
    }
}
