package com.engine.leshanvc.web;

import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import com.engine.leshanvc.service.WorkflowCheckService;
import com.engine.leshanvc.service.impl.WorkflowCheckServiceImpl;
import com.engine.leshanvc.util.ResponseResult;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.Map;

/**
 * @Author weaver_cl
 * @Description:
 * @Date 2023/3/8
 * @Version V1.0
 **/
public class WorkflowCheckAction {

    public WorkflowCheckService getService(User user) {
        return ServiceUtil.getService(WorkflowCheckServiceImpl.class,user);
    }

    @GET
    @Path("/controller")
    @Produces(MediaType.APPLICATION_JSON)
    public String workflowController(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        return new ResponseResult< Map<String, Object>,  Map<String, Object>>(user).run(getService(user)::workflowController, ParamUtil.request2Map(request));
    }
}
