package com.engine.workflow.cmd.requestForm;

import com.api.workflow.util.ServiceUtil;
import com.cloudstore.dev.api.util.Util_TableMap;
import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.constant.BizLogOperateType;
import com.engine.common.constant.BizLogSmallType4Workflow;
import com.engine.common.constant.BizLogType;
import com.engine.common.entity.BizLogContext;
import com.engine.common.util.ParamUtil;
import com.engine.core.interceptor.CommandContext;
import com.engine.workflow.biz.WorkflowTestBiz;
import com.engine.workflow.biz.publicApi.RequestOperateBiz;
import com.engine.workflow.biz.requestForm.RequestRemindBiz;
import com.engine.workflow.biz.requestForm.SubmitErrorMsgBiz;
import com.engine.workflow.biz.requestForm.TestWorkflowCheckBiz;
import com.engine.workflow.biz.requestList.RequestAttentionBiz;
import com.engine.workflow.biz.workflowOvertime.OvertimeBiz;
import com.engine.workflow.constant.RemindTypeEnum;
import com.engine.workflow.constant.requestForm.RequestExecuteType;
import com.engine.workflow.entity.requestForm.RequestOperationResultBean;
import weaver.conn.RecordSet;
import weaver.file.FileUpload;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.hrm.User;
import weaver.systeminfo.SystemEnv;
import weaver.workflow.agent.AgentManager;
import weaver.workflow.msg.MsgPushUtil;
import weaver.workflow.msg.entity.MsgEntity;
import weaver.workflow.request.*;
import weaver.workflow.workflow.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * 功能管理
 * @author liuzy 2018/5/4
 */
public class FunctionManageCmd extends AbstractCommonCommand<Map<String,Object>>{

	private HttpServletRequest request;
	private HttpServletResponse response;

	public FunctionManageCmd(HttpServletRequest request, HttpServletResponse response, User user){
		this.request = request;
		this.response = response;
		this.user = user;
	}

	public Map<String,Object> execute(CommandContext commandContext){
		Map<String, Object> apidatas = new HashMap<String, Object>();

		Map<String, String> resultmap = new HashMap<String, String>();
		int logintype = Util.getIntValue(user.getLogintype());
		int requestid = Util.getIntValue(request.getParameter("requestid"), 0);
		String flag = Util.null2String(request.getParameter("flag"));
		WfFunctionManageUtil wffmu = new WfFunctionManageUtil();
		ArrayList<String> requestidlist = new ArrayList<String>();

		int formid = Util.getIntValue(request.getParameter("formid"), 0);
		int requestLogId = Util.getIntValue(request.getParameter("workflowRequestLogId"), 0);
		String signdocids = Util.null2String(request.getParameter("signdocids"));
		String signworkflowids = Util.null2String(request.getParameter("signworkflowids"));
		String remark = Util.null2String(request.getParameter("remark"));
		int workflowid = Util.getIntValue(request.getParameter("workflowid"), 0);
		int nodeid = -1;


		String isnew = new BaseBean().getPropValue("WorkflowOvertimeIsNew" , "isNew");
		boolean isnewFlag = "1".equals(isnew);
		// 流程暂停
		if ("stop".equals(flag)) {
			wffmu.setStopOperation(requestid, user);
//			this.pushOperationMsg(requestid,user,flag);
			if(isnewFlag)
				OvertimeBiz.getInstance().cancelOvertimeTask(requestid, nodeid);//取消超时任务
		}

		// 流程撤销
		if ("cancel".equals(flag)) {
			wffmu.setCancelOperation(requestid, user);
//			this.pushOperationMsg(requestid,user,flag);
			if(isnewFlag)
				OvertimeBiz.getInstance().cancelOvertimeTask(requestid, nodeid);//取消超时任务
		}

		// 流程启用
		if ("restart".equals(flag)) {
			wffmu.setRestartOperation(requestid, user);
//			this.pushOperationMsg(requestid,user,flag);
			if(isnewFlag)
				OvertimeBiz.getInstance().addOvertimeTaskThread(requestid, workflowid, nodeid);//添加超时任务
		}


		// 强制归档
		if ("ov".equals(flag)) {
			WfForceOver wfo = new WfForceOver();
			String annexdocids = "";
			String fromflow = Util.null2String(request.getParameter("fromflow"));
			String remarkLocation = Util.null2String(request.getParameter("remarkLocation"));

			int agentType = Util.getIntValue(Util.null2String(request.getParameter("agentType")));
			int agentorByAgentId = Util.getIntValue(Util.null2String(request.getParameter("agentorByAgentId")));
			if (agentType == 1) {//流程代理出去，本人强制归档，需先收回代理
				AgentManager agentManager = new AgentManager(user);
				agentManager.agentBackRequest(agentorByAgentId, user.getUID(), workflowid + "", requestid);
				Date currentDate = new Date();
				SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-mm-dd");
				SimpleDateFormat timeForamt = new SimpleDateFormat("HH:mm:ss");
				new RecordSet().executeUpdate("update workflow_currentoperator set operatedate = ? , operatetime = ? where userid = ? and requestid = ? and (operatedate is null or operatedate < ' ' ) ",
						dateFormat.format(currentDate), timeForamt.format(currentDate), user.getUID(), requestid);
			}

			if (fromflow.equals("1")) {
				FileUpload fu = new FileUpload(request);
				remark = Util.null2String(fu.getParameter("remark"));
				workflowid = Util.getIntValue(fu.getParameter("workflowid"), -1);
				nodeid = Util.getIntValue(fu.getParameter("nodeid"), -1);

				// 获取签字意见相关文档，相关流程

				signdocids = Util.null2String(fu.getParameter("signdocids"));
				signworkflowids = Util.null2String(fu.getParameter("signworkflowids"));
				String ismode = Util.null2String(request.getParameter("ismode"));
				if (!ismode.equals("1")) {
					RequestAnnexUpload rau = new RequestAnnexUpload();
					rau.setRequest(fu);
					rau.setUser(user);
					annexdocids = rau.AnnexUpload();
				} else {
					String hasSign = "0";// 模板中是否设置了签字
					RecordSet rs = new RecordSet();
					rs.executeSql("select * from workflow_modeview where formid=" + formid + " and nodeid=" + nodeid + " and fieldid=-4");
					if (rs.next())
						hasSign = "1";
					if ("1".equals(hasSign)) {// 模板中设置了签字
						annexdocids = Util.null2String(fu.getParameter("qianzi"));
					} else {// 模板中没有设置签字，按普通方式上传签字意见的附件
						RequestAnnexUpload rau = new RequestAnnexUpload();
						rau.setRequest(fu);
						rau.setUser(user);
						annexdocids = rau.AnnexUpload();
					}
				}


				WFManager wfManager = new WFManager();
				wfManager.setWfid(workflowid);
				try {
					wfManager.getWfInfo();
				} catch (Exception e) {
					e.printStackTrace();
				}
				String isShowChart = Util.null2s(wfManager.getIsShowChart().trim(),"0");
				apidatas.put("isShowChart", isShowChart);
			}

			wfo.setRemark(remark);
			wfo.setAnnexdocids(annexdocids);
			wfo.setSigndocids(signdocids);
			wfo.setSignworkflowids(signworkflowids);
			wfo.setRequestLogId(requestLogId);
			wfo.setRemarkLocation(remarkLocation);

			WFUrgerManager wfum = new WFUrgerManager();
			if (wffmu.haveOtherOperationRight(requestid) && !wfo.isOver(requestid) && (wfo.isNodeOperator(requestid, user.getUID()) || wfum.getMonitorViewRight(requestid, user.getUID()))) {
				requestidlist.add("" + requestid);
				wfo.doForceOver(requestidlist, request, response, user);
				apidatas.put("success",1);
				if(isnewFlag)
					OvertimeBiz.getInstance().cancelOvertimeTask(requestid, nodeid);//取消超时任务
				
				//no.2545225 强制归档需要触发节点附加操作，实现一键审批
				try {
					RequestManager requestManager = new RequestManager();
					requestManager.setUser(user);
					requestManager.setWorkflowid(workflowid);
					requestManager.setRequestid(requestid);
					WorkflowComInfo wfComInfo = new WorkflowComInfo();
					int tempformid = Util.getIntValue(wfComInfo.getFormId(workflowid+""));
					int tempisbill = Util.getIntValue(wfComInfo.getIsBill(workflowid+""));
					String sql2 = "select nodeid from workflow_flownode where workflowid = ? and nodetype = 3";
					RecordSet recordSet = new RecordSet();
					recordSet.executeQuery(sql2,workflowid);
					int tempnodeid = -1;
					if(recordSet.next()) {
						tempnodeid = recordSet.getInt("nodeid");
					}
					RequestCheckAddinRules requestCheckAddinRules = new RequestCheckAddinRules();
					requestCheckAddinRules.resetParameter();
					requestCheckAddinRules.setWorkflowid(workflowid);
					requestCheckAddinRules.setRequestid(requestid);
					requestCheckAddinRules.setNodeid(tempnodeid);
					requestCheckAddinRules.setObjid(tempnodeid);
					requestCheckAddinRules.setObjtype(1);
					requestCheckAddinRules.setIsbill(tempisbill);
					requestCheckAddinRules.setFormid(tempformid);
					requestCheckAddinRules.setIspreadd("0");
					requestCheckAddinRules.setRequestManager(requestManager);
					requestCheckAddinRules.checkAddinRules();
				} catch (Exception e) {
					e.printStackTrace();
				}
				
			}else{
				apidatas.put("success",0);
			}
			//判断是否属于流程测试
			TestWorkflowCheckBiz testBiz = new TestWorkflowCheckBiz();
			boolean belongTest = testBiz.judgeBelongTest(request, false);
			if(belongTest) {
				RecordSet rs = new RecordSet();
				rs.executeQuery("select nodeid from workflow_flownode where workflowid = ? and nodetype = 3",workflowid);
				rs.next();
				WorkflowTestBiz.setWorkflowTestInfo(flag, requestid, nodeid, "", null,rs.getInt("nodeid"));
			}

			this.doArchiveRemind(workflowid,requestid);

			new weaver.cpt.util.CptWfUtil().releaseFrozenCptnum(requestid+""); //清除资产冻结
		}

		// 强制收回
		if ("rb".equals(flag)) {
			WfForceDrawBack wfdb = new WfForceDrawBack();
			RequestForceDrawBack requestForceDrawBack = new RequestForceDrawBack();
			RequestOperationResultBean resultBean = new  RequestOperationResultBean();
			if (wffmu.haveOtherOperationRight(requestid) && wfdb.isHavePurview(requestid, user.getUID(), logintype, -1, -1)) {
				requestidlist.add("" + requestid);
				// WfForceDrawBack.doForceDrawBack(requestidsArr, request,
				// response, -1, -1);
				// 使用新的收回方式
				String sessionkey = workflowid + "_" + nodeid + "_" + user.getUID() + "_" + System.currentTimeMillis();
				int result = requestForceDrawBack.foreceDrawBack(user, requestid, false, -1, -1);
				if (!requestForceDrawBack.isAddInOperateSuccess()) {//强制收回附加操作执行失败，返回错误信息
					String message = requestForceDrawBack.getMessage();
					String messagecontent = requestForceDrawBack.getMessageContent();
					if("".equals(message) || requestid <= 0) {
						message = "1";
					}
					resultBean.setMessageInfo(SubmitErrorMsgBiz.getMsgInfo(request,user,message,messagecontent));
					resultBean.setType(RequestExecuteType.FAILD);
					Util_TableMap.setObjVal(Util.null2String(sessionkey), resultBean);
					apidatas.put("success",false);
					apidatas.put("msg",SystemEnv.getHtmlLabelNames("506175,83071",user.getLanguage()));
					return apidatas;
				}
				if (result == RequestForceDrawBack.OLDDATA) {
					wfdb.doForceDrawBack(requestidlist, request, response, -1, -1);
				}
				RequestOperateBiz.drawBackSpecialTreatment(formid, workflowid);

				/*E9打印登录超时报错(QC:527424)*/
				if(user == null) {
					try {
						response.sendRedirect(weaver.general.GCONST.getContextPath()+"/wui/index.html");
						return null;
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
				//判断是否可以跳转到新的页面
				boolean reqRoute = ServiceUtil.isReqRoute(String.valueOf(requestid),user);
				apidatas.put("reqRoute", reqRoute);
				apidatas.put("success",result == RequestForceDrawBack.SUCCESS);
				if(result == RequestForceDrawBack.SUCCESS){
					apidatas.put("msg",SystemEnv.getHtmlLabelName(83585,user.getLanguage()));
				}else if(result == RequestForceDrawBack.FAIL){
					apidatas.put("msg",SystemEnv.getHtmlLabelName(389102,user.getLanguage()));
				}else if(result == RequestForceDrawBack.NORIGHT){
					apidatas.put("msg",SystemEnv.getHtmlLabelName(18567,user.getLanguage()));
				}
				apidatas.put("sessionkey", sessionkey);
			}else {
				apidatas.put("success",false);
				apidatas.put("msg",SystemEnv.getHtmlLabelName(18567,user.getLanguage()));
			}
		}
		//自动取消 流程关注
		new RequestAttentionBiz().cancelAttention(requestid,flag);
		return apidatas;
	}

	@Override
	public BizLogContext getLogContext() {
		String targetName = "";
		String flag = Util.null2String(request.getParameter("flag"));
		if ("stop".equals(flag)) {
			targetName = "流程暂停";
		} else if ("cancel".equals(flag)) {
			targetName = "流程撤销";
		} else if ("restart".equals(flag)) {
			targetName = "流程启用";
		} else if ("ov".equals(flag)) {
			targetName = "强制归档";
		} else if ("rb".equals(flag)) {
			targetName = "强制收回";
		}
		BizLogContext bizLogContext = new BizLogContext();
		BizLogOperateType bizLogOperateType = BizLogOperateType.APPROVE;
		bizLogContext.setDateObject(new Date());
		bizLogContext.setUserid(user.getUID());
		bizLogContext.setUsertype(Util.getIntValue(user.getLogintype()));
		bizLogContext.setTargetId("request_functionlink_" + flag);
		bizLogContext.setTargetName(targetName);
		bizLogContext.setLogType(BizLogType.WORKFLOW);
		bizLogContext.setLogSmallType(BizLogSmallType4Workflow.WORKFLOW_APPROVE);
		bizLogContext.setOperateType(bizLogOperateType);
		bizLogContext.setClientIp(Util.null2String(Util.getIpAddr(request)));
		bizLogContext.setParams(ParamUtil.request2Map(request));
		bizLogContext.setDesc(String.format(user.getLastname() + "进行了"+targetName+"操作"));
		return bizLogContext;
	}


	/**
	 * 暂停、撤销、启用消息数据
	 * @param requestId
	 * @param user
	 * @param flag
	 */
	private boolean pushOperationMsg(int requestId,User user,String flag){

		RequestOperationMsgManager romm = new RequestOperationMsgManager();
		List<MsgEntity> requestMsgEntity = romm.getOperateMsgByReqId(String.valueOf(requestId),user,flag);
		new MsgPushUtil().pushMsg(requestMsgEntity);
		return true;
	}


	private void doArchiveRemind(int workflowid,int requestid){
		String src = Util.null2String(request.getParameter("src"));
		String remindTypes = Util.null2String(request.getParameter("remindTypes"));   //表单上提醒方式
		RequestRemindBiz requestRemindBiz = new RequestRemindBiz(user);
		//默认提醒
		WFManager wfManager = new WFManager();
		try{
			wfManager.setWfid(workflowid);
			wfManager.getWfInfo();
		}catch (Exception e){}

		if("-1".equals(remindTypes)){ //老数据
			int messageType = Util.getIntValue(Util.null2String(request.getParameter("messageType")),-1); // 老短信提醒
			int mailMessageType = Util.getIntValue(Util.null2String(request.getParameter("chatsType")),-1); // 老邮件提醒
			if(messageType >=1) requestRemindBiz.requestRemind(requestid,workflowid,src, RemindTypeEnum.SMS,messageType);
			//历史数据可能只有短信提醒，但是其实也开启了邮件提醒
			int _mailMessageType = Util.getIntValue(wfManager.getMailMessageType(),-1);
			if(mailMessageType == 1 || _mailMessageType == 1) requestRemindBiz.requestRemind(requestid,workflowid,src,RemindTypeEnum.EMAIL,0);
			Set<String> remindType = new HashSet<>();
			if(messageType >=1) {
				requestRemindBiz.requestRemind(requestid,workflowid,src,RemindTypeEnum.SMS,messageType);
			}
			if(mailMessageType == 1 || _mailMessageType == 1) {
				requestRemindBiz.requestRemind(requestid,workflowid,src,RemindTypeEnum.EMAIL,0);
			}
		}else{

			String isSmsRemind = remindTypes.indexOf(RemindTypeEnum.SMS.getCode()) > -1 ? "1" : "0";
			String isEmailRemind = remindTypes.indexOf(RemindTypeEnum.EMAIL.getCode()) > -1 ? "1" : "0";
			if("1".equals(isSmsRemind)) requestRemindBiz.requestRemind(requestid,workflowid,src,RemindTypeEnum.SMS,0);
			if("1".equals(isEmailRemind)) requestRemindBiz.requestRemind(requestid,workflowid,src,RemindTypeEnum.EMAIL,0);
		}
		requestRemindBiz.requestEmailApproveRemind(String.valueOf(workflowid),String.valueOf(requestid),src);
	}

	public HttpServletRequest getRequest() {
		return request;
	}
}