package weaver.interfaces.hansang.action;

import weaver.common.DateUtil;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.RequestInfo;

/**
 * @author wanxq
 * @date 2023年10月18日16:02:08
 * @desc 公出自动打卡
 */
public class OfficeOutAutoSignAction extends BaseBean implements Action {


    @Override
    public String execute(RequestInfo requestInfo) {
        String requestid = requestInfo.getRequestid();
        String tableName = requestInfo.getRequestManager().getBillTableName();

        try {
            RecordSet rs = new RecordSet();
            String sql = " select resourceId,fromDate,fromTime,toDate,toTime from "+tableName+" where requestid=? ";
            rs.executeQuery(sql,requestid);
            if(rs.next()){
                String resourceId = Util.null2String(rs.getString("resourceId"));
                String fromDate = Util.null2String(rs.getString("fromDate"));
                String fromTime = Util.null2String(rs.getString("fromTime"));
                String toDate = Util.null2String(rs.getString("toDate"));
                String toTime = Util.null2String(rs.getString("toTime"));

                int daysDiff = DateUtil.dayDiff(fromDate,toDate)+1;
                for(int i=0;i<daysDiff;i++ ){
                    String tempdate = DateUtil.addDate(fromDate,i);

                    String signintime = "08:30:00";
                    if(fromDate.equals(tempdate)){
                        signintime = fromTime;
                    }

                    String signouttime = "17:20:00";
                    if(toDate.equals(tempdate)){
                        signouttime = toTime;
                    }

                    String  signSql = " insert into HrmScheduleSign (userid, usertype, signdate, signtime, isincom, isimport, signfrom) "
                            + " values(?,?,?,?,?,?,?)";

                    //插入上班卡数据
                    rs.executeUpdate(signSql,resourceId,1,tempdate,signintime,1,null,"e9pc");
                    //插入下班卡数据
                    rs.executeUpdate(signSql,resourceId,1,tempdate,signouttime,1,null,"e9pc");

                }
            }
        }catch (Exception e){
            requestInfo.getRequestManager().setMessageid("10001");
            requestInfo.getRequestManager().setMessagecontent("加班自动打卡出错");
            return FAILURE_AND_CONTINUE;
        }
        return SUCCESS;
    }







}
