package weaver.interfaces.hansang.action;

import com.engine.kq.biz.KQFormatData;
import weaver.common.DateUtil;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.RequestInfo;

import java.util.Calendar;

/**
 * @author wanxq
 * @date 2023年08月30日13:26:43
 * @desc 加班自动打卡
 */
public class RefreshKqReportBatchAction extends BaseBean implements Action {


    @Override
    public String execute(RequestInfo requestInfo) {
        String requestid = requestInfo.getRequestid();
        String tableName = requestInfo.getRequestManager().getBillTableName();

        try {
            RecordSet rs = new RecordSet();
            KQFormatData kqFormatData = new KQFormatData();

            String sql = " select jbry,ksrq,jsrq from "+tableName+" a,"+tableName+"_dt1 b where a.id=b.mainid and a.requestid=? ";
            rs.executeQuery(sql,requestid);
            while(rs.next()){
                String resourceId = Util.null2String(rs.getString("jbry"));
                String fromDate = Util.null2String(rs.getString("ksrq"));
                String toDate = Util.null2String(rs.getString("jsrq"));

                Calendar cal = DateUtil.getCalendar();
                boolean isEnd = false;
                for (String date = fromDate; !isEnd; ) {
                    if (date.equals(toDate)) {
                        isEnd = true;
                    }
                    kqFormatData.formatKqDate(resourceId, date);
                    cal.setTime(DateUtil.parseToDate(date));
                    date = DateUtil.getDate(cal.getTime(), 1);
                }
            }
        }catch (Exception e){
            requestInfo.getRequestManager().setMessageid("10010");
            requestInfo.getRequestManager().setMessagecontent("考勤报表数据刷新错误");
            return FAILURE_AND_CONTINUE;
        }
        return SUCCESS;
    }







}
