package weaver.interfaces.hansang.job;


import com.engine.kq.biz.KQHolidaySetBiz;
import com.engine.kq.biz.KQWorkTime;
import weaver.common.DateUtil;
import weaver.conn.RecordSet;
import weaver.file.Prop;
import weaver.general.TimeUtil;
import weaver.general.Util;
import weaver.interfaces.schedule.BaseCronJob;

import java.time.LocalDate;
import java.time.temporal.TemporalAdjusters;

/**
 * @author wanxq
 * @date 2023年06月20日09:25:14
 * @desc
 */
public class KqAutoScheduleJob extends BaseCronJob {


    @Override
    public void execute() {

        String baiban = Util.null2s(Prop.getPropValue("hansang_auto_schedule","baiban"),"2");
        String xiuxiban = Util.null2s(Prop.getPropValue("hansang_auto_schedule","xiuxiban"),"15");

        RecordSet rs = new RecordSet();
        String sql = "  select * from (\n" +
                " SELECT a.id AS resourceid, b.groupid, a.status,a.dsporder,a.lastname,a.subcompanyid1, a.departmentid, a.loginid FROM HrmResource a, kq_groupmember b  \n" +
                " WHERE a.id=b.typevalue and b.type =1 and (b.isdelete is null or  b.isdelete <> '1')  \n" +
                " UNION ALL  \n" +
                " SELECT a.id AS resourceid, b.groupid, a.status,a.dsporder,a.lastname,a.subcompanyid1, a.departmentid, a.loginid FROM HrmResource a, kq_groupmember b  \n" +
                " WHERE a.subcompanyid1 = b.typevalue AND a.seclevel>=b.seclevel AND a.seclevel<=b.seclevelto AND b.type=2 and (b.isdelete is null or  b.isdelete <> '1')  \n" +
                " UNION ALL  \n" +
                " SELECT a.id AS resourceid, b.groupid, a.status,a.dsporder,a.lastname,a.subcompanyid1, a.departmentid, a.loginid FROM HrmResource a, kq_groupmember b  \n" +
                " WHERE a.departmentid = b.typevalue AND a.seclevel>=b.seclevel AND a.seclevel<=b.seclevelto AND b.type=3 and (b.isdelete is null or  b.isdelete <> '1')  \n" +
                " UNION ALL  \n" +
                " SELECT a.id AS resourceid, b.groupid, a.status,a.dsporder,a.lastname,a.subcompanyid1, a.departmentid, a.loginid FROM HrmResource a, kq_groupmember b  \n" +
                " WHERE  (a.jobtitle = b.typevalue AND b.type=5 and (b.isdelete is null or  b.isdelete <> '1') AND (b.jobtitlelevel=1 OR (b.jobtitlelevel=2 AND a.subcompanyid1 IN(b.jobtitlelevelvalue)) OR (b.jobtitlelevel=3 AND a.departmentid IN(b.jobtitlelevelvalue)))) \n" +
                " UNION ALL  SELECT a.id AS resourceid, b.groupid, a.status,a.dsporder,a.lastname,a.subcompanyid1, a.departmentid, a.loginid FROM HrmResource a, kq_groupmember b \n" +
                " WHERE b.type=6 AND a.seclevel>=b.seclevel AND a.seclevel<=b.seclevelto and (b.isdelete is null or b.isdelete <> '1') ) t\n" +
                "where t.groupid = 12  and t.status in(0,1,2,3) and t.loginid is not null  and t.loginid<>''  and (t.status = 0 or t.status = 1 or t.status = 2 or t.status = 3) ";
        rs.execute(sql);
        while(rs.next()){
            String resourceid = Util.null2String(rs.getString("resourceid"));
            saveSchedule(resourceid,baiban,xiuxiban);
        }
    }

    /**
     * 自动设置人员的排班
     * @param resourceid
     */
    public void saveSchedule(String resourceid,String baiban,String xiuxiban){

        RecordSet rs = new RecordSet();
        KQWorkTime kqWorkTime = new KQWorkTime();

        LocalDate now = LocalDate.now();
        now = now.plusMonths(1);
        String firstDay = now.with(TemporalAdjusters.firstDayOfMonth()).toString();
        String lastDay = now.with(TemporalAdjusters.lastDayOfMonth()).toString();



        int diffdays = DateUtil.dayDiff(firstDay,lastDay)+1;
        for(int i=0;i<diffdays;i++){
            String tempdate = TimeUtil.dateAdd(firstDay,i);
            String serialid = baiban;

            //按照生产排班获取当前日期的节假日类型  1-节假日、2-工作日、3-休息日、-1-没有设置过数据
            boolean isHoliday = false;
            int changeType = KQHolidaySetBiz.getChangeType("3",tempdate);
            if (changeType != 2 && (DateUtil.getWeek(tempdate) == 6 || DateUtil.getWeek(tempdate) == 7)) {
                isHoliday = true;
            }
            if (changeType == 1 || changeType == 3) {
                isHoliday = true;
            }

            if(isHoliday){
                serialid = xiuxiban;
            }
            rs.executeQuery(" select 1 from kq_shiftschedule where kqdate=? and serialid=? " +
                    "and resourceid=? and groupid=12 ",tempdate,serialid,resourceid);
            if(rs.next()){
                String updateSql = "update kq_shiftschedule set isdelete=null where kqdate=? and serialid=? and resourceid=? and groupid=12";
                //rs.writeLog("KqAutoScheduleJob updateSql===>"+updateSql);
                rs.executeUpdate(updateSql, tempdate,serialid,resourceid);
            }else {
                String insertSql = "insert into kq_shiftschedule (kqdate,serialid,resourceid,groupid) values(?,?,?,?) ";
                //rs.writeLog("KqAutoScheduleJob insertSql===>"+insertSql);
                rs.executeUpdate(insertSql, new Object[]{tempdate,serialid,resourceid,12});
            }

        }
    }



}
