package weaver.interfaces.hansang.job;


import weaver.common.DateUtil;
import weaver.conn.RecordSet;
import weaver.interfaces.schedule.BaseCronJob;

/**
 * @author wanxq
 * @date 2023年10月07日15:52:27
 * @desc 根据自定义离职日期更新标准合同结束日期字段
 */
public class LeaveDateUpdateJob extends BaseCronJob {

    private String selectMonth;

    @Override
    public void execute() {
        String currentMonth = DateUtil.getCurrentDate().substring(0,7);
        if(selectMonth!=null && !"".equals(selectMonth)){
            currentMonth = selectMonth;
        }

        RecordSet rs = new RecordSet();
        String sql = " update cus_fielddata a,hrmresource b set enddate=date_add(field82, INTERVAL -1 DAY) " +
                " where a.id=b.id and scopeid=3 and field82 like '"+currentMonth+"%' ";
        rs.execute(sql);

    }

    public String getSelectMonth() {
        return selectMonth;
    }

    public void setSelectMonth(String selectMonth) {
        this.selectMonth = selectMonth;
    }

}
