package weaver.interfaces.hansang.job;


import weaver.common.DateUtil;
import weaver.conn.RecordSet;
import weaver.general.Util;
import weaver.interfaces.schedule.BaseCronJob;

import java.text.DecimalFormat;
import java.time.format.DateTimeFormatter;

/**
 * @author wanxq
 * @date 2023年08月17日14:17:51
 * @desc 护理假基数计算
 */
public class NurseLeaveCalculateJob extends BaseCronJob {

    @Override
    public void execute() {

        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");
        DecimalFormat df = new DecimalFormat("#.00");
        String currentYear = DateUtil.getYear();
        //当前日期减出生日期小于3年才计算育儿假
        RecordSet rs = new RecordSet();
        String sql = " select id,companystartdate from hrmresource h where status<=3 and companystartdate is not null ";
        rs.executeQuery(sql);
        while (rs.next()){
            String id = Util.null2String(rs.getString("id"));
            String companystartdate = Util.null2String(rs.getString("companystartdate"));

            double jqts = 0;
            if(!"".equals(companystartdate)){
                String companystartyear = companystartdate.substring(0,4);
                if(currentYear.equals(companystartyear)){
                    int diffDays = DateUtil.dayDiff(companystartdate,companystartyear+"-12-31")+1;
                    jqts = Double.valueOf(df.format((double)diffDays/365*5));
                }else {
                    jqts = 5;
                }
                setLeaveTypeDays(id,jqts,currentYear);
            }
        }
    }

    /**
     * 设置人员护理假
     * @param ry
     * @param jqts
     * @param belongyear
     */
    public void setLeaveTypeDays(String ry, double jqts,String belongyear) {
        RecordSet rs = new RecordSet();
        String sql = " update kq_balanceofleave set baseAmount=? " +
                " where leaveRulesId=? and resourceId=? and belongyear=? ";
        rs.executeUpdate(sql,jqts,37,ry,belongyear);
    }

    public static void main(String[] args) {
        System.out.println("2021-01-27".substring(0,4));
    }


}
