package weaver.interfaces.hansang.job;


import dm.jdbc.util.IdGenerator;
import weaver.conn.RecordSet;
import weaver.general.TimeUtil;
import weaver.general.Util;
import weaver.interfaces.schedule.BaseCronJob;

/**
 * @author wanxq
 * @date 2023年08月01日10:26:38
 * @desc 定时同步个税扣缴义务人
 */
public class SalaryTaxMemSynJob extends BaseCronJob {

    private String selectMonth;


    @Override
    public void execute() {


        RecordSet rs = new RecordSet();
        RecordSet rs2 = new RecordSet();

        //查询上月入职人员
        String lastMonth = TimeUtil.getLastMonthEndDay().substring(0,7);
        if(selectMonth!=null && !"".equals(selectMonth)){
            lastMonth = selectMonth;
        }


        String sql = " select a.id,companystartdate,subcompanyid1,field35 from hrmresource a,cus_fielddata b " +
                "    where companystartdate like '"+lastMonth+"%' " +
                "    and a.id=b.id and field35 is not null";
        rs.writeLog("SalaryTaxMemSynJob sql====>"+sql);
        rs.execute(sql);
        while(rs.next()){
            int userid = rs.getInt("id");
            int subcomid = rs.getInt("subcompanyid1");
            int field35 = rs.getInt("field35");
            Long id = IdGenerator.generate();

            int tax_agent_id = -1;
           /*
            ①　直/间接 等于 办公加班月结、办公加班非月结 且 分部 等于 汉桑（南京）科技股份有限公司 时，人员同步至 （办公）-汉桑（南京）科技股份有限公司 账套中。
            ②　直/间接 等于 制造人员、劳务人员、临时工 且 分部 等于 汉桑（南京）科技股份有限公司 时，人员同步至 （非办公）-汉桑（南京）科技股份有限公司 账套中。
            ③　直/间接 等于 办公加班月结、办公加班非月结 且 分部 等于 南京音范影音科技有限公司 时，人员同步至 南京音范影音科技有限公司 账套中。
            */
            if(field35==0 || field35==1){
                if(subcomid==4){
                    tax_agent_id = 1;
                }else{
                    tax_agent_id = 2;
                }
            }else{
                if(subcomid==4){
                    tax_agent_id = 4;
                }
            }

            //判断是当前人员否存在账套中
            String existSql = "  select id from hrsa_tax_agent_manage_range " +
                    " where tax_agent_id=? and delete_type=0 " +
                    " and target_id=? and target_type=1 and include_type=1  ";
            rs2.executeQuery(existSql,tax_agent_id,userid);
            String currentime = TimeUtil.getCurrentTimeString();
            if(rs2.next()){
                String dataid = Util.null2String(rs.getString("id"));
                String updateSql = " update hrsa_tax_agent_manage_range set employee_status=?,update_time=?  where id=? ";
                rs2.executeUpdate(updateSql,"[\"0\",\"1\",\"2\",\"3\",\"4\",\"5\",\"6\"]",currentime,dataid);

            }else{
                String insertSql = " insert into hrsa_tax_agent_manage_range(id,tax_agent_id,employee_id,tax_agent_sub_admin_id," +
                        "target_type,target_id,employee_status,include_type,creator,create_time,update_time,delete_type,tenant_key,range_type) " +
                        "values(?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
                rs2.executeUpdate(insertSql,new Object[]{id,tax_agent_id,0,0,1,userid,"[\"0\",\"1\",\"2\",\"3\",\"4\",\"5\",\"6\"]",
                        1,1,currentime,currentime,0,"all_teams",1});
            }
        }
    }


    /**
     * 判断个税扣缴义务人是否在当前账套中
     * @param userid
     * @param taxAgentId
     * @return
     */
    public boolean isExist(int userid,int taxAgentId){
        RecordSet rs = new RecordSet();
        String sql = "  select id from hrsa_tax_agent_manage_range " +
                " where tax_agent_id=? and delete_type=0 " +
                " and target_id=? and target_type=1 and include_type=1  ";
        rs.executeQuery(sql,taxAgentId,userid);
        return  rs.next();
    }

    public String getSelectMonth() {
        return selectMonth;
    }

    public void setSelectMonth(String selectMonth) {
        this.selectMonth = selectMonth;
    }
}
