
package weaver.interfaces.hskq.action;

import com.alibaba.fastjson.JSONObject;
import com.engine.common.util.ServiceUtil;
import com.engine.hrm.service.OrganizationService;
import com.engine.hrm.service.impl.OrganizationServiceImpl;
import com.engine.hrm.util.face.HrmFaceCheckManager;
import org.apache.commons.lang3.StringUtils;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.hrm.User;
import weaver.hrm.common.DbFunctionUtil;
import weaver.hrm.company.DepartmentComInfo;
import weaver.interfaces.email.CoreMailAPI;
import weaver.interfaces.hrm.HrmServiceManager;
import weaver.interfaces.workflow.action.Action;
import weaver.matrix.MatrixUtil;
import weaver.rtx.OrganisationCom;
import weaver.soa.workflow.request.Property;
import weaver.soa.workflow.request.RequestInfo;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * 部门调整Action
 */
public class BmChangeAction implements Action {

    static String dateFormat = "yyyy-MM-dd";
    static SimpleDateFormat format = new SimpleDateFormat(dateFormat);

    public OrganizationService getOrganizationService(User user) {
        return ServiceUtil.getService(OrganizationServiceImpl.class, user);
    }

    public BmChangeAction() {
    }

    @Override
    public String execute(RequestInfo info) {
        new BaseBean();
        BaseBean bb = new BaseBean();
        bb.writeLog("部门调整Action进入");
        RecordSet rs = new RecordSet();
        RecordSet rsDept = new RecordSet();
        int userid = info.getRequestManager().getUser().getUID();
        String wfid = info.getWorkflowid();
        String reqid = info.getRequestid();
        String tablaName = info.getRequestManager().getBillTableName();
        User userLcc = new User(1);
        try {
            //获取主表数据
            Map mainInfo = getMainInfo(info);
            //操作类型
            String czlx = Util.null2String(mainInfo.get("czlx"));
            //申请人
            String sqr = Util.null2String(mainInfo.get("sqr"));

            if("0".equals(czlx)){
                //新增
                String insertSql = "select bmjl,qc,jc,bmyw,bmbh,sjbm,szgs,xssx,bmzg,bmzj,cbbmdm,cbbmmc,bmjb,kqwy,zxwy,hrbp,qyrq,fcrq \n" +
                        "from "+tablaName+"_dt1 where mainid = (select id from "+tablaName+" where requestId = "+reqid+")";
                rs.executeQuery(insertSql);
                while (rs.next()){
                    //全称
                    String qc = Util.null2String(rs.getString("qc"));
                    String jc = Util.null2String(rs.getString("jc"));
                    String bmyw = Util.null2String(rs.getString("bmyw"));
                    String sjbm = Util.null2String(rs.getString("sjbm"));
                    String bmzg = Util.null2String(rs.getString("bmzg"));
                    String bmzj = Util.null2String(rs.getString("bmzj"));
                    String cbbmdm = Util.null2String(rs.getString("cbbmdm"));
                    String cbbmmc = Util.null2String(rs.getString("cbbmmc"));
                    String bmjb = Util.null2String(rs.getString("bmjb"));
                    String kqwy = Util.null2String(rs.getString("kqwy"));
                    String zxwy = Util.null2String(rs.getString("zxwy"));
                    String hrbp = Util.null2String(rs.getString("hrbp"));
                    String qyrq = Util.null2String(rs.getString("qyrq"));
                    String fcrq = Util.null2String(rs.getString("fcrq"));
                    String xssx = Util.null2String(rs.getString("xssx"));
                    String bmjl = Util.null2String(rs.getString("bmjl"));
                    bb.writeLog("部门"+qc+"新增");
                    Map<String, Object> deptParamMap = new HashMap<>();
                    if (StringUtils.isEmpty(sjbm) || sjbm.equals("0")) {
                        deptParamMap.put("subcompanyid1", "4");
                    } else {
                        rsDept.execute("SELECT subcompanyid1 FROM hrmdepartment WHERE id = " + sjbm);
                        if (rsDept.next()) {
                            deptParamMap.put("subcompanyid1", rsDept.getString("subcompanyid1"));
                        }
                    }
                    deptParamMap.put("departmentmark", jc);
                    deptParamMap.put("departmentname", qc);
                    deptParamMap.put("supdepid", sjbm);
                    deptParamMap.put("coadjutant", "");
                    deptParamMap.put("departmentcode", "");
                    deptParamMap.put("bmfzr", "");
                    deptParamMap.put("showorder", xssx);
                    List<Object> errorList = new ArrayList<>();
                    Map<String, Object> deptResultMap = getOrganizationService(userLcc).addDepartment(deptParamMap, userLcc);
                    if (!String.valueOf(deptResultMap.get("status")).equals("1")) {
                        info.getRequestManager().setMessagecontent((String) deptResultMap.get("message"));
                        bb.writeLog("部门表数据保存失败, 原因：" + deptResultMap.get("message"));
                        errorList.add(jc+"部门表数据新增失败:"+deptResultMap.get("message"));
//                        return Action.FAILURE_AND_CONTINUE;
                    }
                    String deptId = String.valueOf(deptResultMap.get("id"));
                    // 添加部门自定义表数据
                    RecordSet deptDefinedRs = new RecordSet();
                    deptDefinedRs.execute("DELETE FROM hrmdepartmentdefined WHERE DEPTID = " + deptId);
                    String deptDefinedSql = "INSERT INTO hrmdepartmentdefined (DEPTID, bmzj, bmjl, cbbmcw, cbbmdmcw , bmjb," +
                            "hrbp, zxwy, kqwy, qyrq, fcrq, bmyw, bmzg) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?)";
                    boolean deptDefinedResult = deptDefinedRs.executeUpdate(deptDefinedSql, deptId, bmzj, bmjl, cbbmmc, cbbmdm , bmjb,
                            hrbp, zxwy, kqwy, qyrq, fcrq, bmyw, bmzg);
                    bb.writeLog("部门自定义表保存结果：" + deptDefinedResult);
                    // 如果部门自定义表保存失败，则将已保存的部门表数据也删除
                    if (!deptDefinedResult) {
                        info.getRequestManager().setMessagecontent(deptDefinedRs.getExceptionMsg());
                        bb.writeLog("部门自定义表保存失败原因：" + deptDefinedRs.getExceptionMsg());
                        deleteDeptById(deptId);
                        errorList.add(jc+"部门自定义表数据新增失败:"+deptDefinedRs.getExceptionMsg());
//                        return Action.FAILURE_AND_CONTINUE;
                    }
                    //同步部门数据到矩阵
                    MatrixUtil.updateDepartmentData(deptId);
                    if(errorList.size()>0){
                        info.getRequestManager().setMessagecontent(JSONObject.toJSONString(errorList));
                        bb.writeLog("部门新增存在失败的数据：" + JSONObject.toJSONString(errorList));
                        return Action.FAILURE_AND_CONTINUE;
                    }
                }
            }else if("1".equals(czlx)){
                //封存
                Map<String,Object> result = new HashMap<>();
                List<Object> errorList = new ArrayList<>();
                String insertSql = "select bm,fcrq \n" +
                        "from "+tablaName+"_dt2 where mainid = (select id from "+tablaName+" where requestId = "+reqid+")";
                rs.executeQuery(insertSql);
                while (rs.next()){
                    String deptId = Util.null2String(rs.getString("bm"));
                    String fcrq = Util.null2String(rs.getString("fcrq"));
                    bb.writeLog("部门deptId"+deptId+"封存");
                    result = cancel(deptId,userLcc,bb,fcrq);
                    if ("-1".equals(result.get("status"))) {
                        bb.writeLog("部门封存失败：" + result.get("message"));
                        errorList.add(result.get("message"));
//                        return Action.FAILURE_AND_CONTINUE;
                    }
                }
                if(errorList.size()>0){
                    info.getRequestManager().setMessagecontent(JSONObject.toJSONString(errorList));
                    bb.writeLog("部门封存存在失败的数据：" + JSONObject.toJSONString(errorList));
                    return Action.FAILURE_AND_CONTINUE;
                }

            }else if("2".equals(czlx)){
                //调整
                String insertSql = "select xssx,bm,bmjl,qc,jc,bmyw,bmbh,sjbm,ssgs,bbzg,bmzj,cbbmdm,cbbmmc,bmjb,kqwy,zzwy,hrbp,qyrq,fcrq \n" +
                        "from "+tablaName+"_dt3 where mainid = (select id from "+tablaName+" where requestId = "+reqid+")";
                rs.executeQuery(insertSql);
                while (rs.next()){
                    String deptId = Util.null2String(rs.getString("bm"));
                    String bmjl = Util.null2String(rs.getString("bmjl"));
                    String qc = Util.null2String(rs.getString("qc"));
                    String jc = Util.null2String(rs.getString("jc"));
                    String bmyw = Util.null2String(rs.getString("bmyw"));
                    String sjbm = Util.null2String(rs.getString("sjbm"));
                    String ssgs = Util.null2String(rs.getString("ssgs"));
                    String bbzg = Util.null2String(rs.getString("bbzg"));
                    String bmzj = Util.null2String(rs.getString("bmzj"));
                    String cbbmdm = Util.null2String(rs.getString("cbbmdm"));
                    String cbbmmc = Util.null2String(rs.getString("cbbmmc"));
                    String bmjb = Util.null2String(rs.getString("bmjb"));
                    String kqwy = Util.null2String(rs.getString("kqwy"));
                    String zzwy = Util.null2String(rs.getString("zzwy"));
                    String hrbp = Util.null2String(rs.getString("hrbp"));
                    String qyrq = Util.null2String(rs.getString("qyrq"));
                    String fcrq = Util.null2String(rs.getString("fcrq"));
                    String xssx = Util.null2String(rs.getString("xssx"));
                    bb.writeLog("部门调整deptId:"+deptId);
                    if(StringUtils.isNotBlank(deptId)){
                        RecordSet updateRs = new RecordSet();
                        String updateSql = "update hrmdepartment set DEPARTMENTMARK = ?, DEPARTMENTNAME = ?, SUBCOMPANYID1 = ?," +
                                "SUPDEPID = ?,modified = ?,modifier = ?,showorder = ? where id = ?";
                        boolean deptUpdateCheck =  updateRs.executeUpdate(updateSql,jc,qc,ssgs,sjbm,new Date(),sqr,xssx,deptId);

                        updateSql = "update hrmdepartmentdefined set bmzj = ?, bmjl = ?, cbbmcw = ?," +
                                "cbbmdmcw = ?,bmjb = ?,hrbp = ?,zxwy = ?,kqwy = ?,qyrq = ?,fcrq = ?,bmyw = ?,bmzg = ? where deptid = ?";
                        boolean deptDefinedCheck =  updateRs.executeUpdate(updateSql,bmzj,bmjl,cbbmmc,cbbmdm,bmjb,hrbp,zzwy,kqwy,qyrq,fcrq,bmyw,bbzg,deptId);
                        bb.writeLog("deptUpdateCheck:"+deptUpdateCheck+"deptDefinedCheck:"+deptDefinedCheck);
                        //同步部门数据到矩阵
                        MatrixUtil.updateDepartmentData(deptId);
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
            bb.writeLog(e);
            bb.writeLog("固定加班时长写入加班台账error" + e.getMessage());
            info.getRequestManager().setMessageid("2000");
            info.getRequestManager().setMessagecontent("固定加班时长写入加班台账error");
            return Action.FAILURE_AND_CONTINUE;
        }
        return Action.SUCCESS;
    }

    /**
     * @Description: 系统封存部门
     * @Author: liang.cheng
     * @Date: 2023/6/13 2:42 PM
     * @param: [id, user]
     * @return: java.util.Map<java.lang.String,java.lang.Object>
     */
    private  Map<String, Object> cancel(String id,User user,BaseBean bb,String fcrq){
        Map<String, Object> retmap = new HashMap<>();
        try {

            RecordSet rs = new RecordSet();
            DepartmentComInfo DepartmentComInfo = new DepartmentComInfo();
            OrganisationCom OrganisationCom = new OrganisationCom();
            HrmServiceManager HrmServiceManager = new HrmServiceManager();

            String deptorsubname = "";
            String sqlname = "";

            String supdepid = "";
            String subcompanyid1 = "";
            sqlname = "select departmentname, supdepid, subcompanyid1 from hrmdepartment where id = "+id;
            rs.executeSql(sqlname);
            if(rs.next()) {
                deptorsubname = rs.getString("departmentname");
                supdepid = Util.null2String(rs.getString("supdepid"));
                subcompanyid1 = Util.null2String(rs.getString("subcompanyid1"));
            }

            String sqlstr = "select id from hrmresource where status in (0,1,2,3)"
                    + " and EXISTS (select 1 from hrmdepartment b where hrmresource.departmentid=b.id and b.id = "
                    + id +")";
            rs.executeSql(sqlstr);
            if (rs.next()) {
                //部门下有在职的人员
                retmap.put("status", "-1");
                retmap.put("message",id+"部门下有在职的人员");
                return retmap;
            }

            sqlstr = " select id from hrmdepartment where (canceled = '0' or canceled is null) and id in (select id from hrmdepartment where supdepid = "
                    + id + ")";
            rs.executeSql(sqlstr);
            if (rs.next()) {
                //部门存在下级部门
                retmap.put("status", "-1");
                retmap.put("message", id+"部门存在下级部门");
                return retmap;
            }
            rs.executeSql("update hrmdepartment set canceled = '1', "+ DbFunctionUtil.getUpdateSetSql(rs.getDBType(),user.getUID())+" where id ="+ id);
            DepartmentComInfo.removeCompanyCache();

            OrganisationCom.deleteDepartment(Integer.valueOf(id));//部门封存时同步到RTX

            //部门封存时同步到邮件系统
            if("0".equals(supdepid)) {
                CoreMailAPI.synOrg(""+id, deptorsubname, "parent_org_unit_id=com_"+subcompanyid1+"&org_unit_name="+deptorsubname, "1");
                //testapi.synOrg(""+deptorsupid, deptorsubname, "com_"+subcompanyid1, "1");
            } else {
                CoreMailAPI.synOrg(""+id, deptorsubname, "parent_org_unit_id="+supdepid+"&org_unit_name="+deptorsubname, "1");
                //testapi.synOrg(""+deptorsupid, deptorsubname, ""+supdepid, "1");
            }

            //OA与第三方接口单条数据同步方法开始
            HrmServiceManager.SynInstantDepartment(""+id,"3");
            //OA与第三方接口单条数据同步方法结束
            HrmFaceCheckManager.sync(id+"",HrmFaceCheckManager.getOptUpdate(),this.getClass().getName(),HrmFaceCheckManager.getOaDepartment());
            //同步部门数据到矩阵
//            MatrixUtil.updateDepartmentData(""+id);

            String updateSql = "update hrmdepartmentdefined set fcrq = '"+fcrq+"' where deptid = "+id;
            boolean deptDefinedCheck =  rs.executeSql(updateSql);
            bb.writeLog("deptDefinedCheck:"+deptDefinedCheck);
        } catch (Exception e) {
        }
        return retmap;
    }

    /**
     * 部门删除
     * @param deptId
     */
    public static void deleteDeptById(String deptId){
        RecordSet rs = new RecordSet();
        String sql = "delete from hrmdepartment where id = ?";
        rs.executeUpdate(sql,deptId);
    }

    /**
     * 部门新建
     * @param reqid
     */
    public static void insertDeptByWf(String reqid){





    }


    /**
     * 获取主表数据
     *
     * @param requestInfo
     * @return
     */
    private static Map getMainInfo(RequestInfo requestInfo) {
        Map map = new HashMap();
        Property[] property = requestInfo.getMainTableInfo().getProperty();
        for (int i = 0; i < property.length; i++) {
            map.put(property[i].getName().toLowerCase(), Util.null2String(property[i].getValue()));
        }
        return map;
    }

    /**
     * 提供精确的乘法运算。
     *
     * @param v1 被加数
     * @param v2 加数
     * @return 两个参数的和
     */
    public static Double multiply(String v1, String v2) {
        BigDecimal b1 = new BigDecimal(v1);
        BigDecimal b2 = new BigDecimal(v2);
        return b1.multiply(b2).doubleValue();
    }

    /**
     * 提供精确的除法运算。
     *
     * @param v1 被加数
     * @param v2 加数
     * @return 两个参数的和
     */
    public static Double divide(String v1, String v2) {
        BigDecimal b1 = new BigDecimal(v1);
        BigDecimal b2 = new BigDecimal(v2);
        return b1.divide(b2, 2, BigDecimal.ROUND_HALF_UP).doubleValue();
    }

}
