package weaver.interfaces.hskq.action;

import com.alibaba.fastjson.JSON;
import weaver.common.DateUtil;
import weaver.conn.BatchRecordSet;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.interfaces.schedule.BaseCronJob;
import java.util.*;

/**
 * Created with IntelliJ IDEA.
 * 新入职员工当天打卡数据生成
 * @Auther: chenxu
 * @Date: 2024/05/28/14:03
 * @Description:
 */
public class DkCreateEveryDay extends BaseCronJob {

    @Override
    public void execute() {
        new BaseBean();
        BaseBean bb = new BaseBean();
        RecordSet rs = new RecordSet();
        bb.writeLog("新入职员工当天打卡数据生成！！！");
        String nowdate = DateUtil.getCurrentDate();
        try {
            String sql = "select id,lastname from hrmresource where companystartdate = CURDATE() and status <=3";
            rs.executeQuery(sql);
            List<List<Object>> lsParams = new ArrayList<>();
            List<String> lsFormatData = new ArrayList<>();
            while (rs.next()){
                Integer isimport = 1;
                String userid = Util.null2String(rs.getString("id"));
                Integer usertype = 1;
                Integer isincom = 1;
                String signfrom = "OutDataSourceSyn";
                String signDate = nowdate;
                String signTime = "08:30:00";
                List<Object> params = new ArrayList<>();
                params.add(userid);
                params.add(usertype);
                params.add(signDate);
                params.add(signTime);
                params.add("");
                params.add(isincom);
                params.add(isimport);
                params.add(signfrom);
                params.add("");
                params.add("");
                params.add("");
                params.add("入职当天自动生成");
                lsParams.add(params);
                String formatData = userid+"|"+signDate+"|"+signTime;
                if(!lsFormatData.contains(formatData)){
                    lsFormatData.add(formatData);
                }

                boolean isdelte = deleteByInfo(userid,signDate,signTime);
                boolean isok = InsertByInfo(userid,usertype,signDate,signTime,"",isincom,isimport,signfrom,"","","","入职当天自动生成");
                bb.writeLog("isdelte:" + isdelte+"isok:"+isok);
            }

            bb.writeLog("lsParams:"+JSON.toJSONString(lsParams));

            List<Object> delParams = null;
            List<List<Object>> lsDelParams = new ArrayList<>();
            //刷新报表数据
            for(int i=0;lsFormatData!=null&&i<lsFormatData.size();i++){
                String[] formatData = Util.splitString(lsFormatData.get(i),"|");
                delParams = new ArrayList<>();
                delParams.add(formatData[0]);
                delParams.add(formatData[1]);
                delParams.add(formatData[2]);
                lsDelParams.add(delParams);
            }
            bb.writeLog("lsDelParams:"+JSON.toJSONString(lsDelParams));

        } catch (Exception e) {
            e.printStackTrace();
            bb.writeLog(e);
            bb.writeLog("新入职员工当天打卡数据生成--error"+e.getMessage());
        }
    }


    /**
     * 删除
     * @param userId
     * @param signdate
     * @param signtime
     */
    public static Boolean deleteByInfo(String userId,String signdate,String signtime){
        RecordSet rs = new RecordSet();
        String sql = "delete from hrmschedulesign where signfrom='OutDataSourceSyn' and userid =? and signdate = ? and signtime = ? ";
        boolean isdelete = rs.executeUpdate(sql,userId,signdate,signtime);
        return isdelete;
    }

    /**
     * 新增
     * @param userId
     * @param signdate
     * @param signtime
     */
    public static Boolean InsertByInfo(String userId,Integer usertype,String signdate,String signtime,String clientaddress,Integer isincom,Integer isimport,String signfrom,String longitude,String latitude,String addr,String memo){
        RecordSet rs = new RecordSet();
        String sql = " insert into HrmScheduleSign (userid, usertype, signdate, signtime, clientaddress, isincom, isimport, signfrom, longitude, latitude, addr,memo) "
                + " values(?,?,?,?,?,?,?,?,?,?,?,?)";
        boolean isok =  rs.executeUpdate(sql,userId,usertype,signdate,signtime,clientaddress,isincom,isimport,signfrom,longitude,latitude,addr,memo);
        return isok;
    }
}
