package weaver.interfaces.hskq.util;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import weaver.general.StringUtil;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @Author liang.cheng
 * @Date 2023/6/3 2:22 PM
 * @Description:
 * @Version 1.0
 */

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class BatchIdsParams {

    private String ids;

    public List<Integer> getIds() {
        if(StringUtil.isEmpty(ids)){
            return new ArrayList<>();
        }
        return Arrays.stream(ids.split(",")).map(Integer::parseInt).collect(Collectors.toList());
    }
}
