package weaver.interfaces.leshanvc.cronjob;

import com.weaver.general.BaseBean;
import com.weaver.general.Util;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import weaver.conn.RecordSet;
import weaver.hrm.User;
import weaver.hrm.resource.ResourceComInfo;
import weaver.interfaces.schedule.BaseCronJob;
import weaver.soa.workflow.request.MainTableInfo;
import weaver.soa.workflow.request.Property;
import weaver.soa.workflow.request.RequestInfo;
import weaver.soa.workflow.request.RequestService;
import weaver.workflow.request.RequestComInfo;
import weaver.workflow.workflow.WorkflowComInfo;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.HashMap;
import java.util.Map;

/**
 * 定时任务：执行《转正申请流程》
 */
public class ApplyCronJob extends BaseCronJob {
    /**
     * 入职日期
     */
    private String companystartdate;
    /**
     * 部门编码
     */
    private String departmentcode;
    /**
     * 状态
     */
    private String status;
    /**
     * 工作流id
     */
    private String workflowId;
    /**
     * 流程创建人
     */
    private String workFlowCreatorId;

    private static User user;

    @Override
    public void execute() {
        BaseBean bs = new BaseBean();
        bs.writeLog("--定时任务：执行《转正申请流程》--");
        // 处理传入参数
        if (StringUtils.isBlank(companystartdate)) {
            companystartdate = "20";
        }
//        if (StringUtils.isBlank(departmentcode)) {
//            departmentcode = "805";
//        }
        if (StringUtils.isBlank(status)) {
            status = "0";
        }
        // 创建人
        user = new User(Util.getIntValue(workFlowCreatorId));
        String userId = String.valueOf(user.getUID());
        String userName = user.getLastname();

        String IsNextFlow = "1";
        RecordSet rs = new RecordSet();
        // 获取流程相关信息
        rs.execute("select WORKFLOWNAME from workflow_base where id='" + workflowId + "'");
        String workFlowName = null;
        if (rs.next()) {
            workFlowName = Util.null2String(rs.getString("WORKFLOWNAME"));
        }
        // 查询线长字段ID
        rs.executeQuery("select fieldid  from cus_formfield cf  where `SCOPE` = 'HrmCustomFieldByInfoType' and SCOPEID ='-1' and HRM_FIELDLABLE ='线长' ");
        String fieldId = "field";
        if (rs.next()) {
            fieldId = fieldId + rs.getString("fieldid");
        }
        // 计划任务需要处理的逻辑
//        String hrmSql = "select a.id as sqr,a.id as zzr,a.departmentid as szbm, a.loginid as gh,a.companystartdate as rzrq,a.subcompanyid1 as gsmc,managerid,"+fieldId+" as xc from hrmresource a " +
//                "left join hrmdepartment b on a.departmentid=b.id " +
//                "left join cus_fielddata c on a.id=c.id "+
//                "where a.status in (" + status + ") and left(b.DEPARTMENTCODE,3) in (" + departmentcode + ") and c.SCOPE = 'HrmCustomFieldByInfoType' and c.SCOPEID = -1 and to_days(now())-to_days(companystartdate)>'" + companystartdate + "'";
        String hrmSql = "select a.id as sqr,a.id as zzr,a.departmentid as szbm, a.loginid as gh,a.companystartdate as rzrq,a.subcompanyid1 as gsmc,managerid,"+fieldId+" as xc from hrmresource a " +
                "left join hrmdepartment b on a.departmentid=b.id " +
                "left join cus_fielddata c on a.id=c.id "+
                "where a.status in (" + status + ") and c.field35 in (2,3,4) and c.SCOPE = 'HrmCustomFieldByInfoType' and c.SCOPEID = -1 and to_days(now())-to_days(companystartdate)>'" + companystartdate + "'";

        bs.writeLog("待转正人员查询sql：" + hrmSql);
        rs.executeQuery(hrmSql);
        while (rs.next()) {
            Map<String, String> requestMainMap = new HashMap<>();
            //申请人
            requestMainMap.put("sqr", Util.null2String(userId));
            // 转正人
            String zzr = Util.null2String(rs.getString("zzr"));
            requestMainMap.put("zzr", zzr);
            // 公司名称
            requestMainMap.put("gsmc", Util.null2String(rs.getString("gsmc")));
            // 所属部门
            requestMainMap.put("szbm", Util.null2String(rs.getString("szbm")));
            // 人员编号
            requestMainMap.put("gh", Util.null2String(rs.getString("gh")));
            // 入职日期
            requestMainMap.put("rzrq", Util.null2String(rs.getString("rzrq")));
            // 转正日期
            requestMainMap.put("zzrq", Util.null2String(rs.getString("zzrq")));
            // 转正类型
            requestMainMap.put("zzlx", "1");
            // 线长是否建议转正
            requestMainMap.put("xcsfjyzz", "1");
            // 工作效率评价
            requestMainMap.put("gzxlpj", "0");
            // 工作质量评价
            requestMainMap.put("gzzlpj", "0");
            // 配合度评价
            requestMainMap.put("phdpj", "0");
            // 人际关系评价
            requestMainMap.put("rjgxpj", "0");
            // 审批状态
            requestMainMap.put("spzt", "1");
            // 直接上级
            requestMainMap.put("zjsj", Util.null2String(rs.getString("managerid")));
            requestMainMap.put("sqrq", getDate(0));
            // 线长
            requestMainMap.put("xc", Util.null2String(rs.getString("xc")));

            String requestName = workFlowName + "-" + userName + "-" + getDate(0);

            if (!isHave(workflowId, zzr)) {
                bs.writeLog("无在途流程,开始创建" + workFlowName);
                WorkflowCreateByRequestMap(userId, workflowId, requestName, IsNextFlow, requestMainMap);
            } else {
                bs.writeLog(requestName + "(转正人：" + zzr + "),创建失败，存在在途流程");
            }
        }
    }

    /**
     * 判断是否有在途流程
     */
    private Boolean isHave(String workflowId,String zzr) {
        RecordSet recordSet = new RecordSet();
        String sql = "select * from workflow_requestbase a \n" +
                "inner join formtable_main_51 b on a.REQUESTID=b.REQUESTID where a.WORKFLOWID="+workflowId+" and b.zzr="+zzr;
        recordSet.executeQuery(sql);
        return recordSet.next() ? true : false;
    }

    /**
     * @param @param  creatorId    创建人Id
     * @param @param  workflowId   流程Id
     * @param @param  requestName  请求标题
     * @param @param  IsNextFlow   是否提交到下一节点
     * @param @param  requestMap   Map格式的主表数据<fieldname,fieldvalue>=<字段名称,字段值>
     * @param @return 设定文件
     * @return String    返回类型
     * @throws
     * @Title: 自动创建流程
     */
    private String WorkflowCreateByRequestMap(String creatorId, String workflowId, String requestName, String IsNextFlow, Map<String, String> requestMainMap) {
        BaseBean bs = new BaseBean();
        String requestid = "";
        RequestInfo requestInfo = new RequestInfo();
        // 创建人Id
        requestInfo.setCreatorid(creatorId);
        // 工作流Id
        requestInfo.setWorkflowid(workflowId);
        // 请求标题
        requestInfo.setDescription(requestName);
        if (!"".equals(IsNextFlow)) {
            requestInfo.setIsNextFlow(IsNextFlow);
        }
        //主表字段
        MainTableInfo mainTableInfo = new MainTableInfo();
        Property[] propertyArray = new Property[requestMainMap.size()];
        int p = 0;
        for (Map.Entry<String, String> entry : requestMainMap.entrySet()) {
            propertyArray[p] = new Property();
            propertyArray[p].setName(Util.null2String(entry.getKey()));
            propertyArray[p].setValue(Util.null2String(entry.getValue()));
            bs.writeLog("\r\n---p=" + p + "---Key=" + entry.getKey() + "---Value=" + entry.getValue());
            p++;
        }
        bs.writeLog("-----创建流程传递的参数个数p=" + p);
        mainTableInfo.setProperty(propertyArray);
        requestInfo.setMainTableInfo(mainTableInfo);
        RequestService service = new RequestService();
        try {
            //流程
            try {
                //创建请求id
                requestid = service.createRequest(requestInfo);
            } catch (Exception e) {
                bs.writeLog("转正申请流程触发异常" + e.getMessage());
            }
            //记录日志
            StringBuffer sbf = new StringBuffer("\r\n-----xwd创建工作流记录日志开始");
            WorkflowComInfo wfcif = new WorkflowComInfo();
            RequestComInfo rcif = new RequestComInfo();
            ResourceComInfo rscif = new ResourceComInfo();
            sbf.append("\r\n-----姓名:" + rscif.getLastname(rcif.getRequestCreater(requestid)));
            sbf.append("\r\n-----时间:" + rcif.getRequestCreateTime(requestid));
            sbf.append("\r\n-----创建流程:" + wfcif.getWorkflowname(workflowId));
            sbf.append("\r\n-----请求:" + rcif.getRequestname(requestid));
            sbf.append("\r\n-----请求:" + requestid);
            sbf.append("\r\n-----创建工作流记录日志结束");
            bs.writeLog("" + sbf.toString());
        } catch (Exception e) {
            bs.writeLog("错误：" + e);
        }
        return requestid;
    }

    private String getDate(int day) {
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");//设置格式
        Calendar calendar = Calendar.getInstance(); //创建Calendar 的实例
        calendar.add(Calendar.DAY_OF_MONTH, day); //当前时间减去一天，即一天前的时间
        return simpleDateFormat.format(calendar.getTime());
    }

    public String getCompanystartdate() {
        return companystartdate;
    }

    public void setCompanystartdate(String companystartdate) {
        this.companystartdate = companystartdate;
    }

    public String getDepartmentcode() {
        return departmentcode;
    }

    public void setDepartmentcode(String departmentcode) {
        this.departmentcode = departmentcode;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public String getWorkflowId() {
        return workflowId;
    }

    public void setWorkflowId(String workflowId) {
        this.workflowId = workflowId;
    }
}
