package weaver.interfaces.leshanvc.workflow.action;

import org.apache.commons.lang3.StringUtils;
import weaver.conn.RecordSet;
import weaver.formmode.setup.ModeRightInfo;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.hrm.User;
import weaver.hrm.tools.HrmDateCheck;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.Property;
import weaver.soa.workflow.request.RequestInfo;
import weaver.workflow.request.RequestManager;

import javax.servlet.http.HttpServletRequest;
import java.text.SimpleDateFormat;
import java.util.Arrays;
import java.util.Date;
import java.util.UUID;

/**
 * @Author ml
 * @Date 2023/3/24 10:28
 * @Description 员工信息自助更新
 * @Since version-1.0
 */
public class SyncHrmInfoToCardAction implements Action {
    private static String mainTable;
    private static String detailTable1;
    private static String detailTable2;
    private static String detailTable3;
    private static String detailTable4;

    private static RecordSet recordSet = new RecordSet();
    private BaseBean baseBean = new BaseBean();
    private static final String publicField = "formmodeid,modedatacreater,modedatacreatertype,modedatacreatedate,modedatacreatetime,modedatamodifydatetime,MODEUUID,";


    @Override
    public String execute(RequestInfo requestInfo) {
        RequestManager requestManager = requestInfo.getRequestManager();
        BaseBean baseBean = new BaseBean();
        baseBean.writeLog("***员工信息自助更新action***");
        String requestId = requestInfo.getRequestid();//请求ID
        String zzxxlx = null;
        //取主表数据
        try {
            Property[] properties = requestInfo.getMainTableInfo().getProperty();// 获取表单主字段信息
            for (Property property : properties) {
                String name = property.getName();// 主字段名称
                String value = Util.null2String(property.getValue());// 主字段对应的值
                if (name.equals("zzxxlx")) {
                    zzxxlx = value;
                    break;
                }
            }
            if (StringUtils.isNotBlank(zzxxlx)) {
                String[] strings = zzxxlx.split(",");
                for (String s : strings) {
                    handleHrmInfoToCard(recordSet, s, requestId);
                }
            }
        } catch (Exception e) {
            baseBean.writeLog(e);
            requestInfo.getRequestManager().setMessageid("****" + requestInfo.getRequestid() + "****");
            requestInfo.getRequestManager().setMessagecontent("【员工信息自助更新action】报错，请联系管理员！");
            return Action.FAILURE_AND_CONTINUE;
        }
        return Action.SUCCESS;
    }

    void handleHrmInfoToCard(RecordSet rs, String s, String requestId) {
        String updateSql = null;
        String insertSql = null;
        String selectSql = null;
        String resourceId = null;
        switch (s) {
            case "0":
                //更具人员id和学历 判断 插入或更新 建模表主表
                rs.execute("select a.sqr ,b.school ,b.speciality ,b.startdate ,b.enddate ,b.educationlevel ,b.studydesc,b.xllx,b.fj  from " + mainTable + " a\n" +
                        "inner join " + detailTable1 + " b on a.id = b.mainid \n" +
                        "where requestid ='" + requestId + "' ");
                while (rs.next()) {
                    String sqr = Util.null2String(rs.getString("sqr"));
                    String school = Util.null2String(rs.getString("school"));
                    String speciality = Util.null2String(rs.getString("speciality"));
                    String startdate = Util.null2String(rs.getString("startdate"));
                    String enddate = Util.null2String(rs.getString("enddate"));
                    String educationlevel = Util.null2String(rs.getString("educationlevel"));
                    String studydesc = Util.null2String(rs.getString("studydesc"));
                    String xllx = Util.null2String(rs.getString("xllx"));
                    String fj = Util.null2String(rs.getString("fj"));
                    String workcode = getWorkcode(sqr);
                    resourceId = sqr;
                    if("1".equals(xllx)){
                        //更新花名册表
                        updateSql = "update hrmeducationinfo set school= '"+school+"',speciality='"+speciality+"',startdate='"+startdate+"',enddate='"+enddate+"',educationlevel='"+educationlevel+"',studydesc='"+studydesc+"' where RESOURCEID ='"+sqr+"' ";
                        insertSql = "INSERT INTO HrmEducationInfo (resourceid, startdate, enddate, school, speciality , educationlevel, studydesc)\n" +
                                "VALUES ('"+sqr+"', '"+startdate+"', '"+enddate+"', '"+school+"', '"+speciality+"' , '"+educationlevel+"', '"+studydesc+"')";
                        selectSql = "select * from HrmEducationInfo where RESOURCEID='"+sqr+"'";

                        String hrmupdate = "update hrmresource set educationlevel = '"+educationlevel+"' where id = '"+sqr+"'";
//                        String cusupdate = "update cus_fielddata set field108 = '"+fj+"' where id = '"+sqr+"' and scope = 'HrmCustomFieldByInfoType' and scopeid = 1";
                        updateHrmInfo(selectSql,updateSql,insertSql,hrmupdate);
                    }

//                    updateSql = "update uf_hrmeducationinfo set school= '" + school + "',speciality='" + speciality + "',startdate='" + startdate + "',enddate='" + enddate + "',educationlevel='" + educationlevel + "',studydesc='" + studydesc + "',workcode= '" + workcode + "',xllx= '" + xllx + "',fj='" + fj + "' ,modedatamodifydatetime=curtime() where RESOURCEID ='" + sqr + "' and educationlevel = '" + educationlevel + "'";
//                    insertSql = "INSERT INTO uf_hrmeducationinfo (resourceid, startdate, enddate, school, speciality , educationlevel, studydesc, workcode, xllx, fj,formmodeid,modedatacreatedate,modedatacreater)\n" +
//                            "VALUES ('" + sqr + "', '" + startdate + "', '" + enddate + "', '" + school + "', '" + speciality + "' , '" + educationlevel + "', '" + studydesc + "', '" + workcode + "', '" + xllx + "', '" + fj + "' ,37,date_format(now(),'%Y-%m-%d'),curtime())";
//                    selectSql = "select * from uf_hrmeducationinfo where RESOURCEID='" + sqr + "' and educationlevel = '" + educationlevel + "'";
//
//                    updateHrmEducationInfo(selectSql,updateSql,insertSql,"");

                    String businessFields = "resourceid, startdate, enddate, school, speciality , educationlevel, studydesc, workcode, xllx, fj";
                    String businessFieldValues =  "'"+ sqr + "', '" + startdate + "', '" + enddate + "', '" + school + "', '" + speciality + "' , '" + educationlevel + "', '" + studydesc + "', '" + workcode + "', '" + xllx + "', '" + fj + "' ";
                    insertUfData("uf_hrmeducationinfo",businessFields,businessFieldValues);
                }
                break;
            case "1":
                rs.executeQuery("select sqr, hyzk from " + mainTable + " where requestid = ?", requestId);
                if (rs.next()) {
                    String sqr = Util.null2String(rs.getString("sqr"));
                    String hyzk = Util.null2String(rs.getString("hyzk"));
                    resourceId = sqr;
                    updateSql = "update hrmresource set MARITALSTATUS='" + hyzk + "' where id= '" + sqr + "'";
                }
                updateHrmInfo(selectSql,updateSql,insertSql,"");
                break;
            case "2":
                rs.executeQuery("select sqr,lxrxm,gx,lxfs,dz,bz from " + mainTable + " where requestid = ?", requestId);
                if (rs.next()) {
                    String sqr = Util.null2String(rs.getString("sqr"));
                    String lxrxm = Util.null2String(rs.getString("lxrxm"));
                    String gx = Util.null2String(rs.getString("gx"));
                    String lxfs = Util.null2String(rs.getString("lxfs"));
                    String dz = Util.null2String(rs.getString("dz"));
                    String bz = Util.null2String(rs.getString("bz"));
                    resourceId = sqr;

                    String lxrxmField = getField("1", "联系人姓名");
                    String gxField = getField("1", "关系");
                    String lxfsField = getField("1", "联系方式");
                    String dzField = getField("1", "地址");
                    String bzField = getField("1", "备注");
                    updateSql = "update cus_fielddata set " + lxrxmField + "='" + lxrxm + "', " + gxField + "='" + gx + "', " + lxfsField + "='" + lxfs + "', " + dzField + "='" + dz + "', " + bzField + "='" + bz + "' where SCOPE ='HrmCustomFieldByInfoType' and SCOPEID ='1' and id='" + sqr + "'";
                    insertSql = "insert into cus_fielddata (scope,scopeid,id," + lxrxmField + "," + gxField + "," + lxfsField + "," + dzField + "," + bzField + ") " +
                            "values('HrmCustomFieldByInfoType','1','" + sqr + "','" + lxrxm + "','" + gx + "','" + lxfs + "','" + dz + "','" + bz + "') ";
                    selectSql = "select * from cus_fielddata where SCOPE ='HrmCustomFieldByInfoType' and SCOPEID ='1' and id='" + sqr + "'";
                }
                updateHrmInfo(selectSql,updateSql,insertSql,"");
                break;
            case "3":// 工资福利
                rs.executeQuery("select a.sqr ,b.yhzh ,b.khh ,b.khhdz  from " + mainTable + " a \n" +
                        "inner join " + detailTable2 + " b on a.id =b.mainid \n" +
                        "where a.requestid ='" + requestId + "'");
                while (rs.next()) {
                    String sqr = Util.null2String(rs.getString("sqr"));
                    String yhzh = Util.null2String(rs.getString("yhzh"));
                    String khh = Util.null2String(rs.getString("khh"));
                    String khhdz = Util.null2String(rs.getString("khhdz"));
                    resourceId = sqr;

//                    updateSql = "update uf_gzfl set yhzh='" + yhzh + "',yhhm='" + khh + "',khhdz='" + khhdz + "',modedatamodifydatetime = curtime(),modedatamodifier='" + sqr + "' where ry='" + sqr + "'";
//                    insertSql = "insert into uf_gzfl (yhhm,yhzh,ry,khhdz,formmodeid,modedatacreatedate,modedatacreater) " +
//                            "values ('" + khh + "','" + yhzh + "','" + sqr + "','" + khhdz + "',30,date_format(now(),'%Y-%m-%d'),'" + sqr + "')";
//                    selectSql = "select * from uf_gzfl where ry='" + sqr + "'";

                    String businessFields = "yhhm,yhzh,ry,khhdz";
                    String businessFieldValues =  "'" + khh + "','" + yhzh + "','" + sqr + "','" + khhdz + "'";
                    insertUfData("uf_gzfl",businessFields,businessFieldValues);
                }
                break;
            case "4"://家庭信息
                rs.executeQuery("select a.sqr ,b.ry ,b.gx ,b.lxfs ,b.zz ,b.csrq ,b.xb from " + mainTable + " a\n" +
                        "inner join " + detailTable3 + " b on a.id = b.mainid \n" +
                        "where a.requestid ='" + requestId + "' ");
                while (rs.next()) {
                    String sqr = Util.null2String(rs.getString("sqr"));
                    String ry = Util.null2String(rs.getString("ry"));
                    String gx = Util.null2String(rs.getString("gx"));
                    String lxfs = Util.null2String(rs.getString("lxfs"));
                    String zz = Util.null2String(rs.getString("zz"));
                    String csrq = Util.null2String(rs.getString("csrq"));
                    String xb = Util.null2String(rs.getString("xb"));
                    resourceId = sqr;

//                    updateSql = "update uf_jt set xm = '" + ry + "' ,gx = '" + gx + "' ,lxfs = '" + lxfs + "' ,zz = '" + zz + "' ,csrq= '" + csrq + "' ,xb = '" + xb + "',modedatamodifydatetime=curtime() where ry = '" + sqr + "' ";
//                    insertSql = "insert into uf_jt (xm,gx,lxfs,zz,csrq,xb,ry,formmodeid,modedatacreatedate,modedatacreatetime,modedatacreater) values" +
//                            " ('" + ry + "','" + gx + "','" + lxfs + "','" + zz + "','" + csrq + "','" + xb + "','" + sqr + "',4,date_format(now(),'%Y-%m-%d'),curtime(),'" + sqr + "')";
//                    selectSql = "select * from uf_jt where ry = '" + sqr + "' ";

                    String businessFields = "xm,gx,lxfs,zz,csrq,xb,ry";
                    String businessFieldValues =  "'" + ry + "','" + gx + "','" + lxfs + "','" + zz + "','" + csrq + "','" + xb + "','" + sqr + "'";
                    insertUfData("uf_jt",businessFields,businessFieldValues);
                }
                break;
            case "5"://人力资源工作经历表（入职前）
                rs.executeQuery("select a.sqr ,b.gsmc ,b.kssj ,b.jssj ,b.zw ,b.gzms ,b.leavereason  from " + mainTable + " a\n" +
                        "inner join " + detailTable4 + " b on a.id = b.mainid \n" +
                        "where requestid ='" + requestId + "'");
                while (rs.next()) {
                    String sqr = Util.null2String(rs.getString("sqr"));
                    String gsmc = Util.null2String(rs.getString("gsmc"));
                    String kssj = Util.null2String(rs.getString("kssj"));
                    String jssj = Util.null2String(rs.getString("jssj"));
                    String zw = Util.null2String(rs.getString("zw"));
                    String gzms = Util.null2String(rs.getString("gzms"));
                    resourceId = sqr;

                    String leavereason = Util.null2String(rs.getString("leavereason"));
                    updateSql = "update hrmworkresume set company = '" + gsmc + "' ,startdate = '" + kssj + "' ,enddate = '" + jssj + "' ," +
                            "jobtitle = '" + zw + "',workdesc = '" + gzms + "' ,leavereason = '" + leavereason + "' where resourceid = '" + sqr + "'";
                    insertSql = "INSERT INTO hrmworkresume\n" +
                            "(RESOURCEID, STARTDATE, ENDDATE, COMPANY, JOBTITLE, WORKDESC, LEAVEREASON)\n" +
                            "VALUES('" + sqr + "', '" + kssj + "', '" + jssj + "', '" + gsmc + "', '" + gzms + "', NULL, '" + leavereason + "')";
                    selectSql = "select * from hrmworkresume where resourceid = '" + sqr + "'";
                    updateHrmInfo(selectSql,updateSql,insertSql,"");
                }
                break;
            case "6":
                rs.executeQuery("select sqr, shglqsr from " + mainTable + " where requestid = '" + requestId + "'");
                if (rs.next()) {
                    String sqr = Util.null2String(rs.getString("sqr"));
                    String shglqsr = Util.null2String(rs.getString("shglqsr"));
                    resourceId = sqr;

                    updateSql = "update hrmresource set workstartdate = '" + shglqsr + "' where id = '" + sqr + "'";
                    updateHrmInfo(selectSql,updateSql,insertSql,"");
                }
                break;
            default:
                break;
        }
//        boolean flag = false;
//        if(!"0".equals(s)){
//            if (selectSql != null) {
//                new BaseBean().writeLog("---selectSql:"+selectSql);
//                rs.execute(selectSql);
//                if (rs.next()) {
//                    flag = true;
//                }
//                if (flag) {
//                    rs.execute(updateSql);
//                    new BaseBean().writeLog("---updateSql:"+updateSql);
//                } else {
//                    rs.execute(insertSql);
//                    new BaseBean().writeLog("---insertSql:"+insertSql);
//                }
//            } else {
//                if (updateSql != null) {
//                    rs.execute(updateSql);
//                }
//            }
//        }
        if (resourceId != null ) {
            new HrmDateCheck().calWorkInfo(resourceId);
        }
    }




    private void updateHrmInfo(String selectSql,String updateSql,String insertSql,String hrmupdate){
        RecordSet rs = new RecordSet();
        boolean flag = false;
        new BaseBean().writeLog("--updateHrmInfo-selectSql:"+selectSql);

        new BaseBean().writeLog("--updateHrmInfo-updateSql:"+updateSql);

        new BaseBean().writeLog("--updateHrmInfo-insertSql:"+insertSql);

        new BaseBean().writeLog("--updateHrmInfo-hrmupdate:"+hrmupdate);

        if (selectSql != null) {
            rs.execute(selectSql);
            if (rs.next()) {
                flag = true;
            }
            if (flag) {
                rs.execute(updateSql);
            } else {
                rs.execute(insertSql);
            }
        } else {
            if (updateSql != null) {
                rs.execute(updateSql);
            }
        }
        if(!"".equals(hrmupdate)){
            rs.execute(hrmupdate);
        }
    }

    private String getField(String scopeId, String labelName) {
        RecordSet recordSet = new RecordSet();
        recordSet.executeQuery("select FIELDID from cus_formfield where SCOPE ='HrmCustomFieldByInfoType' and SCOPEID = ? and HRM_FIELDLABLE =?", scopeId, labelName);
        return recordSet.next() ? "field" + Util.null2String(recordSet.getString("FIELDID")) : null;
    }

    private String getWorkcode(String userid) {
        String workcode = "";
        RecordSet rs = new RecordSet();
        rs.execute("select workcode from hrmresource where id = '" + userid + "'");
        while (rs.next()) {
            workcode = Util.null2String(rs.getString("workcode"));
        }
        return workcode;
    }

    /**
     * @Author ml
     * @Date 2024/3/12 19:24
     * @Description 获取公共部分字段数据
     * @Param [tableName]
     * @Return java.lang.String
     */
    private static String getPublicFieldData(String tableName) {
        RecordSet rs = new RecordSet();
        // 权限重构所需字段
        SimpleDateFormat format1 = new SimpleDateFormat("yyyy-MM-dd");
        SimpleDateFormat format2 = new SimpleDateFormat("HH:mm:ss");
        SimpleDateFormat format3 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String currentDate = format1.format(new Date());
        String currentTime = format2.format(new Date());
        String currentDateTime = format3.format(new Date());
        String modeDataCreater = "1";
        String modeDataCreaterType = "0";
        String formmodeid = "";
        String sql = "select k.id from modeinfo k inner join workflow_bill l on formid = l.id where l.tablename = '" + tableName + "'";
        rs.execute(sql);
        if (rs.next()) {
            formmodeid = com.wbi.util.Util.null2String(rs.getString("id"));
        }
        return "'" + formmodeid + "','" + modeDataCreater + "','" + modeDataCreaterType + "','" + currentDate + "','" + currentTime + "','" + currentDateTime + "',";
    }


    public boolean insertUfData(String tableName, String businessFields, String businessFieldValues) {

        RecordSet recordSet = new RecordSet();
        String publicFieldData = getPublicFieldData(tableName);
        String fields = publicField + businessFields;
        String modeUuid = UUID.randomUUID().toString();
        String fieldsData = publicFieldData + "'" + modeUuid + "'," + businessFieldValues;
        String insertSql = "insert into " + tableName + "(" + fields + ") values(" + fieldsData + ")";
        baseBean.writeLog("建模数据插入sql:", insertSql);
        try {
            recordSet.execute(insertSql);
            recordSet.execute("select id from " + tableName + " where modeUuid='" + modeUuid + "'");
            if (recordSet.next()) {
                /*重构权限*/
                // 建模数据的id
                int bid = com.wbi.util.Util.getIntValue(recordSet.getString("id"));
                // ModeRightInfo对应的类：weaver.formmode.setup.ModeRightInfo
                ModeRightInfo modeRightInfo = new ModeRightInfo();
                modeRightInfo.setNewRight(true);
                // 新建的时候添加共享
                modeRightInfo.editModeDataShare(1, getFormModeId(tableName), bid);
            }
        } catch (Exception e) {
            baseBean.writeLog("建模数据插入--ERROR:", e);
            return false;
        }
        return true;
    }

    /**
     *  获取模块Id
     * @param tableName
     * @return
     */
    private static int getFormModeId(String tableName) {
        int formModeId;
        RecordSet recordSet = new RecordSet();
        recordSet.execute("select b.id from workflow_bill a,modeinfo b where a.id=b.formid and a.tablename='" + tableName + "'");
        recordSet.next();
        formModeId = Util.getIntValue(recordSet.getString("id"));
        return formModeId;
    }

    public static String getMainTable() {
        return mainTable;
    }

    public static void setMainTable(String mainTable) {
        SyncHrmInfoToCardAction.mainTable = mainTable;
    }

    public static String getDetailTable1() {
        return detailTable1;
    }

    public static void setDetailTable1(String detailTable1) {
        SyncHrmInfoToCardAction.detailTable1 = detailTable1;
    }

    public static String getDetailTable2() {
        return detailTable2;
    }

    public static void setDetailTable2(String detailTable2) {
        SyncHrmInfoToCardAction.detailTable2 = detailTable2;
    }

    public static String getDetailTable3() {
        return detailTable3;
    }

    public static void setDetailTable3(String detailTable3) {
        SyncHrmInfoToCardAction.detailTable3 = detailTable3;
    }

    public static String getDetailTable4() {
        return detailTable4;
    }

    public static void setDetailTable4(String detailTable4) {
        SyncHrmInfoToCardAction.detailTable4 = detailTable4;
    }
}
