package weaver.workflow.dmlaction.commands.actions;

import java.lang.reflect.Array;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.commons.lang.StringUtils;

import weaver.conn.ConnStatement;
import weaver.conn.ConnStatementDataSource;
import weaver.conn.RecordSet;
import weaver.conn.RecordSetDataSource;
import weaver.conn.RecordSetTrans;
import weaver.general.BaseBean;
import weaver.general.GCONST;
import weaver.general.Util;
import weaver.hrm.company.DepartmentComInfo;
import weaver.hrm.company.SubCompanyComInfo;
import weaver.hrm.resource.ResourceComInfo;
import weaver.integration.logging.Logger;
import weaver.integration.logging.LoggerFactory;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.Cell;
import weaver.soa.workflow.request.DetailTable;
import weaver.soa.workflow.request.Property;
import weaver.soa.workflow.request.RequestInfo;
import weaver.soa.workflow.request.Row;
import weaver.workflow.dmlaction.DBTypeUtil;
import weaver.workflow.request.RequestManager;
import weaver.workflow.workflow.GetShowCondition;

public class DMLAction extends BaseBean implements Action {
    private static Logger newlog = LoggerFactory.getLogger(DMLAction.class);
	private int workflowid;
	private int nodeid;
	private int nodelinkid;
	private int ispreoperator;
	private int actionid;
	private String isNewMark;// 表示是70新的节点后动作开发的标识
	private String baseid;// 表示是70新的节点后动作的集成浏览按钮的id
	private Map<String, String> attr;

	public String getBaseid() {
		return baseid;
	}

	public void setBaseid(String baseid) {
		this.baseid = baseid;
	}

	public int getActionid() {
		return actionid;
	}

	public void setActionid(int actionid) {
		this.actionid = actionid;
	}

	public int getWorkflowid() {
		return workflowid;
	}

	public void setWorkflowid(int workflowid) {
		this.workflowid = workflowid;
	}

	public int getNodeid() {
		return nodeid;
	}

	public void setNodeid(int nodeid) {
		this.nodeid = nodeid;
	}

	public int getNodelinkid() {
		return nodelinkid;
	}

	public void setNodelinkid(int nodelinkid) {
		this.nodelinkid = nodelinkid;
	}

	public int getIspreoperator() {
		return ispreoperator;
	}

	public void setIspreoperator(int ispreoperator) {
		this.ispreoperator = ispreoperator;
	}

	/**
	 * 执行dmlaction
	 */
	public String execute(RequestInfo request) {

		if (workflowid <= 0 || (nodeid < 0 && nodelinkid < 0)) {
			return this.SUCCESS;
		}
		try {
			RecordSetTrans rst = request.getRsTrans();
			RecordSet rs = new RecordSet();
			// 获取dmlaction 属性
			List dmlList = this.getDmlActionSet(rst, rs);


			newlog.info("获取dmlaction 属性 dmlList : " + dmlList.size());
			Property[] properties = request.getMainTableInfo().getProperty();// 获取表单主字段信息
			int requestid = request.getRequestManager().getRequestid();
			int billid = request.getRequestManager().getBillid();
			int formid = request.getRequestManager().getFormid();
			int isbill = request.getRequestManager().getIsbill();
			newlog.info("requestid:" + requestid + "	billid:" + billid);
			newlog.info("properties.length:" + properties.length);
			/*int plength = properties.length;
			properties = (Property[]) expand(properties, plength + 2);

			Property Property = new Property();
			Property.setName("requestid");
			Property.setValue(String.valueOf(requestid));
			properties[plength] = Property;

			Property = new Property();
			Property.setName("id");
			Property.setValue(String.valueOf(billid));
			properties[plength + 1] = Property;*/
			properties = this.setPropertys(properties, request);
			List<Property[]> propertiesList = new ArrayList<Property[]>();
			RequestManager manager = request.getRequestManager();
			attr = new HashMap<String, String>();
			loadProperty(manager.getUser());// 装载节点操作者相关信息
			loadProperty(manager);// 装载流程当前请求信息
			loadMainInfotoProp(properties, request.getDetailTableInfo()
					.getDetailTable());
			if (dmlList.size() > 0) {
				String fieldname = "";
				List fieldtypeList = new ArrayList();
				List fieldnameList = new ArrayList();
				List fieldvalueList = new ArrayList();
				List sqlsetList = new ArrayList();
				for (int i = 0; i < dmlList.size(); i++) {
					sqlsetList.clear();
					propertiesList.clear();
					sqlsetList = (List) dmlList.get(i);
					newlog.info("***************************************dml action start***************************************");
					newlog.info("获取数据值 sqlsetList : " + sqlsetList
							+ " sqlsetList.size() : " + sqlsetList.size());
					if (null != sqlsetList && sqlsetList.size() > 12) {
						String dmlactionname="";
						try {
							String sqlsetid = (String) sqlsetList.get(0);
							String datasourceid = (String) sqlsetList.get(1);
							String dmltype = (String) sqlsetList.get(2);
							String dmlsql = (String) sqlsetList.get(3);
							String dmlfieldtypes = (String) sqlsetList.get(4);
							String dmlfieldnames = (String) sqlsetList.get(5);
							String dmlcuswhere = (String) sqlsetList.get(6);
							String dmlmainsqltype = (String) sqlsetList.get(7);
							String dmlcussql = (String) sqlsetList.get(8);
							dmlactionname = (String) sqlsetList.get(9);
							
							if(dmltype.equals("insert")){
								dmlcuswhere="";
							}
							
							String dmlcuswherebak = dmlcuswhere;
							String dmlcussqlbak = dmlcussql;

							int dmlsource = Util.getIntValue(Util.null2String(sqlsetList.get(10)),-1);
							String dmlsourcetype = Util.null2String(sqlsetList.get(11));
							int dmlsourceorder = Util.getIntValue(Util.null2String(sqlsetList.get(12)),0);
							
							Map<String,String> fieldIdeMap = new HashMap<String, String>();    //fieldid
							Map<String,String> fieldHtmlTypeMap = new HashMap<String, String>();   //field htmltype
							Map<String,String> fieldTypeMap = new HashMap<String, String>();     //field type
							Map<String,String> fieldDbTypeMap = new HashMap<String, String>();     //field dbtype
							
							
							//获取当前action对应的表单字段的信息，包含主表和明细表（如果有）
							getFieldsInfo(rst, rs, formid, isbill,fieldIdeMap,fieldHtmlTypeMap, fieldTypeMap,fieldDbTypeMap,dmlsource);   
							
							//获取映射信息
							Map<String,Map<String,String>> fieldMapSet = getFieldMapSet(rst, rs, sqlsetid,null);
							if("detail".equals(dmlsourcetype)){
								String detailTable = getDetailTable(rst, rs, formid, isbill, dmlsource);   //获取明细表名称
								propertiesList = loadDetail(properties, request, detailTable);   //加载明细表数据
							}else{
								propertiesList.add(properties);  //主表数据
							}
							fieldtypeList.clear();
							fieldnameList.clear();

							fieldnameList = Util.TokenizerString(dmlfieldnames,
									"|");
							fieldtypeList = Util.TokenizerString(dmlfieldtypes,
									"|");

							for(Property [] props : propertiesList){
								fieldvalueList.clear();
								// 获取数据值
								this.getFieldValues(rst,rs,fieldname, props,fieldIdeMap,
										fieldHtmlTypeMap, fieldTypeMap,fieldDbTypeMap,fieldMapSet,
										fieldtypeList, fieldnameList,
										fieldvalueList,request);
								newlog.info("获取数据值 fieldtypeList : " + fieldtypeList
										+ "    fieldnameList : " + fieldnameList
										+ "   fieldvalueList : " + fieldvalueList);
								// 替换自定义条件sql的值
								String dmlcuswhere2 = this.setDmlCusSqlOrWhereValues(
										fieldname, props, dmlcuswherebak);
								// 替换自定dml sql的值
								String dmlcussql2 = this.setDmlCusSqlOrWhereValues(
										fieldname, props, dmlcussqlbak);
								// 以sql的形式执行dmlaction
								dmlcussql2 = loadTableInfo(dmlcussql2, requestid,
										formid, isbill, rst, rs, dmltype);
								dmlcussql2 = setDmlCusSqlValues(dmlcussql2);
								dmlcussql2 = dmlcussql2.replaceAll("\r", " ").replaceAll("\n", " ");//处理sql语句中的回车换行符
//								this.executeDMLAction(rst, rs, datasourceid,
//										dmltype, dmlsql, fieldtypeList,
//										fieldvalueList, dmlcuswhere2.trim(),
//										dmlmainsqltype, dmlcussql2.trim());
								this.executeDMLActionNew(rst, rs, datasourceid,
										dmltype, dmlsql, fieldtypeList,
										fieldvalueList, dmlcuswhere2.trim(),
										dmlmainsqltype, dmlcussql2.trim());
							}
						} catch (Exception e) {
							e.printStackTrace();
							newlog.error("dmlaction e : " + e);
							return StringUtils.isBlank(dmlactionname)?"-1":"-1,"+dmlactionname+" \n ErrorMsg : "+e;
						}
					}
					newlog.info("***************************************dml action end***************************************");
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
			newlog.error("dml action执行出错 dmlaction e : " + e);
			return "-1";
		}
		return this.SUCCESS;
	}
	private Property[] setPropertys(Property[] properties,RequestInfo request)
	{
		int requestid = request.getRequestManager().getRequestid();
		int workflowid = request.getRequestManager().getWorkflowid();
		int billid = request.getRequestManager().getBillid();
		int formid = request.getRequestManager().getFormid();
		int nodeid = request.getRequestManager().getNodeid();
		String nodetype = request.getRequestManager().getNodetype();
		String requestname = request.getRequestManager().getRequestname();
		String remark = request.getRequestManager().getRemark();
		int creater = request.getRequestManager().getCreater();
		ResourceComInfo ResourceComInfo = null;
		try
		{
			ResourceComInfo = new ResourceComInfo();
		}
		catch(Exception e)
		{
			
		}
		String createrdepartment = ResourceComInfo.getDepartmentID(""+creater);
		int userid = request.getRequestManager().getUserId();
		String lastname = ResourceComInfo.getLastname(""+userid);
		String usersubcompany = ResourceComInfo.getSubCompanyID(""+userid);
		String userdepartment = ResourceComInfo.getDepartmentID(""+userid);
		String managerid = ResourceComInfo.getManagerID(""+userid);
		String managerstr = ResourceComInfo.getManagersIDs(""+userid);
		newlog.info("requestid:"+requestid+"	billid:"+billid);
		newlog.info("properties.length:"+properties.length);
		
		int plength = properties.length;
		properties = (Property[]) expand(properties,plength+16);
		
		Property Property = new Property();
		Property.setName("id");
		Property.setValue(String.valueOf(billid));
		properties[plength] = Property;
		
		Property = new Property();
		Property.setName("requestid");
		Property.setValue(String.valueOf(requestid));
		properties[plength+1] = Property;
		
		
		Property = new Property();
		Property.setName("s.workflowid");
		Property.setValue(String.valueOf(workflowid));
		properties[plength+2] = Property;
		
		
		/*流程类型ID	s.workflowid	int
		表单ID	s.formid	int
		当前节点ID	s.nodeid	int
		当前节点类型	s.nodetype	int
		请求标题	s.requestname	varchar
		签字意见	s.remark	varchar
		请求创建人	s.creater	int
		请求创建人部门	s.createrdepartment	int
		节点操作者姓名	s.lastname	int
		用户ID	s.userid	int
		节点操作者分部	s.usersubcompany	int
		节点操作者部门	s.userdepartment	int
		节点操作者上级	s.managerid	int
		节点操作者所有上级	s.managerstr	varchar*/
		
		Property = new Property();
		Property.setName("s.formid");
		Property.setValue(String.valueOf(formid));
		properties[plength+3] = Property;

		Property = new Property();
		Property.setName("s.nodeid");
		Property.setValue(String.valueOf(nodeid));
		properties[plength+4] = Property;
		
		Property = new Property();
		Property.setName("s.nodetype");
		Property.setValue(String.valueOf(nodetype));
		properties[plength+5] = Property;
		
		Property = new Property();
		Property.setName("s.requestname");
		Property.setValue(String.valueOf(requestname));
		properties[plength+6] = Property;
		
		Property = new Property();
		Property.setName("s.remark");
		Property.setValue(String.valueOf(remark));
		properties[plength+7] = Property;
		
		Property = new Property();
		Property.setName("s.creater");
		Property.setValue(String.valueOf(creater));
		properties[plength+8] = Property;
		
		Property = new Property();
		Property.setName("s.createrdepartment");
		Property.setValue(String.valueOf(createrdepartment));
		properties[plength+9] = Property;
		
		Property = new Property();
		Property.setName("s.lastname");
		Property.setValue(String.valueOf(lastname));
		properties[plength+10] = Property;
		
		Property = new Property();
		Property.setName("s.userid");
		Property.setValue(String.valueOf(userid));
		properties[plength+11] = Property;
		
		Property = new Property();
		Property.setName("s.usersubcompany");
		Property.setValue(String.valueOf(usersubcompany));
		properties[plength+12] = Property;
		
		Property = new Property();
		Property.setName("s.userdepartment");
		Property.setValue(String.valueOf(userdepartment));
		properties[plength+13] = Property;
		
		Property = new Property();
		Property.setName("s.managerid");
		Property.setValue(String.valueOf(managerid));
		properties[plength+14] = Property;
		
		Property = new Property();
		Property.setName("s.managerstr");
		Property.setValue(String.valueOf(managerstr));
		properties[plength+15] = Property;
		return properties;
	}
	/**
	 * 获取dmlaction 属性
	 * 
	 * @param rst
	 * @param rs
	 * @return
	 * @throws Exception
	 */
	private List getDmlActionSet(RecordSetTrans rst, RecordSet rs)
			throws Exception {
		List dmlList = new ArrayList();
		StringBuffer sqlsb = new StringBuffer();
		sqlsb.append("select t.id,");
		sqlsb.append("  f.datasourceid,");
		sqlsb.append("  f.dmltype,");
		sqlsb.append("  t.dmlsql,");
		sqlsb.append("  t.dmlfieldtypes,");
		sqlsb.append("  t.dmlfieldnames,");
		sqlsb.append("  t.dmlcuswhere,");
		sqlsb.append("  t.dmlmainsqltype,");
		sqlsb.append("  t.dmlcussql,");
		sqlsb.append("  f.dmlactionname,");
		
		sqlsb.append("  f.dmlsource,");
		sqlsb.append("  f.dmlsourcetype,");
		sqlsb.append("  f.dmlsourceorder");
		
		sqlsb.append("	  from workflowactionset s, formactionset f,formactionsqlset t");
		if (rs.getDBType().equals("oracle")){
			sqlsb.append("	 where s.interfaceid = to_char(f.id) and f.id=t.actionid ");
		}
		else if (rs.getDBType().equals("postgresql")){
			sqlsb.append("	 where s.interfaceid = to_char(f.id) and f.id=t.actionid ");
		}
		else if(rs.getDBType().equals("mysql")){
			sqlsb.append("	 where s.interfaceid = concat(f.id,'') and f.id=t.actionid ");
		} else {
			sqlsb.append("	 where s.interfaceid = cast(f.id as varchar) and f.id=t.actionid ");
		}
		sqlsb.append("	   and s.workflowid =" + workflowid);
		/**
		 * nodeid -2  强制收回附加操作
		 * nodeid -3  流程删除附加操作
		 */
		if (nodeid > 0 || nodeid == -2 || nodeid == -3) {
			sqlsb.append("	   and s.nodeid =" + nodeid);
			if ((null != rs && rs.getDBType().equals("oracle"))
					|| (null != rst && rst.getDBType().equals("oracle"))) {
				sqlsb.append("	   and nvl(s.ispreoperator, 0) = "
						+ ispreoperator);
			} else if(rs.getDBType().equals("mysql")){
				sqlsb.append("	   and ifnull(s.ispreoperator, 0) = " + ispreoperator);
			} else {
				sqlsb.append("	   and isnull(s.ispreoperator, 0) = "
						+ ispreoperator);
			}
		}
		if (nodelinkid > 0) {
			sqlsb.append("	   and s.nodelinkid = " + nodelinkid);
		}
		if (actionid > 0) {
			sqlsb.append(" and t.actionid=" + actionid);
		}
		sqlsb.append("	 order by s.actionorder");
		
		newlog.info("获取dmlaction 属性 sqlsb : " + sqlsb.toString());
		if (null != rst) {
			rst.executeSql(sqlsb.toString());
			if (rst.next()) {
				List sqlsetList = this.setSqlsetList(rst, null);
				if (sqlsetList.size() > 0) {
					dmlList.add(sqlsetList);
				}
			}
		} else if (null != rs) {
			rs.executeSql(sqlsb.toString());
			if (rs.next()) {
				List sqlsetList = this.setSqlsetList(null, rs);
				if (sqlsetList.size() > 0) {
					dmlList.add(sqlsetList);
				}
			}
		}
		return dmlList;
	}

	/**
	 * 将dmlaction属性进行组装
	 * 
	 * @param rst
	 * @param rs
	 * @return
	 */
	private List setSqlsetList(RecordSetTrans rst, RecordSet rs) {
		List sqlsetList = new ArrayList();
		if (null != rst) {
			sqlsetList.add(rst.getString("id"));
			sqlsetList.add(rst.getString("datasourceid"));
			sqlsetList.add(rst.getString("dmltype"));
			sqlsetList.add(rst.getString("dmlsql"));
			sqlsetList.add(rst.getString("dmlfieldtypes"));
			sqlsetList.add(rst.getString("dmlfieldnames"));
			sqlsetList.add(rst.getString("dmlcuswhere"));
			sqlsetList.add(rst.getString("dmlmainsqltype"));
			sqlsetList.add(rst.getString("dmlcussql"));
			sqlsetList.add(rst.getString("dmlactionname"));
			
			sqlsetList.add(rst.getString("dmlsource"));
			sqlsetList.add(rst.getString("dmlsourcetype"));
			sqlsetList.add(rst.getString("dmlsourceorder"));
		} else if (null != rs) {
			sqlsetList.add(rs.getString("id"));
			sqlsetList.add(rs.getString("datasourceid"));
			sqlsetList.add(rs.getString("dmltype"));
			sqlsetList.add(rs.getString("dmlsql"));
			sqlsetList.add(rs.getString("dmlfieldtypes"));
			sqlsetList.add(rs.getString("dmlfieldnames"));
			sqlsetList.add(rs.getString("dmlcuswhere"));
			sqlsetList.add(rs.getString("dmlmainsqltype"));
			sqlsetList.add(rs.getString("dmlcussql"));
			sqlsetList.add(rs.getString("dmlactionname"));
			
			sqlsetList.add(rs.getString("dmlsource"));
			sqlsetList.add(rs.getString("dmlsourcetype"));
			sqlsetList.add(rs.getString("dmlsourceorder"));
		}
		return sqlsetList;
	}

	/**
	 * 获取值
	 * @param fieldname
	 * @param properties
	 * @param htmlTypeMap
	 * @param typeMap
	 * @param fieldtypeList
	 * @param fieldnameList
	 * @param fieldvalueList
	 * @throws Exception 
	 */
	private void getFieldValues(RecordSetTrans rst,RecordSet rs, String fieldname, Property[] properties,Map<String,String> fieldIdMap,
			Map<String,String> htmlTypeMap, Map<String,String> typeMap,Map<String,String> fieldDbtypeMap,Map<String,Map<String,String>> fieldMapSet, List fieldtypeList,
			List fieldnameList, List fieldvalueList,RequestInfo requestInfo) throws Exception {
		// 填充空数据
		for (int i = 0; i < fieldnameList.size(); i++) {
			fieldvalueList.add("");
		}
		// 获取各字段值
		for (int j = 0; j < properties.length; j++) {
			// 主表数据
			String name = properties[j].getName().toLowerCase();
			String value = Util.null2String(properties[j].getValue());
			for (int f = 0; f < fieldnameList.size(); f++) {
				fieldname = "";
				fieldname = (String) fieldnameList.get(f);
				fieldname = fieldname.toLowerCase();
				String fielddbtype = Util.null2String(fieldtypeList.get(f));
				if(fieldname.indexOf("=") != -1){   //2017-04-20,add by fmj,DML支持明细表
					String [] names = fieldname.split("=", -1);   //此时fieldname的值是 dmlfield=formfield，这种格式
					String tempname = "";
					if(names.length == 2){
						tempname = names[1];
					}
					if(tempname.equals(name)){
						String fieldvalueid = fieldIdMap.get(tempname);
						String htmltype = htmlTypeMap.get(tempname);
						String fieldtype = typeMap.get(tempname);
						String dbtype = fieldDbtypeMap.get(tempname);
						Map<String,String> fieldMap = fieldMapSet.get(fieldname);
						String tempvalue = transtValue(rst, rs, requestInfo, fieldname, fieldvalueid, fieldname, value, htmltype, fieldtype, dbtype, fieldMap, properties);
						fieldvalueList.set(f, tempvalue);
					}
				}else{
					if (name.compareTo(fieldname) == 0) {
						fieldvalueList.set(f, value);
					}
				}
			}
		}
		newlog.info("字段数量与字段值数量 fieldvalueList : " + fieldvalueList
				+ "  fieldnameList : " + fieldnameList);
		// 字段数量与字段值数量不一致
		if (fieldvalueList.size() <= 0
				|| (fieldvalueList.size() != fieldnameList.size())) {
			//newlog.info("字段数量与字段值数量不一致!");
			fieldnameList.clear();
			fieldtypeList.clear();
			fieldvalueList.clear();
		}
	}

	/**
	 * 替换自定义条件sql的值
	 * 
	 * @param fieldname
	 * @param properties
	 * @param dmlsql
	 * @return
	 */
	private String setDmlCusSqlOrWhereValues(String fieldname,
			Property[] properties, String dmlsql) {
		// 获取各字段值
		for (int j = 0; j < properties.length; j++) {
			// 主表数据
			String name = properties[j].getName().toLowerCase();
			String value = Util.null2String(properties[j].getValue());
			/* #538173 概述：[90][客户回归]流程流转集成-解决自定义SQL中的流程字段含有单引号，触发DML报错的问题 -start*/
			dmlsql = DBTypeUtil.replaceStringIgnoreCase(dmlsql, "\\{\\?" + name + "\\}", org.apache.commons.lang.StringEscapeUtils.escapeSql(value.replace("\\","\\\\")));
			/* #538173 概述：[90][客户回归]流程流转集成-解决自定义SQL中的流程字段含有单引号，触发DML报错的问题 -end*/
		}
		return dmlsql;
	}

	/**
	 * 替换自定义DMLsql的值
	 * 
	 * @param dmlsql
	 * @return
	 */
	private String setDmlCusSqlValues(String dmlsql) {
		for (String key : attr.keySet()) {
			dmlsql = DBTypeUtil.replaceStringIgnoreCase(dmlsql, "\\$" + key + "\\$", Util
					.null2String(attr.get(key)));
		}
		return dmlsql;
	}

	/**
	 * 以sql的形式执行dmlaction
	 * 
	 * @param rst
	 * @param rs
	 * @param datasourceid
	 * @param dmltype
	 * @param dmlsql
	 * @param fieldtypeList
	 * @param fieldvalueList
	 * @param dmlcuswhere
	 * @param dmlcussql
	 * @throws Exception 
	 */
	private void executeDMLAction(RecordSetTrans rst, RecordSet rs,
			String datasourceid, String dmltype, String dmlsql,
			List fieldtypeList, List fieldvalueList, String dmlcuswhere,
			String dmlmainsqltype, String dmlcussql) throws Exception {
		ConnStatementDataSource connStatementDataSource = null;
		ConnStatement connStatement = null;
		try {
			String dbtype = DBTypeUtil.getDataSourceDbtype(rs, datasourceid);

			if ("".equals(datasourceid)) {
				connStatement = new ConnStatement();
			} else {
				connStatementDataSource = new ConnStatementDataSource(
						datasourceid);
			}
			newlog.info("以sql的形式执行dmlaction dmltype : " + dmltype + " dmlsql : "
					+ dmlsql + " dmlcuswhere : " + dmlcuswhere
					+ "  dmlmainsqltype : " + dmlmainsqltype + "  dmlcussql : "
					+ dmlcussql + " fieldvalueList : " + fieldvalueList.size());
			
			if (!"".equals(dmlcuswhere)) {
				if(StringUtils.isNotBlank(dmlsql)){
					if (dmlsql.toLowerCase().indexOf(" where ") > -1) {
						dmlsql += " and " + dmlcuswhere;
					} else {
						dmlsql += " where " + dmlcuswhere;
					}
				}
				if(StringUtils.isNotBlank(dmlcussql)){
					if (dmlcussql.toLowerCase().indexOf(" where ") > -1) {
						dmlcussql += " and " + dmlcuswhere;
					} else {
						dmlcussql += " where " + dmlcuswhere;
					}
				}
			}
			
			// 如果为update或者delete，必须有条件
			if (dmltype.equals("update") || dmltype.equals("delete")) {
				// 先执行设置的sql
				if (!"".equals(dmlsql)
						&& (dmlsql.toLowerCase().indexOf(" where ") > -1 || !""
								.equals(dmlcuswhere))) {
					this.executesql(dbtype, connStatementDataSource,
							connStatement, dmlsql, fieldtypeList,
							fieldvalueList);
				}
				// 再执行自定义dmlsql
				if ((dmlcussql.toLowerCase().indexOf(" where ") > -1 && Util.getIntValue(
						dmlmainsqltype, 0) == 0)
						|| (!dmlcussql.equals("") && Util.getIntValue(
								dmlmainsqltype, 0) == 1)) {
					this.executesql(dbtype, connStatementDataSource,
							connStatement, dmlcussql, null, null);
				}
			} else {
				if (fieldvalueList.size() > 0 && !"".equals(dmlsql)) {
					// insert sql
					this.executesql(dbtype, connStatementDataSource,
							connStatement, dmlsql, fieldtypeList,
							fieldvalueList);
				}
				// 再执行自定义dmlsql
				if (!"".equals(dmlcussql)) {
					this.executesql(dbtype, connStatementDataSource,
							connStatement, dmlcussql, null, null);
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
			newlog.error("执行sql出错 e : " + e);
			throw new Exception(e.getMessage());
		} finally {
			try {
				if (null != connStatementDataSource) {
					connStatementDataSource.close();
					connStatementDataSource = null;
				}
				if (null != connStatement) {
					connStatement.close();
					connStatement = null;
				}
			} catch (Exception e) {
				e.printStackTrace();
				newlog.error("关闭连接出错 e : " + e);
			}
		}
	}

	/**
	 * 以sql的形式执行dmlaction
	 * @param rst
	 * @param rs
	 * @param datasourceid
	 * @param dmltype
	 * @param dmlsql
	 * @param fieldtypeList
	 * @param fieldvalueList
	 * @param dmlcuswhere
	 * @param dmlmainsqltype
	 * @param dmlcussql
	 * @throws Exception
	 */
	private void executeDMLActionNew(RecordSetTrans rst, RecordSet rs,
			String datasourceid, String dmltype, String dmlsql,
			List fieldtypeList, List fieldvalueList, String dmlcuswhere,
			String dmlmainsqltype, String dmlcussql) throws Exception {
		//ConnStatementDataSource connStatementDataSource = null;
		//ConnStatement connStatement = null;
		try {
			String dbtype = DBTypeUtil.getDataSourceDbtype(rs, datasourceid);

			newlog.info("以sql的形式执行dmlaction dmltype : " + dmltype + " dmlsql : "
					+ dmlsql + " dmlcuswhere : " + dmlcuswhere
					+ "  dmlmainsqltype : " + dmlmainsqltype + "  dmlcussql : "
					+ dmlcussql + " fieldvalueList : " + fieldvalueList.size());
			
			if (!"".equals(dmlcuswhere)) {
				if(StringUtils.isNotBlank(dmlsql)){
					if (dmlsql.toLowerCase().indexOf(" where ") > -1) {
						dmlsql += " and " + dmlcuswhere;
					} else {
						dmlsql += " where " + dmlcuswhere;
					}
				}
				if(StringUtils.isNotBlank(dmlcussql)){
					if (dmlcussql.toLowerCase().indexOf(" where ") > -1) {
						dmlcussql += " and " + dmlcuswhere;
					} else {
						dmlcussql += " where " + dmlcuswhere;
					}
				}
			}
			
			// 如果为update或者delete，必须有条件
			if (dmltype.equals("update") || dmltype.equals("delete")) {
				// 先执行设置的sql
				if (!"".equals(dmlsql)&& (dmlsql.toLowerCase().indexOf(" where ") > -1 || !"".equals(dmlcuswhere))) {
					this.executesqlNew(dbtype,datasourceid, dmlsql, fieldtypeList,fieldvalueList);
				}else{
					newlog.error("执行类型:"+dmltype+">>>"+"没有设置where条件，不执行赋值sql!");		
				}
				// 再执行自定义dmlsql
				if ((dmlcussql.toLowerCase().indexOf(" where ") > -1 && Util.getIntValue(dmlmainsqltype, 0) == 0)|| (!dmlcussql.equals("") && Util.getIntValue(dmlmainsqltype, 0) == 1)) {
					this.executesqlNew(dbtype,datasourceid , dmlcussql, null, null);
				}else{
					newlog.error("执行类型:"+dmltype+">>>"+"没有设置where条件，不执行自定义sql!");		
				}
			} else {
				if (fieldvalueList.size() > 0 && !"".equals(dmlsql)) {
					// insert sql
					this.executesqlNew(dbtype, datasourceid,dmlsql, fieldtypeList,fieldvalueList);
				}
				// 再执行自定义dmlsql
				if (!"".equals(dmlcussql)) {
					this.executesqlNew(dbtype,datasourceid , dmlcussql, null, null);
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
			newlog.error("执行sql出错 e : " , e);
			throw new Exception(e.getMessage());
		} finally {
			try {
//				if (null != connStatementDataSource) {
//					connStatementDataSource.close();
//					connStatementDataSource = null;
//				}
//				if (null != connStatement) {
//					connStatement.close();
//					connStatement = null;
//				}
			} catch (Exception e) {
				e.printStackTrace();
				newlog.error("关闭连接出错 e : " , e);
			}
		}
	}

	/**
	 * 执行sql
	 * 
	 * @param connStatementDataSource
	 * @param connStatement
	 * @param sql
	 * @param fieldtypeList
	 * @param fieldvalueList
	 * @throws Exception 
	 */
	private void executesql(String dbtype,
			ConnStatementDataSource connStatementDataSource,
			ConnStatement connStatement, String sql, List fieldtypeList,
			List fieldvalueList) throws Exception {
		try {
			sql = sql.replaceAll("\r", " ").replaceAll("\n", " ");//处理sql语句中的回车换行符
			newlog.info("执行sql : " + sql);
			if (null != connStatementDataSource) {
				connStatementDataSource.setStatementSql(sql);
			} else if (null != connStatement) {
				connStatement.setStatementSql(sql);
			}
			if (null != fieldtypeList && fieldtypeList.size() > 0) {
				for (int i = 0; i < fieldtypeList.size(); i++) {
					String fielddbtype = (String) fieldtypeList.get(i);
					String fieldvalue = (String) fieldvalueList.get(i);
					boolean ischeck = DBTypeUtil.checkFieldDBType(fielddbtype,
							dbtype);
					String settype = DBTypeUtil.getThistype();
					newlog.info("dbtype : " + dbtype + "  fielddbtype : "
							+ fielddbtype + " fieldvalue : " + fieldvalue
							+ "  settype : " + settype);
					this.setValueWithDBTypeInStatment(i + 1,
							connStatementDataSource, connStatement, settype,
							fieldvalue);
				}
			}
			int count = 0;
			if (null != connStatementDataSource) {
			    count = connStatementDataSource.executeUpdate();
			} else if (null != connStatement) {
				count = connStatement.executeUpdate();
			}
			newlog.error("影响行数 : " + count);

		} catch (Exception e) {
			e.printStackTrace();
			newlog.error("执行sql出错 e : " + e);
			throw new Exception(e.getMessage());
		}
	}
	
	/**
	 * 执行sql
	 * @param dbtype
	 * @param sql
	 * @param fieldtypeList
	 * @param fieldvalueList
	 * @throws Exception
	 */
	private void executesqlNew(String dbtype,String datasourceid,String sql, List fieldtypeList,List fieldvalueList) throws Exception {
		try {
			sql = sql.replaceAll("\r", " ").replaceAll("\n", " ");//处理sql语句中的回车换行符
			if(dbtype.contains("mysql")){
				sql=sql.replace("\\","\\\\");
			}
			if(sql.endsWith(";")){
				sql=sql.substring(0,sql.length()-1);
			}
			newlog.info("执行sql : " + sql);

		
			if (null != fieldtypeList && fieldtypeList.size() > 0) {
				for (int i = 0; i < fieldtypeList.size(); i++) {
					String fielddbtype = (String) fieldtypeList.get(i);
					String fieldvalue = (String) fieldvalueList.get(i);
					boolean ischeck = DBTypeUtil.checkFieldDBType(fielddbtype,
							dbtype);
					String settype = DBTypeUtil.getThistype();
					if(fielddbtype.equalsIgnoreCase("time")&&!"".equals(fieldvalue)&&fieldvalue.length()==5){
						fieldvalue=fieldvalue+":00";
						fieldvalueList.remove(i);
						fieldvalueList.add(i,fieldvalue);
					}
					fieldvalueList=setValueWithDBType(fieldvalueList,settype,fieldvalue,i);


					newlog.info("dbtype : " + dbtype + "  fielddbtype : "
							+ fielddbtype + " fieldvalue : " + fieldvalue
							+ "  settype : " + settype);
					
				}
			}
			
			//int count = 0;
			boolean flag=false;

				RecordSet rs=new RecordSet();
				rs.setChecksql(false);
				if (null != fieldtypeList && fieldtypeList.size() > 0) {	
					List tempfieldvalueList=new ArrayList();
					tempfieldvalueList.add(fieldvalueList);
					if(!datasourceid.equals("")){ //数据源				
					flag=rs.executeBatchSql(sql, tempfieldvalueList,datasourceid);
					}else{ //本地数据库
						flag=rs.executeBatchSql(sql, tempfieldvalueList);
					}
				}else{
					if(!datasourceid.equals("")){ //数据源
						flag=rs.executeSql(sql, datasourceid);
				
					}else{
						flag=rs.execute(sql);
					}
				}

			newlog.error("是否执行成功: " + flag);
				if(!flag){
					throw new Exception(rs.getExceptionMsg());
				}

		} catch (Exception e) {
			e.printStackTrace();
			newlog.error("执行sql出错  : ",e);
			throw new Exception(e.getMessage());
		}
	}

	/**
	 * 将数据填充至statment中
	 * 
	 * @param connStatementDataSource
	 * @param connStatement
	 * @param settype
	 * @param fieldvalue
	 * @throws Exception
	 */
	private void setValueWithDBTypeInStatment(int index,
			ConnStatementDataSource connStatementDataSource,
			ConnStatement connStatement, String settype, String fieldvalue)
			throws Exception {

		// setString 1
		// setInt 2
		// setFloat 3
		// setDate 4
		// setBigDecimal 5
		// setBinaryStream 6
		// setBytes 7
		// setCharacterStream 8
		// setObject 9
		// setNull 10
		// setClob 11
		// setBlob 12
		if (null != connStatementDataSource) {
			if ("1".equals(settype)) {
				connStatementDataSource.setString(index, fieldvalue);
			} else if ("2".equals(settype)) {
				if(null!=fieldvalue&&!fieldvalue.isEmpty()){
					connStatementDataSource.setInt(index, Util.getIntValue(
							fieldvalue, 0));
				}else{
					connStatementDataSource.setString(index, null);
				}
			} else if ("3".equals(settype)) {
				if(null!=fieldvalue&&!fieldvalue.isEmpty()){
					connStatementDataSource.setFloat(index, Util.getFloatValue(
							fieldvalue, 0));
				}else{
					connStatementDataSource.setString(index, null);
				}
			} else if ("4".equals(settype)) {
				java.sql.Date date = null;
				try {
					SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
					Date dt = sdf.parse(fieldvalue);
					date = new java.sql.Date(dt.getTime());
				} catch (Exception e) {
					e.printStackTrace();
					newlog.error("转换日期型出错 ： fieldvalue : " + fieldvalue);
				}
				connStatementDataSource.setDate(index, date);
			} else if ("5".equals(settype)) {
				BigDecimal fieldvalueb = null;
				try {
					
					if(null!=fieldvalue&&!fieldvalue.isEmpty()){
						fieldvalueb = new BigDecimal(fieldvalue);
						connStatementDataSource.setBigDecimal(index, fieldvalueb);
					}else{
						connStatementDataSource.setBigDecimal(index,null);//qc325384 [80][90][客户]流程流转集成-注册DML接口，update类型，对于SQL中字段为decimal类型，执行报错
					}
					
				} catch (Exception e) {
					e.printStackTrace();
					newlog.error("转换数值型出错 ： fieldvalue : " + fieldvalue);
				}
				
			} else if ("6".equals(settype)) {
				connStatementDataSource.setBinaryStream(index, null, 0);
			} else if ("7".equals(settype)) {
				connStatementDataSource.setBytes(index, fieldvalue.getBytes());
			} else if ("8".equals(settype)) {
				connStatementDataSource.setCharacterStream(index, fieldvalue);
			} else if ("9".equals(settype)) {
				connStatementDataSource.setObject(index, null);
			} else if ("10".equals(settype)) {
				//connStatementDataSource.setNull(index);
				connStatementDataSource.setString(index, fieldvalue);
			} else if ("11".equals(settype)) {
				connStatementDataSource.setClob(index, null);
			} else if ("12".equals(settype)) {
				connStatementDataSource.setBlob(index, null);
			}
		}
		if (null != connStatement) {
			if ("1".equals(settype)) {
				connStatement.setString(index, fieldvalue);
				
			} else if ("2".equals(settype)) {
				if(null!=fieldvalue&&!fieldvalue.isEmpty()){
					connStatement.setInt(index, Util.getIntValue(fieldvalue, 0));
				}else{
					connStatement.setString(index, null);
				}
			} else if ("3".equals(settype)) {
				if(null!=fieldvalue&&!fieldvalue.isEmpty()){
					connStatement
					.setFloat(index, Util.getFloatValue(fieldvalue, 0));
				}else{
					connStatement.setString(index, null);
				}
				
			} else if ("4".equals(settype)) {
				java.sql.Date date = null;
				try {
					SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
					Date dt = sdf.parse(fieldvalue);
					date = new java.sql.Date(dt.getTime());
				} catch (Exception e) {
					e.printStackTrace();
					newlog.error("转换日期型出错 ： fieldvalue : " + fieldvalue);
				}
				connStatement.setDate(index, date);
			} else if ("5".equals(settype)) {
				BigDecimal fieldvalueb = null;
				try {
					if(null!=fieldvalue&&!fieldvalue.isEmpty()){
						fieldvalueb = new BigDecimal(fieldvalue);
						connStatement.setBigDecimal(index, fieldvalueb);
					}else{
						//connStatement.setBigDecimal(index,null);
						connStatement.setBigDecimal(index,null);//qc325384 [80][90][客户]流程流转集成-注册DML接口，update类型，对于SQL中字段为decimal类型，执行报错
					}
					
				} catch (Exception e) {
					e.printStackTrace();
					newlog.error("转换数值型出错 ： fieldvalue : " + fieldvalue);
				}	
			} else if ("6".equals(settype)) {
				connStatement.setBinaryStream(index, null, 0);
			} else if ("7".equals(settype)) {
				connStatement.setBytes(index, fieldvalue.getBytes());
			} else if ("8".equals(settype)) {
				connStatement.setCharacterStream(index, fieldvalue);
			} else if ("9".equals(settype)) {
				connStatement.setObject(index, null);
			} else if ("10".equals(settype)) {
				//connStatement.setNull(index);
				connStatement.setString(index, fieldvalue);
			} else if ("11".equals(settype)) {
				connStatement.setClob(index, null);
			} else if ("12".equals(settype)) {
				connStatement.setBlob(index, null);
			}
		}
	}
	private List setValueWithDBType(List fieldvalueList, String settype, String fieldvalue,int index)
			 {

		// setString 1
		// setInt 2
		// setFloat 3
		// setDate 4
		// setBigDecimal 5
		// setBinaryStream 6
		// setBytes 7
		// setCharacterStream 8
		// setObject 9
		// setNull 10
		// setClob 11
		// setBlob 12
		if (null != fieldvalueList) {
			if ("1".equals(settype)) {
				//connStatementDataSource.setString(index, fieldvalue);
				//fieldvalueList.add(index);
			} else if ("2".equals(settype)) {
				if(null!=fieldvalue&&!fieldvalue.isEmpty()){
					//connStatementDataSource.setInt(index, Util.getIntValue(
					//		fieldvalue, 0));
					fieldvalueList.remove(index);
					fieldvalueList.add(index,Util.getIntValue(fieldvalue, 0));
				}else{
					//connStatementDataSource.setString(index, null);
					fieldvalueList.remove(index);
					fieldvalueList.add(index,null);
				}
			} else if ("3".equals(settype)) {
				if(null!=fieldvalue&&!fieldvalue.isEmpty()){
					//connStatementDataSource.setFloat(index, Util.getFloatValue(
					//		fieldvalue, 0));
					fieldvalueList.remove(index);
					fieldvalueList.add(index,Util.getFloatValue(fieldvalue, 0));
				}else{
					//connStatementDataSource.setString(index, null);
					fieldvalueList.remove(index);
					fieldvalueList.add(index,0.0);
				}
			} else if ("4".equals(settype)) {
				java.sql.Date date = null;
				try {
					SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
					Date dt = sdf.parse(fieldvalue);
					date = new java.sql.Date(dt.getTime());
					fieldvalueList.remove(index);
					fieldvalueList.add(index,date);
				} catch (Exception e) {
					e.printStackTrace();
					newlog.error("转换日期型 ： fieldvalue : " + fieldvalue);
				}
				//connStatementDataSource.setDate(index, date);
			} else if ("5".equals(settype)) {
				BigDecimal fieldvalueb = null;
				try {

					if(null!=fieldvalue&&!fieldvalue.isEmpty()){
						fieldvalueb = new BigDecimal(fieldvalue);
						//connStatementDataSource.setBigDecimal(index, fieldvalueb);
						fieldvalueList.remove(index);
						fieldvalueList.add(index,fieldvalueb);
					}else{
						//connStatementDataSource.setBigDecimal(index,null);//qc325384 [80][90][客户]流程流转集成-注册DML接口，update类型，对于SQL中字段为decimal类型，执行报错
						fieldvalueList.remove(index);
						fieldvalueList.add(index,null);
					}

				} catch (Exception e) {
					e.printStackTrace();
					newlog.error("转换数值型出错 ： fieldvalue : " + fieldvalue);
				}

			} else if ("6".equals(settype)) {
				//connStatementDataSource.setBinaryStream(index, null, 0);
			} else if ("7".equals(settype)) {
				//connStatementDataSource.setBytes(index, fieldvalue.getBytes());
			} else if ("8".equals(settype)) {
				//connStatementDataSource.setCharacterStream(index, fieldvalue);
			} else if ("9".equals(settype)) {
				//connStatementDataSource.setObject(index, null);
			} else if ("10".equals(settype)) {
				//connStatementDataSource.setNull(index);
				//connStatementDataSource.setString(index, fieldvalue);
			} else if ("11".equals(settype)) {
				//connStatementDataSource.setClob(index, null);
			} else if ("12".equals(settype)) {
				//connStatementDataSource.setBlob(index, null);
			}
		}
		return fieldvalueList;

	}

	public String getIsNewMark() {
		return isNewMark;
	}

	public void setIsNewMark(String isNewMark) {
		this.isNewMark = isNewMark;
	}

	/**
	 * 动态增加数组长度
	 * 
	 * @param array
	 * @param newSize
	 * @return
	 */
	public Object expand(Object array, int newSize) {

		if (array == null) {

			return null;

		}

		Class c = array.getClass();

		if (c.isArray()) {

			int len = Array.getLength(array);

			if (len >= newSize) {

				return array;

			} else {

				Class cc = c.getComponentType();

				Object newArray = Array.newInstance(cc, newSize);

				System.arraycopy(array, 0, newArray, 0, len);

				return newArray;

			}

		} else {

			// throw new ClassCastException("need array");
			return array;

		}

	}

	private void loadMainInfotoProp(Property[] propertys,
			DetailTable[] detailTables) {
		for (Property property : propertys) {
			attr.put("main." + property.getName().toLowerCase(), property
					.getValue());
		}
		if (detailTables != null) {
			for (int i = 0; i < detailTables.length; i++) {
				Row[] rows = detailTables[i].getRow();
				for (int j = 0; j < rows.length; j++) {
					Cell[] cells = rows[j].getCell();
					for (Cell cell : cells) {
						attr.put("detail_" + i + "_" + j + "" + cell.getName(),
								cell.getValue());
					}
				}
			}
		}
	}
	
	/**
	 * 拼装明细表数据
	 * @param properties 主表数据
	 * @param requestInfo  
	 * @param dtableName 明细表名称
	 * @return
	 */
	private List<Property[]> loadDetail(Property[] properties,RequestInfo requestInfo,String dtableName){
		List<Property[]> propertiesList = new ArrayList<Property[]>();
		DetailTable [] detailTables = requestInfo.getDetailTableInfo().getDetailTable();
		try{
			if(detailTables != null && detailTables.length > 0){
				for(DetailTable detailTable : detailTables){
					String tableName = Util.null2String(detailTable.getTableDBName());
					if(tableName != null && tableName.equalsIgnoreCase(dtableName)){  //取对应的明细表的数据
						int rowCount = detailTable.getRowCount();
						for(int i = 0 ;i < rowCount; i++){
							List<Property> propertyList = new ArrayList<Property>();
							for(Property property : properties){
								Property prop = new Property();
								BeanUtils.copyProperties(prop, property);
								propertyList.add(prop);
							}
							
							Row row = detailTable.getRow(i);
							
							Property tempprop = new Property();
							tempprop.setName("d.id");
							tempprop.setValue(row.getId());
							tempprop.setType("");
							propertyList.add(tempprop);
							
							Cell [] cells = row.getCell();
							for(Cell cell : cells){
								String name = Util.null2String(cell.getName());
								String value = Util.null2String(cell.getValue());
								String type = Util.null2String(cell.getType());
								if(!"".equals(name)){
									name = "d." + name;
									Property prop = new Property();
									prop.setName(name);
									prop.setValue(value);
									prop.setType(type);
									propertyList.add(prop);
								}
							}
							
							Property [] props = propertyList.toArray(new Property[1]);
							propertiesList.add(props);
						}
					}
				}
			}
		}catch (Exception e) {
			newlog.error("加载明细表数据出错:" + e);
		}
		return propertiesList;
	}

	/**
	 * 
	 * @Description : 动态装载DML sql自定义属性值
	 * @param src
	 *            节点操作者/请求基本信息对象
	 */
	public void loadProperty(Object src) {
		if(null==src)
		{
			return;
		}
		Method[] methods = src.getClass().getDeclaredMethods();
		String pfx = "";
		if (src.getClass().equals(weaver.hrm.User.class)) {// 用户信息在属性前面加user.前缀
			pfx = "user.";
		}
		String key, value = "";
		for (Method method : methods) {
			String methodName = method.getName();
			if (methodName.startsWith("get")
					&& (method.getModifiers() == Modifier.PUBLIC)
					&& (method.getParameterTypes().length == 0)) {// 访问不带参数公共方法
				method.setAccessible(true);
				methodName = methodName.substring(3);// 去掉get
				key = pfx + methodName.toLowerCase();
				try {
					value = String.valueOf(method.invoke(src, null));
				} catch (IllegalArgumentException e) {
					newlog.error("获取" + src.getClass().getName() + "信息失败！", e);
				} catch (IllegalAccessException e) {
					newlog.error("获取" + src.getClass().getName() + "信息失败！", e);
				} catch (InvocationTargetException e) {
					newlog.error("获取" + src.getClass().getName() + "信息失败！", e);
				}
				attr.put(key, Util.null2String(value));
			}
		}
	}

	private String loadTableInfo(String dmlsql, int requestid, int formid,
			int billid, RecordSetTrans rst, RecordSet rs, String dmltype)
			throws Exception {
		if (dmlsql.indexOf("$detail_table?") >= 0) {
			if (dmltype.equals("update") || dmltype.equals("delete")) {
				if (dmlsql.indexOf("$detail_pk$") < 0) {
					newlog.info("执行的sql有误，必须存在$detail_pk$！");
					return dmlsql + " and 1=2";
				}
			} else {
				if (dmlsql.indexOf("detail_main_pkfd") < 0
						|| dmlsql.indexOf("detail_main_pkfd_v") < 0) {
					newlog.info("执行的sql有误，必须存在$detail_main_pkfd$、$detail_main_pkfd_v$！");
					return dmlsql + " and 1=2";
				}
			}
			String mainsql = "select detailtablename,tablename,detailkeyfield from workflow_bill where id="
					+ formid;
			String detail_tablename = " workflow_formdetail ";// 明细表表面
			String detail_pk = " requestid=" + requestid + " ";// 明细表主键字段名
			final String pk = "$detail_table?";
			String index = dmlsql.substring(dmlsql.indexOf(pk) + pk.length(),
					dmlsql.indexOf(pk) + pk.length() + 1);// 明细表索引
			// 0代表第一个明细表1表示第二个
			int orderid = Util.getIntValue(index, 0);// 自定义表单需要+1从开始
			final String fsi = "$detail_index?";
			String detail_index = "";// 明细数据索引0代表第0个
			if (dmlsql.indexOf(fsi) >= 0) {
				detail_index = dmlsql.substring(dmlsql.indexOf(fsi)
						+ fsi.length(), dmlsql.indexOf(fsi) + fsi.length() + 1);// 表示明细表的第N条明细
				// 从0开始
				dmlsql = dmlsql.substring(0, dmlsql.indexOf(fsi))
						+ " 1=1 "
						+ dmlsql.substring(dmlsql.indexOf(fsi) + fsi.length()
								+ 2);
			}
			int i = 0;
			if (billid == 1) {
				orderid++;
				if (rst != null) {
					rst.executeSql(mainsql);
					rst.next();
					String detailtablename = rst.getString("detailtablename");
					String maintable = rst.getString("tablename");
					String detailkeyfield = rst.getString("detailkeyfield");
					attr.put("detail_main_pkfd", detailkeyfield);// 主表跟明细表关联关系字段名称
					rst.executeSql("select id from " + maintable
							+ " where requestid=" + requestid);
					rst.next();
					attr.put("detail_main_pkfd_v", rst.getString("id"));// 主表跟明细表关联关系字段值
					detail_pk = "  " + detailkeyfield + "="
							+ rst.getString("id") + " ";
					attr.put("detail_pk", detail_pk);
					if (maintable.trim().toLowerCase().startsWith(
							"formtable_main_")) {// 自定义单据
						rst
								.executeSql("select tablename from workflow_billdetailtable where billid="
										+ formid + " and orderid=" + orderid);
						rst.next();
						attr.put("detail_table?" + index, rst
								.getString("tablename"));
						if (!detail_index.equals("")) {
							rst.executeSql("select id from "
									+ rst.getString("tablename") + " where "
									+ detail_pk + " order by id asc");
							while (rst.next()) {
								String index_id = rst.getString("id");
								if (detail_index.equals("" + i)) {
									dmlsql += " and id=" + index_id + " ";// 表示第几个明细表从0开始
									break;
								}
								i++;
							}
						}
					} else {// 系统单据
						attr.put("detail_table?" + index, detailtablename);
						if (!detail_index.equals("")) {
							rst.executeSql("select id from " + detailtablename
									+ " where " + detail_pk
									+ " order by id asc");
							while (rst.next()) {
								String index_id = rst.getString("id");
								if (detail_index.equals("" + i)) {
									dmlsql += " and id=" + index_id + " ";// 表示第几个明细表从0开始
									break;
								}
								i++;
							}
						}
					}
				} else if (rs != null) {
					rs.executeSql(mainsql);
					rs.next();
					String detailtablename = rs.getString("detailtablename");// 明细表表面
					String maintable = rs.getString("tablename");// 主表表明
					String detailkeyfield = rs.getString("detailkeyfield");// 主表跟明细表关联关系字段名称
					attr.put("detail_main_pkfd", detailkeyfield);
					rs.executeSql("select id from " + maintable
							+ " where requestid=" + requestid);
					rs.next();
					attr.put("detail_main_pkfd_v", rs.getString("id"));// 主表跟明细表关联关系字段值
					detail_pk = "  " + detailkeyfield + "="
							+ rs.getString("id") + " ";
					attr.put("detail_pk", detail_pk);
					if (maintable.trim().toLowerCase().startsWith(
							"formtable_main_")) {// 自定义单据
						rs
								.executeSql("select tablename from workflow_billdetailtable where billid="
										+ formid + " and orderid=" + orderid);
						rs.next();
						attr.put("detail_table?" + index, rs
								.getString("tablename"));
						if (!detail_index.equals("")) {
							rs.executeSql("select id from "
									+ rs.getString("tablename") + " where "
									+ detail_pk + " order by id asc");
							while (rs.next()) {
								String index_id = rs.getString("id");
								if (detail_index.equals("" + i)) {
									dmlsql += " and id=" + index_id + " ";// 表示第几个明细表
									break;
								}
								i++;
							}
						}
					} else {// 系统单据
						attr.put("detail_table?" + index, detailtablename);
						if (!detail_index.equals("")) {
							rs.executeSql("select id from " + detailtablename
									+ " where " + detail_pk
									+ " order by id asc");
							while (rs.next()) {
								String index_id = rs.getString("id");
								if (detail_index.equals("" + i)) {
									dmlsql += " and id=" + index_id + " ";// 表示第几个明细表从0开始
									break;
								}
								i++;
							}
						}
					}
				}
			} else {// 老表单
				attr.put("detail_table?" + index, detail_tablename);
				attr.put("detail_pk", detail_pk);
				attr.put("detail_main_pkfd", "requestid");// 主表跟明细表关联关系字段名称
				attr.put("detail_main_pkfd_v", "" + requestid);// 主表跟明细表关联关系字段值
				if (!detail_index.equals("")) {
					if (rst != null) {
						rst.executeSql("select id from " + detail_tablename
								+ " where groupid=" + orderid
								+ " order by id asc");
						while (rst.next()) {
							String index_id = rst.getString("id");
							if (detail_index.equals("" + i)) {
								dmlsql += " and id=" + index_id + " ";// 表示第几个明细表从0开始
								break;
							}
							i++;
						}
					} else if (rs != null) {
						rs.executeSql("select id from " + detail_tablename
								+ " where groupid=" + orderid
								+ " order by id asc");
						while (rs.next()) {
							String index_id = rs.getString("id");
							if (detail_index.equals("" + i)) {
								dmlsql += " and id=" + index_id + " ";// 表示第几个明细表从0开始
								break;
							}
							i++;
						}
					}
				}

			}
			if (dmltype.equals("update") || dmltype.equals("delete")) {
				if (billid == 0) {
					dmlsql += " and groupid=" + orderid + " ";// 表示第几个明细表
				}
			}
		}
		return dmlsql;
	}
	
	
	/**
	 * 获取明细表的名称
	 * @param rst
	 * @param rs
	 * @param formid
	 * @param isbill
	 * @param tableid
	 * @return
	 * @throws Exception
	 */
	private String getDetailTable(RecordSetTrans rst,RecordSet rs,int formid,int isbill,int tableid) throws Exception{
		String formDetailTable = "";
		if(isbill == 1){
			String tsql = "select tablename from workflow_billdetailtable where id = " + tableid;
			if(rst != null){
				rst.executeSql(tsql);
				if(rst.next()){
					formDetailTable = Util.null2String(rst.getString("tablename"));
				}
			}else{
				rs.executeSql(tsql);
				if(rs.next()){
					formDetailTable = Util.null2String(rs.getString("tablename"));
				}
			}
		}else{
			formDetailTable = tableid + "";
		}
		
		return formDetailTable;
	}	
	
	/**
	 * 查询字段的信息，主要是htmltype，type信息
	 * @param rst
	 * @param rs
	 * @param formid
	 * @param isbill
	 * @param fieldHtmlTypeMap
	 * @param fieldTypeMap
	 * @param tableid
	 * @throws Exception 
	 */
	private void getFieldsInfo(RecordSetTrans rst,RecordSet rs,int formid,int isbill,Map<String,String> fieldIdMap,Map<String,String> fieldHtmlTypeMap,Map<String,String> fieldTypeMap,Map<String,String> fieldDbTypeMap, int tableid) throws Exception{
		String sql = "";
		/****查询主表字段信息********/
		if(isbill==0){
			//表单主字段
			sql = " select d.id,d.fieldname,d.fieldhtmltype,d.type,d.fielddbtype " 
				+ " from workflow_formfield a,workflow_formdict d "
				+ " where a.isdetail is null and a.fieldid=d.id and a.formid="+formid;
		}else if(isbill==1){
			//单据主字段
			sql = " select id,fieldname,fieldhtmltype,type,fielddbtype " 
				+ " from workflow_billfield where viewtype=0 and billid="+formid;
		}
		
		if(rst != null){
			rst.executeSql(sql);
			while(rst.next()){
				String fieldid = Util.null2String(rst.getString("id"));
				String fieldname = Util.null2String(rst.getString("fieldname")).toLowerCase();
				String fieldhtmltype = Util.null2String(rst.getString("fieldhtmltype"));
				String type = Util.null2String(rst.getString("type"));
				String fielddbtype = Util.null2String(rst.getString("fielddbtype"));
				fieldHtmlTypeMap.put(fieldname, fieldhtmltype);
				fieldTypeMap.put(fieldname, type);
				fieldIdMap.put(fieldname, fieldid);
				fieldDbTypeMap.put(fieldname, fielddbtype);
			}
		}else{
			rs.executeSql(sql);
			while(rs.next()){
				String fieldid = Util.null2String(rs.getString("id"));
				String fieldname = Util.null2String(rs.getString("fieldname")).toLowerCase();
				String fieldhtmltype = Util.null2String(rs.getString("fieldhtmltype"));
				String type = Util.null2String(rs.getString("type"));
				String fielddbtype = Util.null2String(rs.getString("fielddbtype"));
				fieldHtmlTypeMap.put(fieldname, fieldhtmltype);
				fieldTypeMap.put(fieldname, type);
				fieldIdMap.put(fieldname, fieldid);
				fieldDbTypeMap.put(fieldname, fielddbtype);
			}
		}
		
		/**********查询明细表字段************/
		if(tableid >= 0){
			if(isbill==0){
				//表单明细字段
		    	sql = " select d.id,d.fieldname,d.fieldhtmltype,d.type,d.fielddbtype " 
		    		+ " from workflow_formfield a,workflow_formdict d "
		    		+ " where a.isdetail=1 and a.fieldid=d.id and a.formid="+formid;
		    	if(rs.getDBType().equals("oracle")){
		    		sql += " and nvl(a.groupid,0) = " + tableid;
		    	}else if(rs.getDBType().equals("mysql")){
					sql += " and ifnull(a.groupid,0) = " + tableid;
				} else{
		    		sql += " and isnull(a.groupid,0) = " + tableid;
		    	}
			}else if(isbill==1){
				String detailtable = "";
				String tsql = "select tablename from workflow_billdetailtable where billid = " + formid + " and id = " + tableid;
				if(rst != null){
					rst.executeSql(tsql);
					if(rst.next()){
						detailtable = Util.null2String(rst.getString("tablename"));
					}
				}else{
					rs.executeSql(tsql);
					if(rs.next()){
						detailtable = Util.null2String(rs.getString("tablename"));
					}
				}
				
				//单据明细字段
				sql = " select id,fieldname,fieldhtmltype,type,fielddbtype " 
					+ " from workflow_billfield " 
					+ " where viewtype=1 and billid = " + formid + " and detailtable = '" + detailtable + "'";
			}
			
			if(rst != null){
				rst.executeSql(sql);
				while(rst.next()){
					String fieldid = Util.null2String(rst.getString("id"));
					String fieldname = Util.null2String(rst.getString("fieldname")).toLowerCase();
					String fieldhtmltype = Util.null2String(rst.getString("fieldhtmltype"));
					String type = Util.null2String(rst.getString("type"));
					String fielddbtype = Util.null2String(rst.getString("fielddbtype"));
					
					fieldname = "d." + fieldname;
					fieldHtmlTypeMap.put(fieldname, fieldhtmltype);
					fieldTypeMap.put(fieldname, type);
					fieldIdMap.put(fieldname, fieldid);
					fieldDbTypeMap.put(fieldname, fielddbtype);
				}
			}else{
				rs.executeSql(sql);
				while(rs.next()){
					String fieldid = Util.null2String(rs.getString("id"));
					String fieldname = Util.null2String(rs.getString("fieldname")).toLowerCase();
					String fieldhtmltype = Util.null2String(rs.getString("fieldhtmltype"));
					String fielddbtype = Util.null2String(rs.getString("fielddbtype"));
					String type = Util.null2String(rs.getString("type"));
					
					fieldname = "d." + fieldname;
					fieldHtmlTypeMap.put(fieldname, fieldhtmltype);
					fieldTypeMap.put(fieldname, type);
					fieldIdMap.put(fieldname, fieldid);
					fieldDbTypeMap.put(fieldname, fielddbtype);
				}
			}
		}
	}
	
	/**
	 * 获取外部表与流程表单表的映射关系，同时返回数据转换规则等
	 * @param sqlsetid
	 * @return
	 * @throws Exception 
	 */
	private Map<String,Map<String,String>> getFieldMapSet(RecordSetTrans rst,RecordSet rs,String sqlsetid,String maptype) throws Exception{
		Map<String,Map<String,String>> map = new HashMap<String,Map<String,String>>();
		String sql = " select fieldname,fieldvalue,transttype,extrainfo" 
				   + " from formactionfieldmap" 
				   + " where actionsqlsetid = " + sqlsetid ;
		if(maptype != null && !"".equals(maptype)){
			sql += " and maptype = '" + maptype + "'";
		}
		if(rst != null){
			rst.executeSql(sql);
			while(rst.next()){
				String fieldname = Util.null2String(rst.getString("fieldname")).toLowerCase();
				String fieldvalue = Util.null2String(rst.getString("fieldvalue")).toLowerCase();
				String transttype = Util.null2String(rst.getString("transttype"));
				String extrainfo = Util.null2String(rst.getString("extrainfo"));
				Map<String,String> m = new HashMap<String, String>();
				m.put("transttype", transttype);
				m.put("extrainfo", extrainfo);
				
				String key = fieldname + "=" + fieldvalue;
				map.put(key, m);
			}
		}else{
			rs.executeSql(sql);
			while(rs.next()){
				String fieldname = Util.null2String(rs.getString("fieldname")).toLowerCase();
				String fieldvalue = Util.null2String(rs.getString("fieldvalue")).toLowerCase();
				String transttype = Util.null2String(rs.getString("transttype"));
				String extrainfo = Util.null2String(rs.getString("extrainfo"));
				Map<String,String> m = new HashMap<String, String>();
				m.put("transttype", transttype);
				m.put("extrainfo", extrainfo);
				
				String key = fieldname + "=" + fieldvalue;
				map.put(key, m);
			}
		}
		return map;
	}
	
	
	private String transtValue(RecordSetTrans rst,RecordSet rs,RequestInfo requestInfo,String keyvaluename,String fieldvalueid,String fieldvaluename,String fieldvalue,String htmltype,String fieldtype,String fielddbtype,Map<String,String> transttypeMap,Property [] properties) throws Exception{
		String value = "";
		int transttype = Util.getIntValue(Util.null2String(transttypeMap.get("transttype")), -1);
		String extrainfo = Util.null2String(transttypeMap.get("extrainfo"));
		RequestManager requestManager = requestInfo.getRequestManager();
		int isbill = requestManager.getIsbill();
		if(transttype > 0){
			ResourceComInfo resourceComInfo = new ResourceComInfo();
			DepartmentComInfo departmentComInfo = new DepartmentComInfo();
			SubCompanyComInfo subCompanyComInfo = new SubCompanyComInfo();
			if(transttype == 1){/*****固定值*****/
				value = extrainfo;
			} else if(transttype == 2){/******显示值*******/
				if("3".equals(htmltype)){   //浏览按钮
					GetShowCondition showCondition = new GetShowCondition();
					value = showCondition.getShowCN(htmltype, fieldtype, fieldvalue, isbill + "",fielddbtype);
					String value2 = Util.formatMultiLang(value, "7");
					if(!"".equals(value2))
						value=value2;
				}else if("5".equals(htmltype)){   //选择框

					if(!"".equals(fieldvalue)){

						String[] tempFieldvalueS=fieldvalue.split(",");
						for(int i=0;i<tempFieldvalueS.length;i++) {
							String dValue="";
							String sql = "";
							String tempFieldValue=Util.null2String(tempFieldvalueS[i]);
							if (isbill == 1 || isbill == 0) {
								sql = "select selectname from workflow_SelectItem where selectvalue=" + tempFieldValue + " and fieldid = " + fieldvalueid + " and isbill = " + isbill;
							} else {
								sql = "select selectname from workflow_SelectItem where selectvalue = " + tempFieldValue + " and fieldid = " + fieldvalueid;
							}

							if (!"".equals(sql)) {
								if (rst != null) {
									rst.executeSql(sql);
									if (rst.next()) {
										dValue = Util.null2String(rst.getString(1));
									}
								} else {
									rs.executeSql(sql);
									if (rs.next()) {
										dValue = Util.null2String(rs.getString(1));
									}
								}
							}
							if(!dValue.equals(""))value=value+dValue+",";
						}
						String value2 = Util.formatMultiLang(value, "7");
						if(!"".equals(value2))
							value=value2;
						if(value.length()>1&&tempFieldvalueS.length>0)value=value.substring(0,value.length()-1);
					}
				}else if("6".equals(htmltype)){   //附件上传
					if(!"".equals(fieldvalue)){
						String sql="select id,docsubject,accessorycount from docdetail where id in("+fieldvalue+") order by id asc";
						if(rst != null){
							rst.executeSql(sql);
							while(rst.next()){
								value += "," + rst.getString("docsubject");
							}
						}else{
							rs.executeSql(sql);
							while(rs.next()){
								value += "," + rs.getString("docsubject");
							}
						}
						
						if(!"".equals(value) && value.startsWith(",")){
							value = value.substring(1);
						}
					}
				}else if("7".equals(htmltype)){  //字段类型：特殊字段
					String sql = " select type,fieldid,displayname,linkaddress,descriptivetext " 
							   + " from workflow_specialfield a, workflow_billfield b " 
							   + " where a.fieldid = b.id and a.isform='0' and a.isbill='1' and a.fieldid = " + fieldvalueid;
					String ftype = "";
					String linkaddress = "";
					String displayname = "";
					if(rst != null){
						rst.executeSql(sql);
						if(rst.next()){
							ftype = Util.null2String(rst.getString("type"));
							linkaddress = Util.null2String(rst.getString("linkaddress"));
							displayname = Util.null2String(rst.getString("displayname"));
						}
					}else{
						rs.executeSql(sql);
						if(rs.next()){
							ftype = Util.null2String(rs.getString("type"));
							linkaddress = Util.null2String(rs.getString("linkaddress"));
							displayname = Util.null2String(rs.getString("displayname"));
						}
					}
					
					if("1".equals(ftype)){
						if(!"".equals(linkaddress)){
							value = "<a href='" + linkaddress + "'>" + displayname + "</a>";
						}else{
							value = linkaddress;
						}
					}
				}
			}else if(transttype == 3){   /********人员编号、部门编号、分部编号********/
				//浏览按钮,单人力、多人力、分权单人力、分权多人力
				if("3".equals(htmltype) && ("1".equals(fieldtype) || "17".equals(fieldtype) || "165".equals(fieldtype) || "166".equals(fieldtype))){
					if(!"".equals(fieldvalue)){
						String [] values = fieldvalue.split(",", -1);
						for(String val : values){
							value += "," + resourceComInfo.getWorkcode(val);
						}
					} 
				//浏览按钮,部门,多部门,分权单部门,分权多部门
				}else if("3".equals(htmltype) && ("4".equals(fieldtype) || "57".equals(fieldtype) || "167".equals(fieldtype) || "168".equals(fieldtype))){
					if(!"".equals(fieldvalue)){
						String [] values = fieldvalue.split(",", -1);
						for(String val : values){
							value += "," + departmentComInfo.getDepartmentCode(val);
						}
					} 
				//浏览按钮,分部,多分部,分权单分部,分权多分部	
				}else if("3".equals(htmltype) && ("164".equals(fieldtype) || "194".equals(fieldtype) || "169".equals(fieldtype) || "170".equals(fieldtype))){
					if(!"".equals(fieldvalue)){
						String [] values = fieldvalue.split(",", -1);
						for(String val : values){
							value += "," + subCompanyComInfo.getSubCompanyCode(val);   
						}
					} 
				}
				
				if(!"".equals(value) && value.startsWith(",")){
					value = value.substring(1);
				}
			}else if(transttype == 4){   /********登录名********/
				//浏览按钮,单人力、多人力、分权单人力、分权多人力
				if("3".equals(htmltype) && ("1".equals(fieldtype) || "17".equals(fieldtype) || "165".equals(fieldtype) || "166".equals(fieldtype))){
					if(!"".equals(fieldvalue)){
						String [] values = fieldvalue.split(",", -1);
						for(String val : values){
							value += "," + resourceComInfo.getLoginID(val);
						}
					} 
				}
				if(!"".equals(value) && value.startsWith(",")){
					value = value.substring(1);
				}
			}else if(transttype == 5){   /********手机号码********/
				//浏览按钮,单人力、多人力、分权单人力、分权多人力
				if("3".equals(htmltype) && ("1".equals(fieldtype) || "17".equals(fieldtype) || "165".equals(fieldtype) || "166".equals(fieldtype))){
					if(!"".equals(fieldvalue)){
						String [] values = fieldvalue.split(",", -1);
						for(String val : values){
							value += "," + resourceComInfo.getMobile(val);
						}
					} 
				}
				if(!"".equals(value) && value.startsWith(",")){
					value = value.substring(1);
				}
			}else if(transttype == 6){   /********Email********/
				//浏览按钮,单人力、多人力、分权单人力、分权多人力
				if("3".equals(htmltype) && ("1".equals(fieldtype) || "17".equals(fieldtype) || "165".equals(fieldtype) || "166".equals(fieldtype))){
					if(!"".equals(fieldvalue)){
						String [] values = fieldvalue.split(",", -1);
						for(String val : values){
							value += "," + resourceComInfo.getEmail(val);
						}
					} 
				}
				if(!"".equals(value) && value.startsWith(",")){
					value = value.substring(1);
				}
			}else if(transttype == 7){/******自定义SQL********/
				extrainfo = extrainfo.toLowerCase();
				if(!"".equals(extrainfo) && extrainfo.indexOf("update") == -1 && extrainfo.indexOf("delete") == -1 && extrainfo.indexOf("insert") == -1){
					extrainfo = setDmlCusSqlOrWhereValues(fieldvaluename, properties, extrainfo);   //替换自定义SQL中的参数
				}
				
				if(!"".equals(extrainfo)){
					newlog.error("转换规则，自定义SQL，fieldvaluename=" + fieldvaluename + ",sql=" + extrainfo);
					if(rst != null){
						rst.executeSql(extrainfo);
						if(rst.next()){
							value = Util.null2String(rst.getString(1));
						}
					}else{
						rs.executeSql(extrainfo);
						if(rs.next()){
							value = Util.null2String(rs.getString(1));
						}
					}
				}
			}
		}
		
		if("".equals(value)){
			value = fieldvalue;
		}
		
		return value;
	}
}